var init = 
{"images":{"d60e23":"themes/default/img/dummy.gif","d60e27":"themes/default/img/mail/image_blocked.gif","mail.detail.pop.detail.flag":"themes/default/img/menu/tag_0.gif","mail.detail.pop.detail.mailflag":"themes/default/img/dummy.gif","mail.detail.pop.detail.header.prority":"themes/default/img/dummy.gif","alert_window-h-i":"themes/default/img/x.png","create_window-h-i":"themes/default/img/x.png","conflict_window-h-i":"themes/default/img/x.png","window_categories-h-i":"themes/default/img/x.png","window_categories_new-h-i":"themes/default/img/x.png"},"hide":{"mail.detail.pop.detail.content":true},"movable":["alert_window-h","create_window-h","conflict_window-h","window_categories-h","window_categories_new-h"],"size":[{"id":"loading_data_complete","align":"stretch","children":[{"id":"all_of_menu","align":"top","size":"11em","resize":"static","children":[]},{"id":"window-header-decorator","align":"top","size":"14px","border":"0px 0px 1px 0px","children":[]},{"id":"d60e12","align":"stretch","children":[{"id":"mail.detail.imip.toolbar","align":"top","size":"26px","resize":"static","children":[]},{"id":"mail.detail.imip","align":"stretch","children":[]},{"id":"mail.detail.content","align":"stretch","children":[{"id":"d60e20","align":"top","border":"0px 0px 1px 0px","children":[]},{"id":"mail.detail.pop.detail.attachments","align":"bottom","size":"3.2em","border":"1px 0px 0px 0px","resize":"static","children":[]},{"id":"d60e57","align":"stretch","children":[{"id":"mail.detail.pop.detail.content","align":"stretch","children":[]}]}]}]}]},],"help":{},"min":{},"max":{},"split":{},"i18n":{"d60e17":"","d60e19":"","d60e24":"","d60e28":"","d60e30-button":"","d60e36":"","d60e40":"","d60e43":"","d60e46":"","d60e49":"","d60e53":"","alert_window-h-i":"alt,title","alert_window-h-c":"","d20e8":"","alert_window_cancel-button":"","alert_window_nocomment-button":"","alert_window_no-button":"","alert_window_yes-button":"","alert_window_ok-button":"","alert_window_appointment-button":"","alert_window_series-button":"","alert_window_edit-button":"","alert_window_continue-button":"","alert_window_save-button":"","create_window-h-i":"alt,title","create_window-h-c":"","create_window_cancel-button":"","create_window_nocomment-button":"","create_window_advanced-button":"","create_window_ok-button":"","conflict_window-h-i":"alt,title","conflict_window-h-c":"","d20e28":"","conflict_recurrence_msg":"","d20e42":"","d20e44":"","d20e46":"","d20e48":"","d20e53-button":"","conflict_window_ignore-button":"","window_categories-h-i":"alt,title","window_categories-h-c":"","d20e63":"","categories_sel_but_new-button":"","categories_sel_but_rename-button":"","categories_sel_but_delete-button":"","d20e69":"","d20e72-button":"","d20e73-button":"","window_categories_new-h-i":"alt,title","window_categories_new-h-c":"","d20e79":"","d20e82":"","categories_new_but_cancel-button":"","categories_new_but_ok-button":""}};
/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 *
 */

function Accordion (maxheight, width, hover) {
	this.hover = hover;
	this.speed = 12;
	this.intervalcounts = 0;
	this.interval = 10;
	this.actualcontent = 0;
	this.components = new Object();
	this.maxheight = maxheight;
	this.width = "100%";
	if (width) {
	    this.width = width + "px";
	};
	this.container = newnode("div", { width: this.width }, 0);
}

Accordion.prototype.addComponent = function (title, node, maximumheight) {
	if (this.components[title]) {
		this.container.removeChild(this.components[title].content);
	}
	this.components[title] = { title: title, content: node, maximumheight: maximumheight };
	node.style.height = "0px";
	var height = Accordion.getHeight(node, this, maximumheight);
	this.components[title].maxheight = height;
	this.container.appendChild(node);
	this.checkHeight();
};

Accordion.prototype.checkComponentHeight = function(title) {
	if (this.components[title]) {
		this.components[title].maxheight = Accordion.getHeight(this.components[title].content, this, this.components[title].maximumheight);
		this.checkHeight();
	}
};

Accordion.prototype.removeComponent=function(title) {
	if (this.components[title]) {
		try {
			this.container.removeChild(this.components[title].content);
		} catch(e) { }
		delete this.components[title];
	}
};

Accordion.prototype.clear = function () {
	this.components = new Object();
	this.getDomNode();
};

Accordion.prototype.inTree = function () {
    try {
    	var node = this.container;
    	while (node) {
    		if (node == $("body")) { 
    		    return true;
    		}
    		node = node.parentNode;
    	}
    } catch (e) {
        return false;
    } finally {
        node = null;
    }
};

Accordion.prototype.setHover = function (hover) {
	this.hover = hover;
};

Accordion.prototype.checkHeight = function () {
	if (this.intervalcounts==0) {
		if (this.maxheight && this.maxheight < this.container.offsetHeight) {
			this.container.style.height=this.maxheight+"px";
			this.container.style.overflowX="hidden";
			this.container.style.overflowY="auto";
		} else {
			this.container.style.height="";
		}
		
		if (!this.hover) {
			if (OXAppointmentHover.actualHover) {
				OXAppointmentHover.actualHover.sizeChanged();
			}
		} else {
			this.hover.sizeChanged();
		}
	}
};

Accordion.prototype.getDomNode = function () {
    try {
    	removeChildNodes(this.container);
    	var tmpintree = this.inTree();
    	if (!tmpintree) {
    	    $("body").appendChild(this.container); 
    	}
    	for (var i in this.components) {
    		var tmp = this.components[i];
    		this.container.appendChild(tmp.content);
    		this.components[i].maxheight=Accordion.getHeight(tmp.content, this);
    		this.components[i].content.style.height = "0px";
    		tmp = null;
    	}
    	if (!tmpintree) {
    	    $("body").removeChild(this.container);
    	}
    	return this.container;
    } catch (e) {
        // ignore
    } finally {
        tmpintree = null;
    }
};

Accordion.prototype.showExtraContent = function (number) {
	var tmpcontents=(""+this.actualcontent).split(",");
	tmpcontents.push(number);
	this.showContent(tmpcontents.join(","));
};

Accordion.prototype.hideExtraContent = function (number) {
	var tmpcontents = (String(this.actualcontent)).split(",");
	for (var i=0; i < tmpcontents.length; i++) {
		if (tmpcontents[i] == number) {
			tmpcontents.splice(i,1);
			break;
		}
	}
	this.showContent(tmpcontents.join(","));
};

Accordion.prototype.showContent = function (number) {
	var Self = this;
	
	var newnumbers=(""+number).split(",");
	var oldnumbers=(""+Self.actualcontent).split(",");
	var oldobject=new Object();
	var newobject=new Object();
	for(var i=0;i<oldnumbers.length;i++) {
		oldobject[oldnumbers[i]]=true;
	}
	for(var i=0;i<newnumbers.length;i++) {
		newobject[newnumbers[i]]=true;
	}
	this.container.style.height="";
	this.container.style.overflow="";
	
	for (var i2 in Self.components) {
		if (!oldobject[i2]) {
			if(!newobject[i2]) {
				Self.components[i2].content.style.height="0px";
			} else {
				Self.setDisplay(Self.components[i2],true);
			}
		} else {
			if (!newobject[i2]) {
				Self.setDisplay(Self.components[i2],false);
			} else {
				if (Self.components[i2].content.style.height == "0px") {
					Self.setDisplay(Self.components[i2],true);
				}
			} 
		}
	} 
	Self.checkHeight();
	var newnumbers = new Array();
	for (var i in newobject) {
		newnumbers.push(i);
	}
	Self.actualcontent = newnumbers;
};

Accordion.prototype.setDisplay = function (containerobject, direction) {
	var Self = this;
	var fade = configGetKey("gui.effects.fading");
	if (direction) {
		containerobject.content.style.height = "0px";
		containerobject.content.style.display = "block";
		if (!containerobject.maxheight) {
		    containerobject.tmpheight = 0;
		} else { 
		    containerobject.tmpheight = containerobject.maxheight;
		}
		if (containerobject.interval) {
		    containerobject.interval();
		}
		Self.intervalcounts++;
		function final_cb1 () {
			if (fade) {
				containerobject.content.style.opacity = "";
				containerobject.content.style.filter = "";	// IE
			}
			if (containerobject.maximumheight && containerobject.content.offsetHeight >= containerobject.maximumheight) {
				containerobject.content.style.height = containerobject.maximumheight + "px";
			} else {
				containerobject.content.style.height = "";
			}
			containerobject.interval = null;
			Self.intervalcounts--;
			if (fade) {
				Self.checkHeight();
			}
		}
		
		if (configGetKey("gui.effects.global")) {
			containerobject.interval = animate(500, 100,
			function (curr) {
				var tmpheight = containerobject.maxheight || 0 ;
				var nextheight = Math.round(tmpheight * (curr / 100));
				if (containerobject.maximumheight && nextheight > containerobject.maximumheight) {
					nextheight = containerobject.maximumheight;
				}
				if (fade) {
					containerobject.content.style.opacity = (curr/100);
					containerobject.content.style.filter = "alpha(style=0,opacity:" +(curr)+ ")"; // IE 
				}
				containerobject.content.style.height = nextheight + "px";
			}, final_cb1);
		} else {
			if (containerobject.maximumheight && containerobject.maxheight > containerobject.maximumheight) {
				containerobject.content.style.height = containerobject.maximumheight + "px";
			}
			final_cb1();
		}
	} else {
		if (containerobject.interval) {
		    containerobject.interval();
		}
		Self.intervalcounts++;
		function final_cb2() {
			if (fade) {
				containerobject.content.style.opacity = 0;
				containerobject.content.style.filter = "alpha(style=0,opacity:" +(0)+ ")";	// IE
			}
			containerobject.content.style.height = "0px";
			containerobject.interval = null;
			Self.intervalcounts--;
			if (fade) {
				Self.checkHeight();
			}
		}
		if (configGetKey("gui.effects.global")) {
			containerobject.interval = animate(500, 100,
			function (curr) {
				var tmpheight = containerobject.maxheight || 0;
				var nextheight = Math.round(tmpheight* ((100-curr)/100));
				if (containerobject.maximumheight && containerobject.maximumheight <= nextheight) {
				    nextheight=containerobject.maximumheight;
				}
				if (fade) {
					containerobject.content.style.opacity = (curr/100);
					containerobject.content.style.filter = "alpha(style=0,opacity:" +(curr)+ ")";	// IE
				} 
				containerobject.content.style.height = nextheight+"px";
			}, final_cb2);
		} else {
			if (containerobject.maximumheight && containerobject.maxheight > containerobject.maximumheight) {
				containerobject.content.style.height = containerobject.maximumheight + "px";
			}
			final_cb2();
		}
	}
};

Accordion.getHeight = function (node, accordion, maximumheight) {
    try {
    	var tmpnode = node.cloneNode(true);
    	tmpnode.style.height = "";
    	tmpnode.style.zIndex = -1;
    	body.appendChild(tmpnode);
    	var value = tmpnode.offsetHeight;
    	if (maximumheight && value > maximumheight) {
    		node.style.overflow = "auto";
    	} else {
    		node.style.overflow = "hidden";
    	}
    	body.removeChild(tmpnode);
    	return value;
    } catch (e) {
        // ignore
    } finally {
        tmpnode = null;
    }
};

function createHoverContent (innerwidth, headerheight, borderheight, imgsizes, tabnummer) {
	var mywidth = 412;
	var innerwidthtop = 392;
	var innerwidthbottom = 392;
	if (!innerwidth) {
	    innerwidth = 400;
	}
	if (!imgsizes) { 
	    imgsizes= { t: 9 , tl: 10 , tr: 10 , r: 6, l: 6 , b: 15, bl: 10, br: 10 };
	};
	if(!headerheight) { headerheight = 9 }
	if(!borderheight) { borderheight = 15 }
	var mywidthtop=innerwidth+imgsizes.tr+imgsizes.tl;
	var returnobj=new Object();
	var coreelement = newnode("div", { position: "absolute", width: "414px", zIndex: 100000, left: "300px", top: "100px", display:"none" }, 0, [
		newnode("div", { position:"relative", width: "0px", height: "0px", whiteSpace: "nowrap"}, 0, [
			newnode("div",{ position: "absolute", top: "0px", left: "0px", width: "0px", height: "0px" }, { className : "hover-header-t" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position:"absolute",top : "0px", left: "0px",width: "0px",height : "0px" }, { className : "hover-header-tr" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute",top: "0px", left: "0px", width: "0px", height: "0px" }, { className : "hover-header-tl" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute", left: "0px", top: "0px", width: "0px", height: "0px" }, { className : "hover-header-r" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute", left: "0px", top: "0px", width: "0px", height: "0px" }, { className : "hover-header-l" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute", left: "0px", top: "0px", width:"0px" , height: "0px" }, { className : "hover-header-color" }, [
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			])
		]),
		newnode("div", { position: "relative", overflow: "hidden", width: "414px" }, 0, [
			newnode("div", { marginLeft: (imgsizes.l +2) + "px"  , width: (innerwidth) + "px", overflow: "hidden", zIndex: "1" }, { className: "hover_background" }, [
                newnode("div", { height: "100%", width: "100%", overflow: "hidden" })
            ]),
			newnode("div",{ position: "absolute", left: "408px", top: "23px", height: "1000px", width: "8px" }, { className: "hover-body-r" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div", { position: "absolute", left: "0px", top: "23px", height: "1000px", width: "8px" }, { className: "hover-body-l" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div", { position: "absolute", top: "0px", left: "0px", width: (imgsizes.tl+"px"), height: "23px" }, { className : "hover_master_background hover-header-tab-tl_ac", id: tabnummer+"hover-tabbin-corner-l" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position:"absolute",top : "0px",left: "406px",width: "10px",height : "23px"},{ className : "hover_master_background hover-header-tab-tr", id : tabnummer+"hover-tabbin-corner-r" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			])
		]),
		newnode("div",{ position: "relative", width: mywidth+"px", height: borderheight + "px" }, 0, [
			newnode("div",{ position: "absolute",left : "406px", top:borderheight-imgsizes.b+"px", width: (imgsizes.br+"px"), height: (imgsizes.b +"px") }, { className : "hover_master_background hover-bottom-br" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute",left : "0px", top: borderheight-imgsizes.b+"px", width: (imgsizes.bl+"px"), height: (imgsizes.b +"px") }, { className : "hover_master_background hover-bottom-bl" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute",left : "0px", top:"0px" , width: (imgsizes.bl+"px"), height: ((borderheight-imgsizes.b)+"px") }, { className : "hover-bottom-l" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute",left : (innerwidthbottom+imgsizes.bl)+"px", top:"0px", width: (imgsizes.br+"px"), height: ((borderheight-imgsizes.b)+"px") },{ className : "hover-bottom-r" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute", left: imgsizes.bl+ "px", top: (borderheight-imgsizes.b)+"px", width: "396px" , height: (imgsizes.b)+"px" }, { className : "hover-bottom-b" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			]),
			newnode("div",{ position: "absolute", left: imgsizes.bl+ "px", top: "0px" , width:(innerwidthbottom)+"px", height: (borderheight-imgsizes.b)+"px" }, { className : "hover-bottom-color" },[
				newnode("img", 0, { src: getFullImgSrc("img/dummy.gif") })
			])
		])
	]);
 
	returnobj.node = coreelement;
	returnobj.header = coreelement.getElementsByTagName("div")[6];
	returnobj.body = coreelement.getElementsByTagName("div")[9];
	returnobj.bottom = coreelement.getElementsByTagName("div")[18];
	return returnobj;
}

/* ########################################## TABS ####################################################### */

/**
 * tab container
 * @param id {String} the id of the hover which the tab container is attached to (deprecated)
 */
function Tabbing(id) {
	// @TODO: the id is just a workaround for the 'broken by design' hover layout
	// and needs to be reviewed!
	this.id = id;
	this.tabs = new Array();
	this.selected; 
}

Tabbing.prototype = {
		
	/**
	 * returns the DOMNode containing all tabs
	 * @returns {DOMNode} the DOMNode containing all tabs
	 */
	getDOMNode: function() {
	    try {
    		var trnode = newnode("tr");
    		for (var i in this.tabs) {
    			var tdnode = this.tabs[i].getDOMNode();
    			trnode.appendChild(tdnode);
    			tnode = null;
    		}
    		trnode.appendChild(
    				newnode("td", { width : "100%" }, 
    					{ className : "tabbing_border_style" },
    					[ document.createTextNode("\u00a0")] )
    				);
    		
    		return trnode;
	    } catch (e) {
	        // ignore
	    } finally {
	        trnode = null;
	    }
	},

	/**
	 * adds a new tab with the given id
	 * @param tab {Tab} the tab
	 */
	addTab : function(tab) {
	     var self = this;
		 if (this.tabs.length == 0) {
			tab.select(true);
			this.selected = 0;
		 }
		 this.tabs.push(tab);
		 var clickHandler = function(event) {
		     self.selectTabById(event.data.id);
		 };
		 jQuery(tab.getDOMNode())
		 .click({ id: tab.id }, clickHandler);
	},
	
	/**
	 * removes a tab with the given id
	 * @param id {String} the id of the tab
	 */
	removeTab : function(id) {
		for (var i in this.tabs) {
			if (this.tabs[i].id == id) {
				this.tabs.splice(i,i);
			}
		}
	},
	
	selectTabById : function(id) {
		var pos = 0;
		// iterate through tabs and select / deselect them
		for (var i in this.tabs) {
			if (id == this.tabs[i].id) {
				this.selected = pos = i;
			}
			this.tabs[i].select(id == this.tabs[i].id);
		}
		
		// do we have to trigger a callback?
		if (this.tabs[this.selected].onShow) {
			this.tabs[this.selected].onShow();
		}
		
		// ugly hack to fix the 'broken by design' hover layout
		// hover layout needs to be reviewed (again) :-|
		if (this.selected == 0) {
			// change bg image on left corner of hover if first tab is selected
			$ALL(this.id + "hover-tabbin-corner-l").className = "hover_master_background hover-header-tab-tl_ac";
		} else {
			// change bg image on left corner of hover if first tab is selected
			$ALL(this.id + "hover-tabbin-corner-l").className = "hover_master_background hover-header-tab-tl";
			// change the bg image of the td on the left of the selected td
			this.tabs[this.selected-1].getDOMNode().className="hover_master_background tabbing_tab_inactive_left";
		}
	},
	
	/**
	 * returns the requested {Tab} tab
	 * @param id {String} the id of the tab
	 * @returns {Tab} the tab object, otherwise null
	 */
	getTabById : function(id) {
		for (var i in this.tabs) {
			if (this.tabs[i].id == id) {
				return this.tabs[i];
			}
		}	
		return null;
	}
	
};

/**
* a single tab
* @param id {String} the id of the tab
* @param title {String} the tab title
* @param onShow {function} a function called when entering the tab
*/
function Tab(id, title, onShow) {
	this.id = id;
	this.title = title;
	this.onShow = onShow;
	this.enabled = true;
	this.node = newnode("td", 0, 
			{ className : "clickable hover_master_background tabbing_tab_inactive" }, 
			[ addTranslated(title) ]);
}

Tab.prototype = {
	/**
	 * show / hide the tab
	 * @param {boolean} enabled - true shows the tab, otherwise false
	 */
	show : function(enabled) {
		this.enabled = enabled;
		this.node.style.display = this.enabled ? "" : "none";
	},
	
	/**
	 * selects / highlights the tab
	 * @param {boolean} selected - true select the tab, otherwise false
	 */
	select : function(selected) {
		this.node.className = selected ? "hover_master_background tabbing_tab_active" : "hover_master_background tabbing_tab_inactive";
	},
	
	setTitle : function(title) {
		this.node.firstChild.nodeValue = title;
	},
	
	/**
	 * returns the DOM node of the tab
	 * returns {DOMNode} the dom node of the tab
	 */
	getDOMNode : function() {
		return this.node;
	}
}
/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 *
 */

var corewindow=window;
function configGetKey(key) {
	var splitkey = typeof key == "string" ? key.split(".") : key;
	if (!window.config) {
		return null;
	}
	var tmp=ox.api.config.get();//(corewindow) ? corewindow.config : config;
	for ( var i = 0; i < splitkey.length; i++) {
		if (tmp[splitkey[i]] != undefined) {
			tmp = tmp[splitkey[i]];
		} else {
			return null;
		}
	}
	return clone(tmp);
}

function configSetKey(key,value) {
	if(!corewindow.config) {
		corewindow.config={};
	}
	var tmp=ox.api.config.get();//(corewindow) ? corewindow.config : config;
	var splitkey = typeof key == "string" ? key.split(".") : key;
	for ( var i = 0; i < splitkey.length - 1; i++) {
		if (tmp[splitkey[i]]) {
			tmp = tmp[splitkey[i]];
			if (typeof (tmp) != "object") {
				alert("" + tmp + " parentNode is a value");
				return;
			}
		} else {
			tmp[splitkey[i]] = {};
			tmp = tmp[splitkey[i]];
		}
	}
	tmp[splitkey[splitkey.length-1]]=clone(value);
	configuration_changed_outside=true;
	triggerEvent("OX_Configuration_Parameter_Changed",key,value);
}

function configContainsKey(key) {
	var splitkey = typeof key == "string" ? key.split(".") : key;
	if (!config) {
		return false;
	}
	var tmp=ox.api.config.get();//(corewindow) ? corewindow.config : config;
	for ( var i = 0; i < splitkey.length; i++) {
		if (tmp[splitkey[i]] != undefined) {
			tmp = tmp[splitkey[i]];
		} else {
			return false;
		}
	}
	return true;
}

function configRemoveKey(key) {
    // get full config (not a clone is this case)
    var tmp = ox.api.config.get();
    // key split key (key might already be an array)
    var splitkey = typeof key == "string" ? key.split(".") : key;
    // iterate over config to find the node
    for ( var i = 0; i < splitkey.length - 1; i++) {
        if (tmp[splitkey[i]]) {
            tmp = tmp[splitkey[i]];
            if (typeof (tmp) != "object") {
                alert("" + tmp + " parentNode is a value");
                return;
            }
        } else {
            tmp[splitkey[i]] = {};
            tmp = tmp[splitkey[i]];
        }
    }
    // now, we have the right node, so...
    delete tmp[splitkey[splitkey.length-1]];
    // done
    configuration_changed_outside = true;
    triggerEvent("OX_Configuration_Parameter_Changed", key, undefined);
}
/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 *
 */

// get reference to core window
var corewindow = window;
if (window.opener) {
    corewindow = window.opener.corewindow;
} else if (window.parent) {
    corewindow = window.parent.corewindow;
}

oxThemeStyle = corewindow.oxThemeStyle;

corewindow.register("LanguageChanged", function () {
    setLanguage(corewindow.configGetKey("language"));
    if (setWindowTitle) {
        setWindowTitle();
    }
});

register("Loaded",function() {
    var newPath = corewindow.oxThemeStyle.path || "default";
    for (var i in init.images) {
        init.images[i] = init.images[i].replace(/\/default\//g, "/"+newPath+"/");
    }
	appendNode("everything");
});
function addHideTreeNode(node,parent,index) { }
function appendNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display=="none" || node.style.display=="NONE")) {
		if(node.tagName == "DIV") { node.style.display = "block"; }
		else { node.style.display = ""; }
	}
}
function removeNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display!="none" || node.style.display!="NONE")) {
		node.style.display = "none";
	}	
}
function refillImages(id) {
    if($ALL(id)) {
        var elements=$ALL(id).getElementsByTagName("img");
        for(var i=0;i<elements.length;i++) {
            var src = init.images[elements[i].id];
            if(src && src != elements[i].src) elements[i].src = src;
        }
    }
}
function showNode(id,changedisplay) {
	appendNode(id,changedisplay);
	refillImages(id);
}

function hideNode(id,changedisplay) {
	removeNode(id,changedisplay);
}
function autorefill() {
	refillImages("body");
}
register("Loaded",autorefill);

var fileloaded=function() {};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

register("OX_Configuration_Loaded", function() {
	var configerrors=false;
	try {
		if (typeof(config.gui) == "string") {
			config.gui = eval("(" + config.gui + ")");
		}
	} catch (e) {
		delete(config.gui);
		//#. %s is the error message.
		//#, c-format
		alert(format(_("Syntax error in config: \n%s"), e.message));
	}
	if (!configContainsKey("identifier") || !configContainsKey("contact_id")) {
		 configerrors=true;
		 alert(_("Configuration damaged, please inform the administrator."));
	} 
	if (!configContainsKey("language")) {
			configSetKey("language","de_DE");
	}
	if (!configContainsKey("timezone")) {
		configSetKey("timezone","Europe/Berlin");
	}
	if (!configContainsKey("folder"))  {
		configSetKey("folder",{});	
	}	
 	if (!configContainsKey("modules.tasks.notifyNewModifiedDeleted")) {
		configSetKey("modules.tasks.notifyNewModifiedDeleted",false);
    }
    if (!configContainsKey("modules.tasks.notifyAcceptedDeclinedAsParticipant")) {
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsParticipant",true);
    	configuration_changed_fields["module"]=true;
    }
	if(!configContainsKey("mail.deletemail")) {
		configSetKey("mail.deletemail",false);	
	}	
	if(!configContainsKey("gui.menu.menuiteration")) {
		configSetKey("gui.menu.menuiteration",2);
	}
	if(!configContainsKey("gui.mail.notifyacknoledge")) {
		configSetKey("gui.mail.notifyacknoledge",true);
	}
	if(!configContainsKey("gui.mail.select_first_message")) {
        configSetKey("gui.mail.select_first_message",true);
    }
	if(!configContainsKey("mail.appendmailtext")) {
		configSetKey("mail.appendmailtext",true);
	}
	if(!configContainsKey("gui.mail.htmlmessage")) {
		configSetKey("gui.mail.htmlmessage",true);
	}
	if(!configContainsKey("mail.vcard")) {
		configSetKey("mail.vcard",false);
	}
	if(!configContainsKey("gui.mail.editor_featureset")) {
		configSetKey("gui.mail.editor_featureset", 2);
		configSetKey("mail.inlineattachments",true);
		configSetKey("mail.emoticons",true);
		configSetKey("mail.colorquoted",true);
		configuration_changed_fields["mail"]=true;
		configuration_changed_fields["gui"]=true;
	}
	if (!configContainsKey("gui.mail.showname")) {
	    configSetKey("gui.mail.showname", false);
	}
	if(!configContainsKey("gui.mail.formatmessage")) {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE");
	} else if(configGetKey("gui.mail.formatmessage") == "text") {
		configSetKey("gui.mail.formatmessage","ALTERNATIVE");
	}
	if(!configContainsKey("gui.mail.autocomplete")) {
		configSetKey("gui.mail.autocomplete",true)
	}
	if(!configContainsKey("mail.forwardmessage")) {
		configSetKey("mail.forwardmessage","Inline");
	}
	if(!configContainsKey("mail.linewrap")) {
		configSetKey("mail.linewrap",70)
	}
	if(!configContainsKey("gui.calendar.interval")) {
		configSetKey("gui.calendar.interval",30);
	}
	if(!configContainsKey("gui.calendar.starttime")) {
		configSetKey("gui.calendar.starttime",8);
	}
	if(!configContainsKey("gui.calendar.endtime")) {
		configSetKey("gui.calendar.endtime",18);
	}
	if(!configContainsKey("gui.calendar.default_reminder")) {
		configSetKey("gui.calendar.default_reminder",15);
	}
	if(!configContainsKey("gui.calendar.teamview.workingTimeOnly")) {
        configSetKey("gui.calendar.teamview.workingTimeOnly", true);
    }
	
    if (!configContainsKey("gui.calendar.views")) {
        if (configContainsKey("gui.calendar.view")) {
            var view = configGetKey("gui.calendar.view");
            if (!view || typeof view != "object") {
                var match = /^calendar\/([^\/]+)\/([^\/]+)$/.exec(view)
                    || [, "calendar", "day"];
                view = { view: match[1], calendar: match[2], team: match[2],
                         list: match[2], shared: true };
            }
            if(!(   configGetKey("modules.calendar.calendar_freebusy")
                && configGetKey("modules.calendar.calendar_teamview")))
            {
                if (view.view == "team") view.view = "calendar";
            }
        } else {
            var view = { view: "calendar", calendar: "workweek", team: "workweek",
                         list: "workweek", shared: true };
        }
        configSetKey("gui.calendar.views", view);
        configSetKey("gui.calendar.view", getDefaultCalendarView());
    }
	if (!configContainsKey("gui.calendar.allfolders")) {
		configSetKey("gui.calendar.allfolders",true);
		configSetKey("modules.calendar.notifyAcceptedDeclinedAsCreator",true);
    	configSetKey("modules.tasks.notifyAcceptedDeclinedAsCreator",true);
    	configuration_changed_fields["modules"]=true;
	}
	if(!configContainsKey("gui.calendar.day.numberofappointments")) {
		configSetKey("gui.calendar.day.numberofappointments",4);
	}
	if(!configContainsKey("gui.calendar.workweek.numberofappointments")) {
		configSetKey("gui.calendar.workweek.numberofappointments",2);
	}
	if(!configContainsKey("gui.calendar.workweek.startday")) {
		configSetKey("gui.calendar.workweek.startday",1);
	}
	if(!configContainsKey("gui.calendar.workweek.countdays")) {
		configSetKey("gui.calendar.workweek.countdays",5);
	}
	if(!configContainsKey("gui.calendar.custom.countdays")) {
		configSetKey("gui.calendar.custom.countdays",3);
	}
	if(!configContainsKey("gui.calendar.custom.numberofappointments")) {
		configSetKey("gui.calendar.custom.numberofappointments",3);
	}
	if (!configContainsKey("modules.calendar.notifyNewModifiedDeleted")) {
        configSetKey("modules.calendar.notifyNewModifiedDeleted",false);
    } 
    if (!configContainsKey("modules.calendar.notifyAcceptedDeclinedAsParticipant")) {
        configSetKey("modules.calendar.notifyAcceptedDeclinedAsParticipant",true);
        configuration_changed_fields["modules"]=true;
    }
	if(!configContainsKey("gui.contacts.view")) {
		configSetKey("gui.contacts.view","contacts/cards");
	}
	if(!configContainsKey("gui.infostore.view")) {
		configSetKey("gui.infostore.view","infostore/split");
	}
	if(!configContainsKey("gui.mail.view")) {
		configSetKey("gui.mail.view","mail/hsplit/unthreaded");
	}
	if(!configContainsKey("gui.mail.signatures")) {
		configSetKey("gui.mail.signatures",new Array());
	}
	if(!configContainsKey("reloadtimes")) {
		configSetKey("reloadtimes",[0]);		
	}
	if(!configContainsKey("gui.global.autorefresh")) {
		configSetKey("gui.global.autorefresh",10);
	} else {
		var isvalid=false;
		var myrel=configGetKey("reloadtimes");		
		for(var i=0;i<myrel.length;i++) {
			if(configGetKey("gui.global.autorefresh")*60000==myrel[i]) {
				isvalid=true;
				break;
			}
		}
		if(!isvalid) {
			configSetKey("gui.global.autorefresh",0);
		}
	}
	if(!configContainsKey("gui.effects.hover.portal")) {
		configSetKey("gui.effects.hover.portal",true);
	}
	if(!configContainsKey("gui.effects.hover.mail")) {
		configSetKey("gui.effects.hover.mail",false);
	}
	if(!configContainsKey("gui.effects.hover.calendar")) {
		configSetKey("gui.effects.hover.calendar",true);
	}
	if(!configContainsKey("gui.effects.hover.contacts")) {
		configSetKey("gui.effects.hover.contacts",true);
	}
	if(!configContainsKey("gui.effects.hover.tasks")) {
		configSetKey("gui.effects.hover.tasks",true);
	}
	if(!configContainsKey("gui.effects.hover.infostore")) {
		configSetKey("gui.effects.hover.infostore",true);
	}
	if(!configContainsKey("gui.effects.hover.speed")) {
		configSetKey("gui.effects.hover.speed",3);
	}
	if(!configContainsKey("gui.effects.global")) {
		configSetKey("gui.effects.global",false);
		configSetKey("gui.effects.fading",false);
	}
	if (!configContainsKey("gui.categories.local")) {
		configSetKey("gui.categories.local", []);
		ox.categories.utils.migrateTags();
	}
//	if (!configContainsKey("gui.FolderTreeState")) {
//		configSetKey("gui.FolderTreeState",new Object);
//	}			
	if (!configContainsKey("gui.contacts.gridsort") || !isNaN(configGetKey("gui.contacts.gridsort")))   {
		configSetKey("gui.contacts.gridsort","last_name");
	}
	if (!configContainsKey("gui.contacts.gridorder")) {
		configSetKey("gui.contacts.gridsort","asc");
	}			
	if (!configContainsKey("gui.contacts.cardsToViewPerColumn")) {
		configSetKey("gui.contacts.cardsToViewPerColumn","auto");
	}
	if (!configContainsKey("gui.tasks.view")) {
		configSetKey("gui.tasks.view","tasks/split");
	}
	if(!configContainsKey("gui.tasks.gridsort")) {
		configSetKey("gui.tasks.gridsort","200");
	}
	if(!configContainsKey("gui.tasks.gridorder")) {
		configSetKey("gui.tasks.gridsort","asc");
	}
	if(!configContainsKey("gui.tasks.interval")) {
		configSetKey("gui.tasks.interval",30);
	}
	if(!configContainsKey("gui.global.save")) {
		configSetKey("gui.global.save",1);
	}
	if(!configContainsKey("gui.global.confirmpopup")) {
		configSetKey("gui.global.confirmpopup",true);
	} else {
		var id=configGetKey("gui.global.save");
		if(id != 0 && id != 1 && id != 2) {
			configSetKey("gui.global.save",2);
		}
	}
	if(!configContainsKey("gui.portal.internalcontents")) {
		configSetKey("gui.portal.internalcontents",new Array());
	}
	if(!configContainsKey("gui.portal.externalcontents")) {
		configSetKey("gui.portal.externalcontents",new Array());
	}
	
	// expert mode
    if (!configContainsKey("ui.global.expert.mode")) {
        configSetKey("ui.global.expert.mode", { value: false, configurable: true });
    }
    
	// embedded windows
	if (!configContainsKey("ui.global.windows.mode")) {
        configSetKey("ui.global.windows.mode", { value: "embedded", configurable: true });
    }
	
	// toolbar
    if (!configContainsKey("ui.global.toolbar.mode")) {
        configSetKey("ui.global.toolbar.mode", { value: "tabbased", configurable: true });
    }
    
    // show contact image
    if (!configContainsKey("ui.mail.showContactImage")) {
        configSetKey("ui.mail.showContactImage", { value: true, configurable: true });
    }
    
    // overwrite backend setting as this is no longer required
    configSetKey("participants.showDialog", true);
	
    if (configuration_changed_outside === true) {
        setTimeout(function() {
            triggerEvent("OX_Save_Configuration",false,true);
            configuration_changed_outside = false;
        }, 5000);
    }
    
	triggerEvent("OX_Configuration_Set_Empty");
});

registerModule("configuration", _("Configuration"), 100);

// Configuration changed?
function configuration_changed() {
	for (var id in configuration_changed_fields) {
		if (configuration_changed_fields[id] === true) {
			return true;
		}
	}
	return false;
}

var configuration_changed_fields=new Object();
var configuration_changed_outside=false;
configuration_changed_fields["timezone"]=false;
configuration_changed_fields["language"]=false;
configuration_changed_fields["gui"]=false;
configuration_changed_fields["mail"]=false;
configuration_changed_fields["folder"]=false;
configuration_changed_fields["calendarnotification"]=false;
configuration_changed_fields["tasknotification"]=false;
configuration_changed_fields["modules"]=false;

var lastViewed = "";
var changed = new Array();
var changed_inv = false;
var foldersChanged = 0;
var j = 0;
var configVisited = false;
var configToolbars = {};

(function() {
	register("Loaded", function() {});
})();

//because already defined in configtree.js
/*
registerView("configuration",
	function (){},
	function() { 
	},
	function() {		
	},
	function() {
	},
	null
);*/
register("OX_Configuration_GUI_Changed",function () {
	configuration_changed_fields["gui"]=true;
});

/**
 * Asks the user to save changes before leaving a configuration page.
 * If the changes need to be saved, the event OX_SAVE_OBJECT is triggered.
 * If the changes should be discarded, the event OX_Cancel_Object is triggered.
 * @param {Function} callback An optional callback which is called if the page
 * change is not cancelled.
 */
function configuration_askforSave(callback) {
    if(configuration_changed()) {
        newConfirm(_("Configuration changed"),
            _("Do you want to save your configuration?"),
            AlertPopup.YESNO, null, null,
            function() {
                triggerEvent("OX_SAVE_OBJECT");
                if (callback) callback();
            },
            function() {
                triggerEvent("OX_Cancel_Object");
                if (callback) callback();
            });     
    } else {
        if(callback) callback();
    }
}

register("OX_Save_Configuration",configuration_saveObject);
function configuration_saveObject(force,hidemessage,myok,myerror,optParam) {
    var showmessage=true;
    var openrequests=0;
    var iserror=false;
    var errormessage="";
    
    function successcb(r) {
        openrequests--;
        if(openrequests==0) {
            afterRequest();
        }
    }
    if(!myok) {
        myok=successcb;
    }
    
    function errorcb(result,status) {
        openrequests--;
        iserror=true;
        if(status != 200) {
            errormessage=_("The configuration could not be saved, because of the following error:") +
                //#. HTTP Errors from the server
                //#. %1$s is the numeric HTTP status code
                //#. %2$s is the corresponding HTTP status text
                //#, c-format
                format(_("Error: %1$s - %2$s"), status, result);
        }
        if (openrequests==0) {
            afterRequest();
        }
    }
	if(!myerror) {
		myerror=errorcb;
	}

	function afterRequest() {
		if (iserror) {
			if(!hidemessage) triggerEvent("OX_New_Error",errormessage);
		} else {
			if(!hidemessage) {
				triggerEvent("OX_New_Info",4,_("Your settings have been saved"));
			}
			if (!force) {
				if(activemodule=="configuration") {
					triggerEvent("OX_Configuration_Changed",currentpath2.join("/"));
				} else {
					triggerEvent("OX_Configuration_Changed","");
				}
			}
		}
		// make sure all config fields are marked as "not changed"
		for (var id in configuration_changed_fields) {
		    configuration_changed_fields[id] = false;
		}
	}
	
    var ro_ConfigSettings = [
        "addresses", "availableModules", "availableTimeZones", "contact_id",
        "context_id", "currentTime", "defaultaddress", "folder",
        "global_categories", "identifier", "maxUploadIdleTimeout",
        "mail.addresses", "mail.defaultaddress", "mail.folder",
        "mail.spambutton", "modules", "participants.showDialog",
        "participants.showWithoutEmail", "reloadtimes", "serverVersion",
        "spambutton", "ui"
    ];
	
	function saveConfigtoServer(path,params,success1,error1) {
		showmessage=true;
		var reqstring= "config"; //AjaxRoot + "/config";
		var myparams;
		if (path && path != "") {
			reqstring=reqstring+"/"+path;
		}
		//reqstring=reqstring+"?session="+session;
		if (params && params != "") {
			myparams=configGetKey(params);
		} else {
			myparams=clone(config);
		}
        // going to remove read-only settings
		for (i in ro_ConfigSettings) {			
			var splitkey = ro_ConfigSettings[i].split(".");			
			var tmp = myparams;
			for (var ia=0; ia<splitkey.length-1; ia++) {
		        if (tmp[splitkey[ia]] != undefined) {
		            tmp=tmp[splitkey[ia]];
		        } else {
		            break;
		        }
		    }		       	            
            if (!splitkey || !splitkey.length) continue;
            delete tmp[splitkey[splitkey.length-1]];
		}
		// use http api (fixes IE9 logout bug)
		ox.api.http.PUT({
		    module: reqstring,
            appendColumns: false,
		    data: myparams,
		    success: success1,
		    error: error1
		});
		//myjson.put(reqstring, myparams, null, success1, error1);
	}
	if(force) {
		for (var i in configuration_changed_fields) {
			configuration_changed_fields[i] = false;
		}
		saveConfigtoServer("","",myok,myerror);
		configuration_changed_outside=false;
	}
    if (temporary.folderTabs.viewModified()) {
        temporary.folderTabs.saveView(configuration_changed_fields.folder ?
            emptyFunction :
            function() {
        		ox.api.folder.refresh({ folders: [temporary.folderTabs.folder.id] });
                /*
        		oMain-FolderTree.cache.updateFolders(
                    [temporary.folderTabs.folder.id],
                    function() {
                        oMain-FolderTree.load_view(
                            oMain-FolderTree.cache.folders.root,
                            oMain-FolderTree.tree, true, false);
                    
        			});*/
            });
        showmessage = false;
    }
	if(configuration_changed_fields["folder"] == true) {
		saveFolder(optParam);
		configuration_changed_fields["folder"]=false;
		showmessage=false;
	}
	if(configuration_changed_fields["mail"] == true) {
		saveConfigtoServer("mail","mail",myok,myerror);
		openrequests++;
		configuration_changed_fields["mail"] = false;
	}
	
	function timezoneChanged(data) {
	    if (data) {
	        configSetKey("currentTime", data.currentTime);
	        configSetKey("availableTimeZones", data.availableTimeZones);
	        // redraw timezone combo-box
            cs_drawTimezoneCombo(data.availableTimeZones);
            // update reminders
            if (jQuery.isFunction(updateReminders)) {
                updateReminders();
            }
	    }
	    triggerEvent("OX_SetTime");
	    triggerEvent("TimezoneChanged", configGetKey("timezone"));
	    myok();
	}
	
	if (configuration_changed_fields["timezone"] === true
	        || configuration_changed_fields["language"] === true) {
	    ox.api.http.PUT({
	        module: "config",
	        processData: false,
	        data: { 
	            "timezone": ox.api.config.get("timezone"),
                "language": ox.api.config.get("language")
	        },
	        success: function (data) {
	            ox.api.http.PUT({
	                module: "multiple",
	                appendColumns: false,
	                processData: false,
	                data: [
	                   { module: "config/currentTime", action: "GET" },
	                   { module: "config/availableTimeZones", action: "GET" }
                    ],
	                success: function (response) {
	                    // response not empty?
	                    if (!response && !response.length) {
	                        openrequests--;
	                        return;
	                    }
	                    data = { "currentTime": response[0].data, 
	                            "availableTimeZones": response[1].data
	                    };
	                    timezoneChanged(data);
                        //workaround for foldertree updates after language changes
                        ox.api.cache.folder0.clear();
                        ox.api.cache.folder1.clear();
                        ox.api.cache.folderFlat.clear();
                        ox.api.folder.dispatcher.trigger("modify");
	                    configuration_changed_fields["timezone"] = false;
	                    configuration_changed_fields["language"] = false;
	                    openrequests--;
	                }
	            });
	        },
	        error: myerror
	    });
	    openrequests++;
	}
	if(configuration_changed_fields["gui"] == true) {
		saveConfigtoServer("gui","gui",function(){
		    myok();
		    triggerEvent("OX_Calendar_Teamlist_Changed");}
		,myerror);
		
		openrequests++;
		configuration_changed_fields["gui"] = false;
	}
	if(configuration_changed_fields["ui"] == true) {
	    saveConfigtoServer("ui", "ui", myok, myerror);
        openrequests++;
        configuration_changed_fields["ui"] = false;
    }
	if (configuration_changed_fields["tasknotification"] == true) {		
        delete(config["tasknotification"]);
		// todo: each modules section should have an own area later!!
		configuration_changed_fields["modules"] = true;
		configuration_changed_fields["tasknotification"] = false;
	}
	if (configuration_changed_fields["calendarnotification"] == true) {
		delete(config["calendarnotification"]);
		// todo: each modules section should have an own area later!!
        configuration_changed_fields["modules"] = true;
		configuration_changed_fields["calendarnotification"] = false;
	}
	if(configuration_changed_fields["modules"] == true) {
		saveConfigtoServer("modules","modules",myok,myerror);
		openrequests++;
		configuration_changed_fields["modules"] = false;
	}
	if(openrequests==0 && showmessage) {
		afterRequest();
	}
}

function selectValue(rObj, setValue) {
	var fieldValue = new Array();
	var j;
	for (var i=0; i < rObj.length; i++) {
		if (rObj[i].value == setValue) {
			j = i;
			break;
		} else {
			j = 0;
		}
	}
	return j;
}

function cancelConfigGUI() {
	if (cloned != "") {
		config = new Object();
		config = copy(cloned);
	}
	changed = new Array();
}

function displaySignatureConfig(val) {
	 sig = document.getElementById("signaturetext");
	 sig.value = val;
}

var setConfigPath = function (domNode) {
    var node = ox.widgets.configTree.nodeIndex[currentpath2.join("/")];
    var path = node.name instanceof I18nString ? node.name : _(node.name);
    while (node.parentNode) {
        node = node.parentNode;
        path = _(node.name) + " / " + path;
    }
    domNode.firstChild.nodeValue = path;
};

var deleteFolderConfig = function () {
    // get folder
    ox.api.folder.get({
        folder: configfolder,
        success: function (data) {
            if (ox.api.folder.can("delete", data)) removeFolder(configfolder);
        }
    });
};

fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var printviews=new Object();
function registerPrintView(printview) {
	printviews[printview]=true;
}
function isPrintableView(printview) {
	return printview in printviews;
}

function Print(windowtitle) {
	this.printName = windowtitle;
	this.width="1024px";
	this.height="768px";
}
Print.createContent = function (key,value,isimage) {
	if(isimage) {
		return { title: key, name : value, type: "content", "isimage": isimage };
	} else {
		return { title: key, name : value, type: "content", "isimage": false };
	}
}
Print.createLine = function(myheight, isimage) {
	if(isimage) {
		return { type: "line", height: myheight, "isimage": isimage };
	} else {
		return { type: "line", height: myheight, "isimage": false };
	}
}
Print.createTitle = function(value,isimage) {
	if(isimage) {
		return { type: "title", title : value, "isimage": isimage };
	} else {
		return { type: "title", title : value, "isimage": false };		
	}
}
Print.createHeader = function(header,isimage) {
	if(isimage) {
		return { type: "header", title : header, "isimage": isimage };
	} else {
		return { type: "header", title : header, "isimage": false };
	}
}
Print.createEmpty = function(isimage) {
	if(isimage) {
		return { type: "empty" ,"isimage": isimage } ;
	} else {
		return { type: "empty" ,"isimage": false } ;
	}

}
Print.createPicture = function (srcpathofimage) {
	return { type: "image", src : srcpathofimage, "width" : "76px", "height" : "76px" }
}

Print.createPriority = function (prio, isimage) {
	if(isimage) {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": isimage }
	} else {
		return { type: "prio", src : getFullImgSrc("img/tasks/taskprio" + prio + ".gif"), "width" : "35px", "height" : "11px", "isimage": false }
	}
}
Print.createMail = function (mail,isimage) {
	if(isimage) {
		return { type: "mailtext", "mailtext" : mail, "isimage": isimage }
	} else {
		return { type: "mailtext", "mailtext" : mail, "isimage": false }
	}
}

Print.prototype = 
{
	setTitle : function (title) {
		this.printName=title;
	},
	
	printDetail: function (detailarray, closer) {
	    
	    var self = this;
	    
        // open native popup window
	    if (IE) {
	        this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",left=50,top=50,resizable=yes,scrollbars=yes,menubar=yes,toolbar=yes,status=yes");
	        self.printDetailCont(detailarray);
	    } else {
    	    ox.api.window.open("newInfoItemHidden.html", {
    	        options: {
    	            width: parseInt(self.width),
    	            height: parseInt(self.height),
    	            resizable: "yes",
    	            menubar: "yes",
    	            toolbar: "no",
    	            location: "no",
    	            status: "yes",
    	            scrollbars: "yes"
    	        },
    	        closer: closer !== undefined && closer !== jQuery.noop ? closer : function (opt) {
    	            ox.api.window.close(opt.guid);
    	        },
    	        success: function (win, guid) {
    	            self.printwindow = win;
    	            self.printDetailCont(detailarray);
    	         }
    	    });
	    }
	},
	
	printDetailCont: function (detailarray) {

        // write document
        var printdoc = this.printwindow.document;
		printdoc.open();
		printdoc.write("<html style=\"overflow:auto\"><head><title>" + this.printName + "</title>");
		printdoc.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"print.css\"/>");
		printdoc.write("</head><body style=\"width:95%; height:95%\">");
		printdoc.write("<table class=\"detailprint\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\">");

        function tryToPlugTheGapingSecurityHole(s) {
           return String(s).replace(/[<>"\n]/g, function(c) {
                return {
                    "<": "&lt;",
                    ">": "&gt;",
                    "\"": "&quot;",
                    "\n": "<br>"
                }[c];
            });
        }

		for(var i=0;i<detailarray.length;i++) {
			if(!detailarray[i]) { continue; }
			switch(detailarray[i].type) {
				case "content":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\" valign=\"top\" style=\"white-space: nowrap; "+(detailarray[i].title || "")+"\">"+detailarray[i].title+"</td><td class=\"printcontentname\">"+tryToPlugTheGapingSecurityHole(detailarray[i].name)+"</td>");
					break;
				case "title":
					printdoc.write("<tr><td class=\"printtitle\" colspan=\"2\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");
					break;
				case "line":
					printdoc.write("<tr><td class=\"printline\" colspan=\"2\" style=\"height:"+detailarray[i].height+";\"></td>");
					break;
				case "empty":
					printdoc.write("<tr><td colspan=\"2\">&nbsp;</td>");					
					break;
				case "prio":
					printdoc.write("<tr class=\"printcontent\"><td class=\"printcontenttitle\">" + _('Priority:') + "</td><td class=\"printcontentname\"><img src=\"" + detailarray[i].src + "\" style=\"width:" + detailarray[i].width + ";height:" + detailarray[i].height + "\"/></td>");
					break;
				case "header":
					printdoc.write("<tr><td colspan=\"2\" class=\"printheader\">"+tryToPlugTheGapingSecurityHole(detailarray[i].title)+"</td>");					
					break;
				case "mailtext":
					printdoc.write("</table><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\" style=\"width:100%\"><tr><td colspan=\"2\" class=\"printmailcontent\">");
					var iframe = newnode("iframe",{display: "none"});
					body.appendChild(iframe);
					iframe.contentWindow.document.open();
					iframe.contentWindow.document.write(detailarray[i].mailtext);
					iframe.contentWindow.document.close();
					var str = iframe.contentWindow.document.body.innerHTML;
					// clean up html
			        var div = jQuery("<div/>").html(str);
			        div.find("*").contents()
    		            .filter(function () {
    		                return this.nodeType === 3;
    		            })
    		            .each(function () {
    		                var t = this.nodeValue, l = t.length;
    		                if (l > 80) {
    		                    t = t.replace(/(\\S{80})/g, "$1\u200b");
    		                    this.nodeValue = t;
    		                }
    		            });
			        // write mail content
					printdoc.write(div.html());
					body.removeChild(iframe);
					div = str = iframe = null;
					printdoc.write("</td>");
					break;
				case "mailattachments":
				    printdoc.write("<tr><td colspan=\"2\" align=\"center\"><br>");
				    for (var ia=0; ia<detailarray[i].mailattachments.length; ia++) {				    	
				    	var attach = detailarray[i].mailattachments[ia];
                        printdoc.write("<table cellpadding=\"5\" cellspacing=\"0\" border=\"1\" style=\"width:70%; margin-top:10px\">");
                        printdoc.write("<tr>");
                        printdoc.write("<td class=\"printmailcontent\" align=\"center\"\"><b>" + attach.filename + "</b></td>");
                        printdoc.write("<td class=\"printmailcontent\">" 
                                + "<b>" + _("Content-Type:") + "</b> " + attach.content_type 
                                + (attach.size ? "<br><b>" + _("Size:") + "</b> " + bytesToString(attach.size) : "")
                                + "</td>");
                        printdoc.write("</tr>");
                		printdoc.write("</table>");	
				    }
				    printdoc.write("</td>");
				    break;
			}
			if(!detailarray[i]["isimage"]) {
				printdoc.write("</tr>");
			} else {
				for(var i2=0;i2<detailarray.length;i2++) {
					if(detailarray[i2].type == "image") {
						printdoc.write("<td style=\"width:90px\"><div class=\"printimage\"><img src=\""+detailarray[i2].src+"\" style=\"width:"+detailarray[i].width+";height:"+detailarray[i2].height+"\"/></div></td></tr>");
					}
				}
			}
		}
		printdoc.write("</table>");
		printdoc.write("</body>");
		printdoc.write('<script type="text/javascript">window.setTimeout(function() { window.focus(); window.print(); }, 10);</script>');
		printdoc.write("</html>");
		printdoc.close();
	},
	printLiveGrid : function(livegrid, printAll) {
		var Self=this;
		this.printdiv=document.createElement("div");
		this.printdiv.style.width="100%";
		if (printAll !== true && menucountselected !=0) {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },true);
		} else {
			livegrid.print(this.printdiv,function () { Self.printWindow(); },false);
		}
	},
	printWindow : function() {
		this.printwindow = newWindow("newInfoItemHidden.html","width="+this.width+",height="+this.height+",left=50,top=50,resizable=yes,menubar=yes,toolbar=yes,status=yes");
		var printdoc =this.printwindow.document;
		printdoc.open();
		printdoc.write("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\" \"http://www.w3.org/TR/html4/strict.dtd\">");
		printdoc.write("<html><head><title>"+this.printName+"</title><link rel=\"stylesheet\" type=\"text/css\" href=\"print.css\"/></head>");
		printdoc.write("<body style=\"width:95%;height:95%\">");
		printdoc.write(this.printdiv.innerHTML);
		printdoc.write("</body>");
		printdoc.write('<script type="text/javascript">window.setTimeout(function() { window.focus(); window.print(); window.close(); }, 500);</script>');
		printdoc.write("</html>");
		printdoc.close();
	}
}
var globalprint = new Print("");
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 * 
 */

var key= "appointments"; /*i18n*/
key= "tasks"; /*i18n*/
SeriesObject.NOSERIES= 0;
SeriesObject.DAILY= 1;
SeriesObject.WEEKLY= 2;
SeriesObject.MONTHLY= 3;
SeriesObject.YEARLY= 4;

SeriesObject.SUNDAY=1;
SeriesObject.MONDAY=2;
SeriesObject.THUESDAY=4;
SeriesObject.WEDNESDAY=8;
SeriesObject.THURSDAY=16;
SeriesObject.FRIDAY=32;
SeriesObject.SATURDAY=64;

SeriesObject.JANUARY=1;
SeriesObject.FEBRUARY=2;
SeriesObject.MARCH=3;
SeriesObject.APRIL=4;
SeriesObject.MAY=5;
SeriesObject.JUNE=6;
SeriesObject.JULY=7;
SeriesObject.AUGUST=8;
SeriesObject.SEPTEMBER=9;
SeriesObject.OCTOBER=10;
SeriesObject.NOVEMBER=11;
SeriesObject.DECEMBER=12;

function SeriesObject (object,createseries) {
	this.disabled=false;
	this.old_recurrence_type=null;
	this.old_days=null;
	this.old_day_in_month=null;
	this.old_month=null;
	this.old_interval=null;
	this.old_until=null;
	this.old_occurrences=null;
	/*
	 * NOSERIES= 0 ; DAILY= 1; WEEKLY= 2; MONTHLY= 3; YEARLY= 4;
	 */
	this.recurrence_type = 0;
	/*
	 * Null not set.
	 * Add up integer of in week days; or the day of series in monthview;
	 */
	this.days=null; //WEEK,MONTH,YEAR
	/*
	 * Null not set.
	 * which day of a month is part of the sequence. Counting starts with 1. counting all days set in days or if days not set all days.
	 */	
	this.day_in_month=null; //MONTH,YEAR
	 /*
	  * Null not set.
	  * Month of series
	  */
	this.month=null; //YEAR
	 /*
	  * Interval of series each number week,month,day 
	  */
    this.interval=null; //DAY,WEEK,MONTH || YEAR=1
    /*
     * Null not set 
     * End date of the series, if not set and occcurences not set series is unlimited
     */
     this.until=null; //DATE OF END
     /*
      * Null not set
      * Count of series not set
      */
     this.occurrences=null; //COUNT OF OCCURENCES
     
     if(object) {
     	this.setParameters(object,createseries);
     }
}
SeriesObject.prototype = {
	hasNoChanges : function () {
		if(this.old_recurrence_type != this.recurrence_type) { return false; }
		else if(this.old_days != this.days) { return false; }
		else if(this.old_day_in_month != this.day_in_month) { return false; }
		else if(this.old_month != this.month) { return false; }
		else if(this.old_interval != this.interval) { return false; }
		else if(this.old_until != this.until) { return false; }
		else if(this.old_occurrences != this.occurrences) { return false; }
		return true;		
	},
	setParameters : function(responseobject,createseries, forceNew) {
		if(!responseobject) {
			return;
		}
		if(responseobject.recurrence_position && !createseries) {
			this.disabled=true;
			//REMOVE IF IS VALID TO CREATE SERIES
			return;
		}
		if(responseobject.recurrence_type != undefined) {
			if (!forceNew) this.old_recurrence_type=parseInt(responseobject.recurrence_type);
			this.recurrence_type=parseInt(responseobject.recurrence_type);
		}
		if(responseobject.days != undefined) {
		    if (!forceNew) this.old_days=parseInt(responseobject.days);
			this.days=parseInt(responseobject.days);
		}
		if(responseobject.day_in_month != undefined) {
		    if (!forceNew) this.old_day_in_month=parseInt(responseobject.day_in_month);
			this.day_in_month=parseInt(responseobject.day_in_month);
		}
		if(responseobject.month != undefined) {
		    if (!forceNew) this.old_month=parseInt(responseobject.month);
			this.month=parseInt(responseobject.month);
		}
		if(responseobject.interval != undefined) {
		    if (!forceNew) this.old_interval=parseInt(responseobject.interval);
			this.interval=parseInt(responseobject.interval);
		}
		if(responseobject.until != undefined) {
		    if (!forceNew) this.old_until=responseobject.until;
			this.until=responseobject.until;
		}
		if(responseobject.occurrences != undefined) {
		    if (!forceNew) this.old_occurrences=parseInt(responseobject.occurrences);
			this.occurrences=parseInt(responseobject.occurrences);
		}
	},
	getSeriesString : function() {
		function getCountString (countint) {
			switch (countint) {
				case 1:
					return _("first");
				case 2:
					return _("second");
				case 3:
					return _("third");
				case 4:
					return _("fourth");
				case 5:
				case -1:
					return _("last"); 
			}
		}
		function getMonthString(monthint) {
			var mymonth=[_("January"),_("February"),_("March"),_("April"),_("May"),_("June"),_("July"),_("August"),_("September"),_("October"),_("November"),_("December")];
			return mymonth[monthint];
		}
		function getDayString(daysint) {
			var daystring="";
			switch (daysint) {
				case 62:
				    daystring=_("Work Day");
				    break;
				case 65:
                    daystring=_("Weekend Day");
                    break;
                case 127:
                    daystring=_("Day");
                    break;
				default:
					if (((daysint % SeriesObject.MONDAY) / SeriesObject.SUNDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Sunday") : daystring=daystring + ", "+_("Sunday"); 
					}					
					if (((daysint % SeriesObject.THUESDAY) / SeriesObject.MONDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Monday") : daystring=daystring + ", "+_("Monday"); 
					}					
					if (((daysint % SeriesObject.WEDNESDAY) / SeriesObject.THUESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Tuesday") : daystring=daystring + ", "+_("Tuesday"); 
					}					
					if (((daysint % SeriesObject.THURSDAY) / SeriesObject.WEDNESDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Wednesday") : daystring=daystring + ", "+_("Wednesday"); 
					}					
					if (((daysint % SeriesObject.FRIDAY) / SeriesObject.THURSDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Thursday") : daystring=daystring + ", "+_("Thursday"); 
					}					
					if (((daysint % SeriesObject.SATURDAY) / SeriesObject.FRIDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Friday") : daystring=daystring + ", "+_("Friday"); 
					}					
					if ((daysint / SeriesObject.SATURDAY) >= 1) {
						(daystring=="") ? daystring=daystring + _("Saturday") : daystring=daystring + ", "+_("Saturday"); 
					}
			}
			return daystring;
		}
		var returnstring;
		var interval=this.interval;
		var recurrence_type=this.recurrence_type;
		var days=this.days;
		var day_in_month=this.day_in_month;
		var month=this.month;
		var until=this.until;
		var occurences=this.occurences;
		if(this.hasNoChanges()) {
			interval=this.old_interval;
			recurrence_type=this.old_recurrence_type;
			days=this.old_days;
			day_in_month=this.old_day_in_month;
			month=this.old_month;
			until=this.old_until;
			occurrences=this.old_occurrences;
		}
		switch (this.recurrence_type) {
			case 0:
				returnstring = _("No recurrence");
				break;
			case 1:	
				returnstring = format(_("Each %s Day"),interval);
				break;
			case 2:
				returnstring = format(_("Each %s Week(s) on %s"),[interval, getDayString(days)]);
				break;
	  		case 3:
	  			if(this.days==null) {
	  				returnstring = format(_("On day %s every %s month(s)"),[day_in_month,interval]);
	  			} else {
	  				returnstring = format(_("On %s %s each %s months"),[getCountString(day_in_month),getDayString(days),interval]);
	  			}
	  			break;
	  		case 4:
	  			if(this.days==null) {
	  				returnstring = format(_("Each %s %s"),[day_in_month,getMonthString(month)]);
	  			} else {
	  				returnstring = format(_("On %s %s in %s"),[getCountString(day_in_month), getDayString(days),getMonthString(month)]);
	  			}
			    break;
		}
		return returnstring;
	}
}
function SeriesView () {
	this.seriesobject=new SeriesObject();
	this.series_content_month_day_in_month1;
	this.series_content_month_days1;
	this.series_content_year_month0;
	this.series_content_year_month1;
	this.series_content_year_days1;
	this.series_content_year_day_in_month1;
	this.sequenceStart;
	this.sequenceEnd;
	this.actualnode;
}
SeriesView.prototype = {
	toggleMiniSequenceStart : function() {
		var tmp = $("series_duration_calendar_start");
		if(tmp.style.display!="block") {
			centerPopupWindow(tmp);
			tmp.style.height = 210 + "px";
			tmp.style.width = 228 + "px";
			tmp.style.display = "block";
		} else {
			tmp.style.display = "none";
		}
	},
	toggleMiniSequenceEnd : function() {
		var tmp = $("series_duration_calendar_end");
		if(tmp.style.display!="block") {
			centerPopupWindow(tmp);
			tmp.style.height = 210 + "px";
			tmp.style.width = 228 + "px";
			tmp.style.display = "block";
			if ($("series_ending_date_2")) {
			    $("series_ending_date_2").checked = "checked";
		    }
		} else {
			tmp.style.display = "none";
		}
	},
	setParameters : function(responseobject, forceNew) {
		this.seriesobject.setParameters(responseobject, false, forceNew);
		triggerEvent("OX_Series_Data_Init", this.getSeriesString());
	},
	getParameters : function(responseobject, moduleCase) {
		if (!responseobject) {
			responseobject=new Object();
		}
		if (!this.seriesobject.hasNoChanges() || (moduleCase && moduleCase == "duplicate")) {
			if (this.seriesobject.recurrence_type != null) { 
				responseobject["recurrence_type"]= this.seriesobject.recurrence_type; 
			}
			if (this.seriesobject.days != null) { 
				responseobject["days"]=this.seriesobject.days; 
			} else if (this.seriesobject.old_days != null) {
				responseobject["days"]=null;
			}
			if (this.seriesobject.day_in_month != null) { 
				responseobject["day_in_month"]=this.seriesobject.day_in_month; 
			}
			if (this.seriesobject.month != null) { 
				responseobject["month"]=this.seriesobject.month; 
			}
			if (this.seriesobject.interval != null) { 
				responseobject["interval"]=this.seriesobject.interval; 
			}
			if (this.seriesobject.occurrences != null) { 
				responseobject["occurrences"]=this.seriesobject.occurrences; 
			} else {
			    delete responseobject.occurrences;
			}
			if (this.seriesobject.until != null) { 
				var tmpdate=new Date(this.seriesobject.until);
				tmpdate=new Date(Date.UTC(tmpdate.getUTCFullYear(),tmpdate.getUTCMonth(),tmpdate.getUTCDate(),0,0,0));
				responseobject["until"]=tmpdate.getTime(); 
			} else {
			    delete responseobject.until;
			}
			if (this.seriesobject.until == null && this.seriesobject.occurrences == null) {
	            if (this.seriesobject.old_until != null) {
	                responseobject["until"] = null;
	            } else if (this.seriesobject.old_occurrences != null) {
	                responseobject["occurrences"] = null;
	            }
            }
		}
		return responseobject;
	},
	initView : function() {
		var Self=this;
		function createCalendar() {
			Self.sequenceStart = new cMiniCalendar(	$("begin_header_sequence"),$("begin_sequence"), 
									series_setSequenceStartDate,false,'seq_begin',$("seq_begin_header_month"),$("seq_begin_header_year"));

			Self.sequenceEnd = new cMiniCalendar(	$("end_header_sequence"), $("end_sequence"), 
										series_setSequenceEndDate,false,'seq_end',$("seq_end_header_month"),$("seq_end_header_year"));
		}
		function createCombos() {
			Self.series_content_month_day_in_month1 = new ComboBox3(window, "series_content_month_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_month_day_in_month1.addElement(_("first"),1);
			Self.series_content_month_day_in_month1.addElement(_("second"),2);
			Self.series_content_month_day_in_month1.addElement(_("third"),3);
			Self.series_content_month_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_month_day_in_month1.addElement(_("last"),5);
			Self.series_content_month_day_in_month1.getDomNode();
			Self.series_content_month_days1 = new ComboBox3(window, "series_content_month_days:1", "9em", 0, true, null, 4);
			Self.series_content_month_days1.addElement(_("Monday"),2);
			Self.series_content_month_days1.addElement(_("Tuesday"),4);
			Self.series_content_month_days1.addElement(_("Wednesday"),8);
			Self.series_content_month_days1.addElement(_("Thursday"),16);
			Self.series_content_month_days1.addElement(_("Friday"),32);
			Self.series_content_month_days1.addElement(_("Saturday"),64);
			Self.series_content_month_days1.addElement(_("Sunday"),1);
			Self.series_content_month_days1.addElement(_("Day"),127);
			Self.series_content_month_days1.addElement(_("Weekend Day"),65);
			Self.series_content_month_days1.addElement(_("Work Day"),62);
			Self.series_content_month_days1.getDomNode();
			Self.series_content_year_month0 = new ComboBox3(window, "series_content_year_month:0", "9em", 0, true, null, 4);
			Self.series_content_year_month0.addElement(_("January"),0);
			Self.series_content_year_month0.addElement(_("February"),1);
			Self.series_content_year_month0.addElement(_("March"),2);
			Self.series_content_year_month0.addElement(_("April"),3);
			Self.series_content_year_month0.addElement(_("May"),4);
			Self.series_content_year_month0.addElement(_("June"),5);
			Self.series_content_year_month0.addElement(_("July"),6);
			Self.series_content_year_month0.addElement(_("August"),7);
			Self.series_content_year_month0.addElement(_("September"),8);
			Self.series_content_year_month0.addElement(_("October"),9);
			Self.series_content_year_month0.addElement(_("November"),10);
			Self.series_content_year_month0.addElement(_("December"),11);
			Self.series_content_year_month0.getDomNode();
			Self.series_content_year_month1 = new ComboBox3(window, "series_content_year_month:1", "9em", 0, true, null, 4);
			Self.series_content_year_month1.addElement(_("January"),0);
			Self.series_content_year_month1.addElement(_("February"),1);
			Self.series_content_year_month1.addElement(_("March"),2);
			Self.series_content_year_month1.addElement(_("April"),3);
			Self.series_content_year_month1.addElement(_("May"),4);
			Self.series_content_year_month1.addElement(_("June"),5);
			Self.series_content_year_month1.addElement(_("July"),6);
			Self.series_content_year_month1.addElement(_("August"),7);
			Self.series_content_year_month1.addElement(_("September"),8);
			Self.series_content_year_month1.addElement(_("October"),9);
			Self.series_content_year_month1.addElement(_("November"),10);
			Self.series_content_year_month1.addElement(_("December"),11);
			Self.series_content_year_month1.getDomNode();
			Self.series_content_year_days1 = new ComboBox3(window, "series_content_year_days:1", "9em", 0, true, null, 4);
			Self.series_content_year_days1.addElement(_("Monday"),2);
			Self.series_content_year_days1.addElement(_("Tuesday"),4);
			Self.series_content_year_days1.addElement(_("Wednesday"),8);
			Self.series_content_year_days1.addElement(_("Thursday"),16);
			Self.series_content_year_days1.addElement(_("Friday"),32);
			Self.series_content_year_days1.addElement(_("Saturday"),64);
			Self.series_content_year_days1.addElement(_("Sunday"),1);
			Self.series_content_year_days1.addElement(_("Day"),127);
			Self.series_content_year_days1.addElement(_("Weekend Day"),65);
			Self.series_content_year_days1.addElement(_("Work Day"),62);
			Self.series_content_year_days1.getDomNode();
			Self.series_content_year_day_in_month1 = new ComboBox3(window, "series_content_year_day_in_month:1", "7em", 0, true, null, 4);
			Self.series_content_year_day_in_month1.addElement(_("first"),1);
			Self.series_content_year_day_in_month1.addElement(_("second"),2);
			Self.series_content_year_day_in_month1.addElement(_("third"),3);
			Self.series_content_year_day_in_month1.addElement(_("fourth"),4);
			Self.series_content_year_day_in_month1.addElement(_("last"),5);
			Self.series_content_year_day_in_month1.getDomNode();
		}

		createCombos();
		createCalendar();
	},
	showView : function (module,startdate,enddate) {
		if(!this.seriesobject.disabled) {
		    ox.api.setModal(true);
//			showNode("modal-dialog");
//			$("modal-dialog").style.display="block";
			showNode("series_window");
			centerPopupWindow($("series_window"));
			$("series_window").style.display="block";
			this.openView(module,startdate,enddate);
		} else {
			triggerEvent("OX_New_Error",4,_("You can't create a new recurrence in a modified appointment."));
		}
		
		
		
	},
	openView : function (module,startdate,enddate) {
		this.seriesobject.tmp_recurrence_type=this.seriesobject.recurrence_type;
		this.recurrenceType(this.seriesobject.recurrence_type,startdate);
		switch(parseInt(this.seriesobject.recurrence_type)) {
			case 0:
				break;
			case 1:
				$("series_interval_day").value=parseInt(this.seriesobject.interval);
				break;
			case 2:
				$("series_interval_week").value=parseInt(this.seriesobject.interval);
				setCheckBoxinWeek(parseInt(this.seriesobject.days));
				break;
			case 3:
				if(this.seriesobject.days == null) {
					$("series_content_month_option:0").checked=true;
					if(this.seriesobject.day_in_month != null) $("series_content_month_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.interval != null) $("series_interval_month:0").value=	parseInt(this.seriesobject.interval);
				} else  {
					$("series_content_month_option:1").checked=true;
					if(this.seriesobject.day_in_month != null) this.series_content_month_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
				  	if(this.seriesobject.days != null) this.series_content_month_days1.setKey(parseInt(this.seriesobject.days));
				   	if(this.seriesobject.interval != null) $("series_interval_month:1").value=	parseInt(this.seriesobject.interval);
				}
			    break;
			case 4:	
				if(this.seriesobject.days == null) {	
					$("series_content_year_option:0").checked=true;			
					if(this.seriesobject.day_in_month != null) $("series_content_year_day_in_month:0").value=parseInt(this.seriesobject.day_in_month);
					if(this.seriesobject.month != null) this.series_content_year_month0.setKey(parseInt(this.seriesobject.month));
				} else {
					$("series_content_year_option:1").checked=true;			
					if(this.seriesobject.days != null) this.series_content_year_days1.setKey(parseInt(this.seriesobject.days));
					if(this.seriesobject.day_in_month != null) this.series_content_year_day_in_month1.setKey(parseInt(this.seriesobject.day_in_month));
					if(this.seriesobject.month != null) this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));			
				} 
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			setRadioBoxEndingDate(this.seriesobject.occurrences,this.seriesobject.until);
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 1:
					$("series_duration_endsafter").value=this.seriesobject.occurrences;
					break;
				case 2:
					var mydate=new Date(this.seriesobject.until);
					globalseries.sequenceEnd.setSelectedByDate(mydate.getUTCFullYear(),mydate.getUTCMonth(),mydate.getUTCDate());
					$("series_duration_enddate").value= formatDate(mydate, "date");
					break;
			}
		}
		if(enddate && !this.seriesobject.until) { 
			$("series_duration_enddate").value= formatDate(enddate, "date");
			globalseries.sequenceEnd.setSelectedByDate(enddate.getUTCFullYear(),enddate.getUTCMonth(),enddate.getUTCDate()); 
		} else {
			$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
		}
		if(startdate) {	
			$("series_duration_startdate").value= formatDate(startdate, "date"); 
			globalseries.sequenceStart.setSelectedByDate(startdate.getUTCFullYear(),startdate.getUTCMonth(),startdate.getUTCDate()); 
		} else {
			$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date"); 
		}
		if(module) {
			$("endsAfterType").firstChild.data=_(module);
		}
		
		if (this.seriesobject.days == null) {
			var prefill_date = parseDateString($("series_duration_startdate").value, "date");

			/* Pre Fill Weekly View */
			var prefill_dayOfWeek = prefill_date.getDay();				
			if(prefill_dayOfWeek) {	
				switch(parseInt(prefill_dayOfWeek)) {
				case 0:
					this.series_content_month_days1.setKey(parseInt(1));
					this.series_content_year_days1.setKey(parseInt(1));
					setCheckBoxinWeek(1);
					break;
				case 1:
					this.series_content_month_days1.setKey(parseInt(2));
					this.series_content_year_days1.setKey(parseInt(2));
					setCheckBoxinWeek(2);
					break;
				case 2:
					this.series_content_month_days1.setKey(parseInt(4));
					this.series_content_year_days1.setKey(parseInt(4));
					setCheckBoxinWeek(4);				
					break;
				case 3:
				this.series_content_month_days1.setKey(parseInt(8));
					this.series_content_year_day_in_month1.setKey(parseInt(8));
					setCheckBoxinWeek(8);
				    break;
				case 4:
					this.series_content_month_days1.setKey(parseInt(16));
					this.series_content_year_days1.setKey(parseInt(16));
					setCheckBoxinWeek(16);
				    break;
				case 5:
					this.series_content_month_days1.setKey(parseInt(32));
					this.series_content_year_days1.setKey(parseInt(32));
					setCheckBoxinWeek(32);
				    break;
				case 6:
					this.series_content_month_days1.setKey(parseInt(64));
					this.series_content_year_days1.setKey(parseInt(64));
					setCheckBoxinWeek(64);
				    break;
				}									
			}
			
			/* Pre Fill Monthly View */
			
			var prefill_dayOfMonth = prefill_date.getUTCDate();
			if ($("series_content_month_day_in_month:0") && prefill_dayOfMonth){
				$("series_content_month_day_in_month:0").value = parseInt(prefill_dayOfMonth);
			}
			
			if (prefill_dayOfMonth){
				if (prefill_dayOfMonth <= 7){						
					this.series_content_month_day_in_month1.setKey(parseInt(1));
					this.series_content_year_day_in_month1.setKey(parseInt(1));
				} else if (prefill_dayOfMonth <= 14 && prefill_dayOfMonth > 7){
					this.series_content_month_day_in_month1.setKey(parseInt(2));
					this.series_content_year_day_in_month1.setKey(parseInt(2));
				} else if (prefill_dayOfMonth <= 21 && prefill_dayOfMonth > 14){
					this.series_content_month_day_in_month1.setKey(parseInt(3));
					this.series_content_year_day_in_month1.setKey(parseInt(3));
				} else if (prefill_dayOfMonth <= 28 && prefill_dayOfMonth > 21){
					this.series_content_month_day_in_month1.setKey(parseInt(4));
					this.series_content_year_day_in_month1.setKey(parseInt(4));
				} else if (prefill_dayOfMonth > 28){
					this.series_content_month_day_in_month1.setKey(parseInt(5));
					this.series_content_year_day_in_month1.setKey(parseInt(5));
				}				
			}
		}
	},
	hideView : function () {
		hideNode("series_window");
		$("series_window").style.display="none";
		hideNode("series_window");
		ox.api.setModal(false);
//		$("modal-dialog").style.display="none";
	},
	cancelView : function() {
		this.seriesobject.recurrence_type=this.seriesobject.tmp_recurrence_type;
		this.hideView();
	},
	closeView : function () {
		switch (this.seriesobject.recurrence_type) {
			case 0:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=null;
                break;
			case 1:
				this.seriesobject.days=null;
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
    			this.seriesobject.interval=parseInt($("series_interval_day").value, 10);
			    break; 	
			case 2:
				this.seriesobject.days=getCheckBoxInt($("series_window_form").series_days);	
				if(this.seriesobject.days == 0) {
					//TODO SHOW ERROR
					return;
				}
				this.seriesobject.interval=parseInt($("series_interval_week").value, 10);
				this.seriesobject.day_in_month=null;
				this.seriesobject.month=null;
			    break;
			case 3:
			  	var myoption=getRadioBoxValue($("series_window_form").series_content_month_option);
			   	this.seriesobject.interval =parseInt($("series_interval_month:"+myoption).value, 10);
				this.seriesobject.month=null;
				if(myoption==0) {
					this.seriesobject.day_in_month=parseInt($("series_content_month_day_in_month:"+myoption).value, 10);
				  	this.seriesobject.days=null;
				} else if(myoption == 1) {
					this.seriesobject.day_in_month=parseInt(this.series_content_month_day_in_month1.getKey());
				  	this.seriesobject.days=parseInt(this.series_content_month_days1.getKey());
				} else {
					return;
				}
			    break;
			case 4:	
				var myoption=getRadioBoxValue($("series_window_form").series_content_year_option);
				if(myoption == 0) {
					this.seriesobject.day_in_month=parseInt($("series_content_year_day_in_month:"+myoption).value, 10);
					this.seriesobject.days=null;
					this.seriesobject.month=parseInt(this.series_content_year_month0.getKey());
				} else if(myoption == 1) {
					this.seriesobject.days=parseInt(this.series_content_year_days1.getKey());
					this.seriesobject.day_in_month=parseInt(this.series_content_year_day_in_month1.getKey());
					this.seriesobject.month=parseInt(this.series_content_year_month1.getKey());			
				} else {
					//TODO THROW ERROR
					return;
				}
				this.seriesobject.interval=1;
				break;
		}
		if(this.seriesobject.recurrence_type != 0) {
			var mytype=getRadioBoxValue($("series_window_form").ending_date);
			switch(mytype) {
				case 0:
					 this.seriesobject.until=null; 
				     this.seriesobject.occurrences=null; 
					break;
				case 1:
					this.seriesobject.until=null;
					this.seriesobject.occurrences=parseInt($("series_duration_endsafter").value, 10);
					break;
				case 2:
					this.seriesobject.until=this.sequenceEnd.selectedTime;
					this.seriesobject.occurrences=null;
					break;
			}
		}
		triggerEvent("OX_Series_Data_Changed", this.getSeriesString()); 
		this.hideView();
	},
	recurrenceType : function (type) {		
		type=parseInt(type);
		this.seriesobject.recurrence_type=type;
		if(type == 4) {
			var tmp = parseDateString($("series_duration_startdate").value, "date");
			
			if(this.seriesobject.day_in_month == null) $("series_content_year_day_in_month:0").value=tmp.getUTCDate();
			if(this.seriesobject.month == null) this.series_content_year_month0.setKey(tmp.getUTCMonth());
			if(this.seriesobject.month == null) this.series_content_year_month1.setKey(tmp.getUTCMonth());
			else this.series_content_year_month1.setKey(parseInt(this.seriesobject.month));
		}
		for(var i=0;i<5;i++) {
			if(this.seriesobject.recurrence_type != i) {
				$("series_content:"+i).style.display= "none";
			} else {
				$("series_content:"+i).style.display= "block";
				$("series_recurrence_type:"+i).checked=true;
			}
		}
		for (var i = 0; i < 3; i++) {
	       $("series_ending_date_" + i).parentNode.parentNode.style.visibility =
	           type ? "" : "hidden";
		}
	},
	getSeriesString : function() {
		return this.seriesobject.getSeriesString();
	},
	getStartDate : function() {
		return new Date(this.sequenceStart.selectedTime);	
		
	}
}
function series_parseValue(value,type) {
	var returnvalue;
	switch (type) {
		case "integer":
			returnvalue=parseInt(value, 10);
			if(isNaN(value) || returnvalue < 1 || (value == "") ) {
				returnvalue=1;
			}
			break;
	}
	return returnvalue;	
}
function getCheckBoxInt(checkboxarray) {
	var returnvalue = 0;
	for (var i=0; i<checkboxarray.length; i++) {
		if (checkboxarray[i].checked) {
			returnvalue = returnvalue + parseInt(checkboxarray[i].value);
		} 
	}
	return returnvalue;	
}
function getRadioBoxValue(radioboxarray) {
	var returnvalue = 0;
	for (var i=0; i<radioboxarray.length; i++) {
		if (radioboxarray[i].checked) {
			return parseInt(radioboxarray[i].value);
		} 
	}
	return returnvalue;	
}

function setRadioBoxEndingDate(occurence,until) {
	if(!occurence && !until) {
		$("series_ending_date_0").checked=true;
	} else if (occurence) {
		$("series_ending_date_1").checked=true;
	} else {
		$("series_ending_date_2").checked=true;
	}
}
function setCheckBoxinWeek(mydays) {
	var tmpdays=mydays;
	if(tmpdays>=SeriesObject.SATURDAY) {
		$("series_days_"+SeriesObject.SATURDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SATURDAY;
	} else {
		$("series_days_"+SeriesObject.SATURDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.FRIDAY) {
		$("series_days_"+SeriesObject.FRIDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.FRIDAY;
	} else {
		$("series_days_"+SeriesObject.FRIDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THURSDAY) {
		$("series_days_"+SeriesObject.THURSDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THURSDAY;
	} else {
		$("series_days_"+SeriesObject.THURSDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.WEDNESDAY) {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.WEDNESDAY;
	} else {
		$("series_days_"+SeriesObject.WEDNESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.THUESDAY) {
		$("series_days_"+SeriesObject.THUESDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.THUESDAY;
	} else {
		$("series_days_"+SeriesObject.THUESDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.MONDAY) {
		$("series_days_"+SeriesObject.MONDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.MONDAY;
	} else {
		$("series_days_"+SeriesObject.MONDAY).checked=false;
	}
	if(tmpdays>=SeriesObject.SUNDAY) {
		$("series_days_"+SeriesObject.SUNDAY).checked=true;
		tmpdays=tmpdays-SeriesObject.SUNDAY;
	} else {
		$("series_days_"+SeriesObject.SUNDAY).checked=false;
	}
}
function series_setSequenceStartDate () {
	globalseries.sequenceStart.setSelected(this.id);
	$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");
	$("series_duration_calendar_start").style.display = "none";
}
function series_setSequenceEndDate () {
	globalseries.sequenceEnd.setSelected(this.id);
	$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	$("series_duration_calendar_end").style.display = "none";
}
function setSequenceStartDateOnBlur(){
	var tmp = parseDateString($("series_duration_startdate").value, "date");
	if(tmp) {
		globalseries.sequenceStart.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_startdate").value= formatDate(globalseries.sequenceStart.selectedTime, "date");	
	}
}
function setSequenceEndDateOnBlur(){
	var tmp = parseDateString($("series_duration_enddate").value, "date");
	if(tmp) {
		globalseries.sequenceEnd.setSelectedByDate(tmp.getUTCFullYear(), tmp.getUTCMonth(), tmp.getUTCDate());
	} else {
		$("series_duration_enddate").value= formatDate(globalseries.sequenceEnd.selectedTime, "date");
	}
}
fileloaded();
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

var refToMain = ox.api.window.core;
var session = refToMain.session;
var config = refToMain.config;
var isPrintableView = refToMain.isPrintableView;
var registerPrintView = refToMain.registerPrintView;
var OXMailMapping = refToMain.OXMailMapping, OXCache = refToMain.OXCache;
var oSel = -1, nested_msgs = "", detailmessage, propertiesPopUp;
var attachExists=false, mailFetchTimestamp, detailrequest, message = new Object();
var smilies = {
	";-)": "wink.gif",
	";)": "wink.gif",
	":-D": "big_smile.gif",
	":D": "big_smile.gif",
	":-)": "smile.gif",
	":)": "smile.gif",
	":-(": "sad.gif",
	":(": "sad.gif",
	"=(": "sad.gif",
	":|": "neutral.gif",
	":-|": "neutral.gif",
	":/": "hmm.gif",
	":-/": "hmm.gif"
};

var regexps = [];
for (var i in smilies) regexps.push(i.replace(/([$^\\.*+?()[\]{}|])/, "\\$1"));
var regexpstr = "(^| |\\n|<br>)(" + regexps.join("|") + ")";
var regexp = new RegExp(regexpstr, "g");
var sortVsplitHeader;
var triggerReady = jQuery.noop;

function replaceSmilies(text) {
	return text.replace(regexp, function(_, space, match) {
		return space + "<img src=\"" + getFullImgSrc("img/smilies/" + smilies[match]) + "\">";
	});
}

function getMailDetailObject() {
	var myobject = {};
	myobject.id = url["id"];
	myobject.folder_id = url["folder"] || url["folder_id"]; 
	return myobject;
}

var menucheckRight=function(right) {
	return refToMain.menuhasRight([getMailDetailObject()],right);	
};

registerPrintView("mail_detail/detail");

//var oNestedMessage = null;
function loadDetailMail() {	
	activemodule="mail_detail";
	initContents("mail_detail");
	mail_message = getMailDetailObject();
	ox.UIController.presetModule("mail_detail");
	initAll();
}

//function getRefToMainForMailPopup() {	
//	return refToMain || window.opener;
//}

function triggerEventInOpener(eventToTrigger) {
	refToMain.triggerEvent(eventToTrigger);
}

function isStdFolder(type) {
    return url.folder ? refToMain.isStdFolder(type, url.folder) : false;
}

register("Loaded", initMailDetail);
register("OX_Attachment_Open", function() { openAttachment("OPEN"); });
register("OX_Attachment_Open_Nested", function(){ openNestedMessage() });
register("OX_Attachment_Save", function() { openAttachment("SAVE"); });
register("OX_Attachment_SaveInfoStore", mail_saveAttachmentInDocStore);
register("OX_Add_Flag", setFlagInMailView);
register("OX_Mail_Close", function() { ctrl.close(true); });
register("OX_Cancel_Object", function() { ctrl.close(true); });
register("OX_Mail_Delete", 
		function() {
			deleteMails(url["folder"], 
                    [ OXMailMapping.createKeyFromObject(
                        { module: "mail", 
                          folder_id: url["folder"], 
                          id: url["id"] }) 
                    ]);
		}
	);
register("OX_Mail_SaveMail", 
		function() {
			var tF = $("mail.detail.pop.attachment.save");
			var n_url = AjaxRoot + '/mail?action=get'
				+ '&session=' + session + '&folder=' + encodeURIComponent(url["folder"])
				+ '&id=' + encodeURIComponent(url["id"]);
			tF.src=n_url+"&src=1&save=1";
		}
	);	
register("OX_NEW_MAIL", function(){ newMail(""); });
register("OX_Mail_Reply", function(){ newMail("reply"); });
register("OX_Mail_ReplyAll", function(){ newMail("replyall"); });
register("OX_Mail_Forward", function(){ newMail("forward"); });
register("OX_Mail_Edit_Draft", function(){ newMail("draft"); });
register("OX_Mail_Mark", mail_mark);
register("OX_Mail_Flag", markAsMail);
register("OX_Mail_Spam", markAsSpam);
register("OX_Mail_Ham", markAsHam);

registerView("mail_detail/detail",
	null,
	function() { 
		register("OX_Print", mail_printDetailMail);
		register("OX_Mail_Show_Source", mail_showMailSource);
		triggerEvent("OX_Selected_Draft", isStdFolder("drafts"));
	}, 
	function () {
		unregister("OX_Print", mail_printDetailMail);
		unregister("OX_Mail_Show_Source", mail_showMailSource);
        triggerEvent("OX_Selected_Draft", false);
	},
	function () {
	    triggerEvent('OX_Delete_Search');
        triggerEvent("OX_Selected_Draft", false);
	},
	null
);

function mail_saveAttachmentInDocStore() {
    // get attachment
	var a = selectedAttachments[0].data;
	// compose from attachment
	ox.api.infostore.composeFromAttachment({
	    params: {
	        attachmail: a.id,
	        filename: a.filename,
	        mailid: url.id,
	        mailfolder: url.folder
	    },
	    id: { folder: message.folder_id, id: message.id, attach_id: a.id },
	    success: function (win) {
	        corewindow.propertiesPopUp = win;
	    }
	});
}
	
/**
 * Delete messages
 */ 
function deleteMails(folder, ids) {
    // return if ids is empty or a delete is still in progress
    if (!ids || ids.length == 0) return;
    function cb() {
        if (corewindow.currentpath.join("/").match(/^mail\//) && corewindow.grid) {
            var focusPos = corewindow.grid.focus;
            var obj = corewindow.grid.collection.objects[focusPos];
            if(corewindow.grid.collection.objects.length) {
                corewindow.grid.selection.click(obj ? focusPos : 0);  
            }            
        }
        setTimeout(function() {
            ctrl.close(true);
        }, 0);
    }
    if (configGetKey("mail.deletemail") || configGetKey("mail.folder.trash") == url["folder"]) {
        newConfirm(_("Delete E-Mails"),_('Are you sure you want to delete the selected E-Mails?'),AlertPopup.YESNO,null,null,
        function () {
            corewindow.OXMailMapping.deleteObjects(ids,true,cb);
        }, null);
    } else {
        corewindow.OXMailMapping.deleteObjects(ids,false,cb);
    }
}

/**
 * updates the flag image
 * @param - {int} new flag bitmask
 */
function setFlagImage(flagsMessage) {
    var fimg = "unread.gif";
    if (flagsMessage & 2) {
       fimg = "deleted.gif";
    } else if (flagsMessage & 1) {
        fimg = "reply.gif";
    } else if (flagsMessage & 256) {
        fimg = "forward.gif";
    } else if (flagsMessage & 32) {
        fimg = "read.gif";
    }   
    $('mail.detail.pop.detail.mailflag').src = getFullImgSrc("img/mail/" + fimg);
}

function mail_mark() {
	$("menu_mail_flags").style.display="block";
	if(refToMain.menucheckRight("READ")) {
		$("menu_mail_flags_seen").style.display="";
		$("menu_mail_flags_unseen").style.display="";
	} else {
		$("menu_mail_flags_seen").style.display="none";
		$("menu_mail_flags_unseen").style.display="none";
	}
	if(refToMain.menucheckRight("DELETE")) {
		$("menu_mail_flags_delete").style.display="";
		$("menu_mail_flags_undelete").style.display="";
	} else {
		$("menu_mail_flags_delete").style.display="none";
		$("menu_mail_flags_undelete").style.display="none";
	}
	if(refToMain.menucheckRight("WRITE")) {
		$("menu_mail_flags_answer").style.display="";
		$("menu_mail_flags_unanswer").style.display="";
	} else {
		$("menu_mail_flags_answer").style.display="none";
		$("menu_mail_flags_unanswer").style.display="none";
	}
}

/**
 * Marks message as Spam 
 */
function markAsSpam() {
    corewindow.oMailFunctions.markAsSpam({ module: "mail", folder_id: url["folder"], id: url["id"] });
    triggerEvent("OX_Mail_Close");
}

/**
 * Marks message as Hpam 
 */
function markAsHam() {
    corewindow.oMailFunctions.markAsHam(
        { module: "mail", folder_id: url["folder"], id: url["id"] });
    triggerEvent("OX_Mail_Close");
}

/**
 * Marks message as 'Answered, Read, Deleted, ...' 
 * @param - mailFlag
 */
function markAsMail(mailFlag) {
	OXMailMapping.setMailFlags(mailFlag, [ 
		       OXMailMapping.createKeyFromObject({ 
	       	       module: "mail", folder_id: url["folder"], id: url["id"] 
	           }) 
           ]); 
}

/**
 * Sets message color tag
 * @param - tag
 */
function setFlagInMailView(tag){
    OXMailMapping.setTag(tag, [ 
               OXMailMapping.createKeyFromObject({ 
                   module: "mail", folder_id: url["folder"], id: url["id"] 
               }) 
           ]);
}

/**
 * Open a new message window
 */
function newMail(action) {
    var params = { folder: url.folder, id: url.id, action: action };
    // set account id if available
    if (detailmessage && detailmessage["whole_message"] && detailmessage["whole_message"]["account_id"]) {
        // is an existing account?
        if (ox.api.cache.account.get(detailmessage["whole_message"]["account_id"]) !== undefined) {
            params.account = detailmessage["whole_message"]["account_id"];
        }
    }
    // use api
    ox.api.mail.open({ params: params });
}
	
function initMailDetail() {
	session = refToMain.session;
	
	var themeStyle = corewindow.oxThemeStyle || { name: "Default", path: "default" };
	ox.gui.themePath = getFullImgSrc("");
    removeCSSFilesForNewWindow(themeStyle.path);
	
	var detailedMail = {};
	detailedMail.id = url["id"];
	detailedMail.folder_id = url["folder"];
	detailedMail.type = url["type"];
	var aObjectMail = new Array(detailedMail);
	
    // adding new menu 
    ox.gui.initToolBarNewWindowMailDetail();
    
    triggerReady = function (object) {
        
        // disable loading screen
        $("loading_data_bg").style.display = "none";
        
        var metaData = {
            module: "mail",
            activemodule: activemodule,
            handle: url.guid,
            id: url.id ? url.id : null,
            folder_id: url.folder ? url.folder : null,
            title: object ? object.subject || "" : ""
        };
        
        // trigger default selection
        ox.ToolBarController.processSelection("default", true, aObjectMail, true);
        ox.api.window.core.triggerEvent("OX_Window_Ready", metaData, window);
        object = metaData = null;
    };
    
    setTimeout(function () { 
        triggerEvent("OX_Switch_View","mail_detail/detail");
        initMessageContent(corewindow.loadblockedimages);
        triggerEvent("Selected", aObjectMail); 
    }, 0);
}

var loadBlockedImages = function() {
    initMessageContent(true);
    // corewindow only needs to force upodate if the same 
    // message is still selected
    if (corewindow.mail_lastSelectedId.id == message.id) {
        setTimeout(corewindow.loadBlockedImages,0);
    }
};

var toggleImipTab = function(button, what) {
    jQuery("td", $("mail.detail.imip.toolbar"))
        .removeClass("oxTabCurrent")
        .filter("." + what)
        .addClass("oxTabCurrent");
    if (what === "inv") {
        jQuery($('mail.detail.content')).hide();
    } else {
        jQuery($('mail.detail.content')).show();
    }
};

function initMessageContent(loadblockedimages) {
	var oNestedMessage = ox.api.window.getData(url.guid).oNestedMessage;
	if (oNestedMessage && oNestedMessage.length) {
		message.id = oNestedMessage[0].id;
		message.folder_id = message.folder_id || url["folder"];
		oNestedMessage[0].folder_id = message.folder_id;
		drawMessage(oNestedMessage[0], message.folder_id);
	} else {
		message.id = url["id"];
		message.folder_id = url["folder"];
				
		var collection={};
        collection.objects=[OXMailMapping.createKeyFromObject(
	              { module: "mail", 
	                folder_id: message.folder_id, 
	                id: message.id }
              )];
        if(configGetKey("mail.inlineattachments")) {
            if(configGetKey("modules.mail.allowhtmlimages") || loadblockedimages) {
                collection.columns=OXMailMapping.GETHTML;       
            } else {
                collection.columns=OXMailMapping.GETHTMLNOIMAGE;
            }
        } else {
            collection.columns=OXMailMapping.GETPLAIN;
        }
		
		if (detailrequest) { OXCache.unregister(detailrequest.uniqueName); }
		
		// get mail
		var cont = function (daten) {
            if (daten.objects[0]) {
                mailFetchTimestamp = daten.timestamp;
                showMessage(daten.objects[0], message.folder_id);
            }
        };

        jQuery(".mail_content_view").css({ visibility: "hidden" });
        jQuery($("mail.detail.content")).show();
        
		detailrequest = OXCache.newRequest(null, "mail", collection, cont, cont, false, triggerReady);
	}
}

function showMessage(message, folder) {
    function _cb(itipObject) {
        if (itipObject === undefined) {
            jQuery("#mail\\.detail\\.imip\\.toolbar").hide();
            resizeSplit("mail.detail.imip.toolbar", 0);
        } else {
            // select first tab
            jQuery("td", $("mail.detail.imip.toolbar")).removeClass("oxTabCurrent").first().addClass("oxTabCurrent");
            // show toolbar and resize to correct height
            jQuery("#mail\\.detail\\.imip\\.toolbar").show();
            resizeSplit("mail.detail.imip.toolbar", "26px");
            
            itipObject.node = jQuery("#mail\\.detail\\.imip");
            itipObject.success = function() {
                jQuery($("mail.detail.content")).hide();
                jQuery(".mail_content_view").css({ visibility: "visible" });
            };
            ox.mail.itip.paint(itipObject);
        }
        drawMessage(message, folder);
    }
    
    ox.mail.itip.parseMessage({
        callback: _cb,
        message: message
    });
}

function drawMessage(message, folder) {
	nested_msgs = "";
	if(message["nested_msgs"] && message["nested_msgs"].length) {
		nested_msgs = message["nested_msgs"];
		attachExists = true;
	}
	detailmessage=new Object();
	detailmessage["whole_message"]=message;
	if(message["from"]) {
		detailmessage["from"] = refToMain.getAdressString(message["from"], false);
		if (configGetKey("ui.mail.showContactImage.value") === true && message.from.length) {
		    ox.mail.drawContactImage(message.from[0][1]);
		}
	}
	if(message["to"])  
		detailmessage["to"]=refToMain.getAdressString(message["to"], false);
	if(message["cc"])  
		detailmessage["cc"]=refToMain.getAdressString(message["cc"], false);
	if(message["bcc"])  
		detailmessage["bcc"]=refToMain.getAdressString(message["bcc"], false);
	detailmessage["date"]=message["sent_date"];
	detailmessage["subject"]=message["subject"];
	detailmessage["priority"]=message["priority"];
	detailmessage["color-label"]=message["color_label"];
	
	// set document title as well
	var title = message["subject"] || "";
	document.title = _("E-Mail") + (title ? ": " : "") + title;
	
	$("mail.detail.pop.detail.row.organization").style.display="none";
	if (message["headers"] && message["headers"]["Organization"]) {
		$("mail.detail.pop.detail.header.organization").firstChild.data=message["headers"]["Organization"];
		$("mail.detail.pop.detail.row.organization").style.display="";
	}
	
	var from = setAdressHeader("from", message["from"]);
	if (from && message["headers"] && message["headers"]["Sender"] && 
			message["from"] != message["headers"]["Sender"]) {
    	from.insertBefore(newtext(format(_("%1$s on behalf of"), [ message["headers"]["Sender"] ]) + " "), 
    			from.firstChild);
	}
	setAdressHeader("to", message["to"]);
	setAdressHeader("cc", message["cc"]);
	setAdressHeader("bcc", message["bcc"]);
	
	setColor_label(message["color_label"]);
	setSubject(message["subject"]);
	setPriority(message["priority"]);
	var dateToShow = message["received_date"];
    if (isStdFolder("sent") || isStdFolder("drafts")) {
        dateToShow = message["sent_date"];
    }
	setDate(dateToShow);
	// change header description if the folder is sent or draft
    jQuery(".received").text(isStdFolder("sent") ||  isStdFolder("drafts") ? 
            _("Sent").toString() : _("Received").toString());
	setMessageText(message);
	msgref = message["msgref"];
	setFlagImage(message["flags"]);
	
	jQuery(".mail_content_view").css({ visibility: "visible" });
	
    triggerReady(message);
}

function setColor_label(colorlabel) {
    $("mail.detail.pop.detail.flag").src = getFullImgSrc("img/menu/tag_"+(colorlabel||0)+".gif");
}

function setAdressHeader(fType, address) {
    var oDivEmails = $("mail.detail.pop.detail.header." + fType);
    var rDivEmails = $("mail.detail.pop.detail.row." + fType);
    if (rDivEmails && address && address == "") {
        rDivEmails.style.display ="none";
        oDivEmails.firstChild.nodeValue = "";
    } else if (oDivEmails && address && address != "") {
        removeChildNodes(oDivEmails);
        if (rDivEmails != undefined) rDivEmails.style.display="";
        getAdressStringLinked(oDivEmails, address, configGetKey("gui.mail.showname"));
    } 
    
    return oDivEmails;
}

function setPriority(priority) {
    if ("mail.detail.pop.detail.header.prority") {
        var divPrio = $("mail.detail.pop.detail.header.prority");
        divPrio.style.display = "";
        if (priority < 3) {
            divPrio.src = getFullImgSrc("img/mail/email_priohigh.gif");      
        } else if (priority > 3) {
            divPrio.src = getFullImgSrc("img/mail/email_priolow.gif");
        } else {
            divPrio.style.display = "none";
        }
    }
}

function setSubject(subject) {
    if (subject)
        $("mail.detail.pop.detail.header.subject").firstChild.nodeValue = subject.replace(/(.{1,20})/g, "$1\u200B");
}

function setDate(date) {
    if (date) {
        date = refToMain.formatDate(date, "datetime");
    } else {
        date = "";
    }
    $("mail.detail.pop.detail.header.received_date").firstChild.nodeValue = date;
}

var detailNestedMessage = null;
function setMessageText(message) {
	var mda = $("mail.detail.pop.detail.attachments");
	removeChildNodes(mda);
	
	var cnn = "", mdac = "";
    var attachmentParam=null;
    var newMessageTextType=null;
    var attachments = [];    
    if(message["attachments_plain"] && !configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_plain"]; 
        newMessageTextType="attachments_plain"; 
    } else if (message["attachments_html"] && configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_html"]; 
        newMessageTextType="attachments_html"; 
    } else if (message["attachments_html_noimage"] && configGetKey("mail.inlineattachments")) { 
        attachmentParam=message["attachments_html_noimage"]; 
        newMessageTextType="attachments_html_noimage"; 
    } else if (message["attachments"]) {
        attachmentParam=message["attachments"]; 
        newMessageTextType="attachments";     	
    }
    
	for (idfield in attachmentParam) {
		var conArr = attachmentParam[idfield];
		var ct = conArr["content_type"] ? conArr["content_type"].toLowerCase() : "application/unknown";
		var con = conArr["content"];
		if (ct.search(/text\//) != -1 && con != null) {
			if (ct.search(/text\/plain/) != -1) {
				var tmpcnn=(configGetKey("mail.emoticons") ? replaceSmilies(con) : con);
				tmpcnn=replaceSpaces(tmpcnn);
				cnn += "<div class=\"plainTextContent\">" + tmpcnn + "</div>";
			} else { 
				cnn += "<div>" + con + "</div>";
			}			
		} else {	
			if(conArr["filename"]) {
				attachments.push(conArr);				
				
				var aimg = getMimeImage(ct).match(/empty.png/g) ? getFullImgSrc("img/mail/attachment.gif") : getMimeImage(ct.toLowerCase());
                attachExists = true;
                
                var filename = String(conArr.filename),
                    filenameAbbr = filename.length >= 30 ? filename.substr(0, 27) + "..." : filename;
                    
                var oDOMDiv = newnode("div", { MozUserSelect: "none" }, { className: "mailDetailAttachmentsCont" },[
				  newnode("img", { }, { src: aimg, padding: "3px" }),
				  //#. Displayed label for attachments
				  //#. %1$s is the file name.
				  //#. %2$s is the file size.
				  //#, c-format
                  newnode("span", { }, { title: filename, className: "nothing" },
                      [ document.createTextNode(format(_(" %1$s (%2$s) "), 
                          filenameAbbr, bytesToString(conArr.size, 0)))
                      ])
                ]); 
                // prevent text selection on dbl click
                oDOMDiv.onselectstart = function() { return false; };
                (function(selAttach) {
                	var wrapper = function(e) {
                		selectAttachment(selAttach, (Mac ? e.metaKey : e.ctrlKey), false);                        		
                	};
                    addDOMEvent(oDOMDiv, "click", wrapper);
                    addDOMEvent(oDOMDiv, "dblclick", function(e) { 
                        openAttachment("OPEN");
                    });
                    addDOMEvent(oDOMDiv, "contextmenu", function(e) {
                        stopEvent(e);
                        selectAttachment(selAttach, false, true);
                        globalContextMenus.attachments.display(
                            e.clientX, e.clientY);
                    });                            
                    if (menucountsubselected == 0) {
                    	selectAttachment(selAttach, false, false);
                    	menucountsubselected = 1;
                    }
                })({ node: oDOMDiv, data: conArr}); 
                mda.appendChild(oDOMDiv);
			} else {
				removeChildNodes(mda);
			}
		}		
	}
	detailmessage["message_text"]=cnn;
	
	if(nested_msgs && nested_msgs != "") {	
		for(var nMessage = 0; nMessage < nested_msgs.length; nMessage++) {
			(function(o) {
				var oNestedMessage = new Array(nested_msgs[o]);
				attachments.push({ filename: nested_msgs[o].filename || nested_msgs[o].subject, content_type: "message/rfc822", size: nested_msgs[o].size });
				var textAttachment = newtext(nested_msgs[o].filename || nested_msgs[o].subject || "message/rfc822 Part" );
				var blank = document.createTextNode(" ");
				var oDOMDiv = newnode("div", { MozUserSelect: "none" }, { className: "mailDetailAttachmentsCont" },
					[ newnode("img",0,{ src: getFullImgSrc("img/mail/unread.gif"), align: "top", title: textAttachment.data, padding: "3px"}),
					  	newnode("span",0,{className: "_nothing"},
					  		[ blank ]
					  	),
					  	newnode("span", 0, {className: "_nothing", title: textAttachment.data },
					  		[ textAttachment ]
					  	)
					]
				);
				// prevent text selection on dbl click
                oDOMDiv.onselectstart = function() { return false; };
				(function(oDOMDiv, selNested_msgs) {
					var wrapper = function(e) {
                		selectAttachment({ node: oDOMDiv, data: selNested_msgs.length ? selNested_msgs[0] : selNested_msgs}, (Mac ? e.metaKey : e.ctrlKey), false);
                		detailNestedMessage = selNested_msgs;
						if (!detailNestedMessage.sid) 
							detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
                	};
                    addDOMEvent(oDOMDiv, "click", wrapper);
                    addDOMEvent(oDOMDiv, "contextmenu", function(e) {
                        stopEvent(e);
                        selectAttachment({ node: oDOMDiv, data: selNested_msgs.length ? selNested_msgs[0] : selNested_msgs}, false, true);
                        detailNestedMessage = selNested_msgs;
                        if (!detailNestedMessage.sid) 
                            detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
                        globalContextMenus.attachments.display(e.clientX,
                                                               e.clientY);
                    });
					addDOMEvent(oDOMDiv, "dblclick", function(e) {
						cancelBubbling(e);							
						detailNestedMessage = selNested_msgs;
						if (!detailNestedMessage.sid) 
							detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
						openNestedMessage();	
					});
					if (menucountsubselected == 0) {
                    	selectAttachment({ node: oDOMDiv, data: selNested_msgs.length ? selNested_msgs[0] : selNested_msgs}, false, false);
                    	detailNestedMessage = selNested_msgs;
                    	if (!detailNestedMessage.sid) 
							detailNestedMessage.sid = !isNaN(url["sid"]) ? url["sid"] + nMessage : nMessage;
						menucountsubselected=1;
                    }
				})(oDOMDiv, oNestedMessage);
				mda.appendChild(oDOMDiv);
			})(nMessage);
		}
	}
	
	detailmessage["message_attachments"] = attachments;
    
    // do we have to enable pishing protection?
    $("mail.detail.pop.header.phishing_protection").style.display="none";
    if (configContainsKey("modules.mail.phishingheaders") && message["headers"]) {
        var psa = configGetKey("modules.mail.phishingheaders");
        for (ba in psa) {
            if (message["headers"][psa[ba]]) {
                $("mail.detail.pop.header.phishing_protection").style.display="";
                break;
            }
        }           
    }
    
    // do we have to enable image protection?
    if (message["attachments_html_noimage"] && !message["attachments_html"] && message["blocked_images"]) {
        //TODO CHECK IF EXISTS IMAGE WHICH ARE REMOVED IN NOIMAGE-ATTACHMENTS
        $("mail.detail.pop.header.image_protection").style.display="";
    } else {
        $("mail.detail.pop.header.image_protection").style.display="none";
    }  	
    
	var ih = getFrameElement("mail.detail.pop.detail.content");
    if (ih && ih.document) {
        ih = ih.document;
        ih.open();
        ih.writeln('<html><head><title></title>'
                + '<base href="' + "[protocol]://[hostname][path]newInfoItemHidden.html".format()  + '">'
                + '<link type="text/css" rel="stylesheet" href="' + ox.gui.themePath + "css/iframe.css" + '"></link>'
                + '</head><body>' + cnn + '</body></html>');
        ih.close();
        setTimeout(function() {
            var body = ih.getElementsByTagName("body");
            var colorQuoted = configGetKey("mail.colorquoted") === true;
            try {
                if (body && body.length) {
                    // set margin
                    body[0].style.margin = ".5em";
                    // colored quotes?
                    if (colorQuoted) {
                        body[0].className = "colored-quotes";
                    }
                }
            } catch (e) { }
            
            if (message.headers && message.headers["X-OX-Reminder"]) {
                var object = message.headers["X-OX-Reminder"].split(",");
                if (object.length === 3 && object[1] !== 0) {
                    var node = jQuery(".calendar-buttons", body);
                    if (node.is("div")) {
                        var actions = { 3: _("Tentative"), 2: _("Decline"), 1: _("Accept") };
                        jQuery.each(actions, function(idx, action) {
                            node.append(
                                jQuery("<a>")
                                .attr({ href: "#" })
                                .addClass("action link")
                                .text(action.toString())
                                .click(function(e) {
                                    corewindow.acceptdeny_updateConfirm([{
                                        objectid: object[0],
                                        folder_id: object[1],
                                        module: "calendar"
                                    }], 
                                    idx,
                                    "",
                                    function() {
                                        //deleteMails(message.folder_id, [ message ]);
                                        ox.UINotifier.ok(_("Confirmation status has been saved."));
                                    });
                                    return false;
                                })
                            );
                        });
                        node.show();
                    }
                    delete(node);
                }
                delete(objects);
            }
            
            parseDirectLinksInMails(ih);
        }, 0);
    }
    setTimeout(function () {
        // one line
        var should = "2.25em";
        // reset height to get the real scrollheight
        jQuery($(mda.id)).css({ height: should });
        // measure scroll height
        var scrollHeight = jQuery($(mda.id)).prop("scrollHeight");
        // if scroll height >= 2 lines we resize the attachment div
        if (isNaN(scrollHeight) === false) {
            var height = Math.round(scrollHeight/pxPerEm);
            if (height >= 8)  {
                // 3 rows max
                should = "6.2em";
            } else if (height >= 4) {
                // 2 rows
                should = "4.20em";
            }
        }
        resizeSplit(mda.id, attachExists ? should : "0em");
    }, 0);
}

function selectAttachment(selAttach, multi, context) {
	// check if click is a context click and if click was on already selected item
	for (var i in selectedAttachments) {
		if (selectedAttachments[i].node == selAttach.node && context) {
			return;
		}			
	}
	var nAtt = [], found = false;
	for (var i in selectedAttachments) {
		var attach = selectedAttachments[i];
		if ((!multi || (multi && attach.node == selAttach.node)) && attach.node.className.match(/mailDetailAttachmentsContSel/)) {
			attach.node.className = "mailDetailAttachmentsCont";
			found = (multi && attach.node == selAttach.node);
		} else if (multi) {
			nAtt.push(attach);
		}
	}
	selectedAttachments = nAtt;
	if (!found) {
		selAttach.node.className = "mailDetailAttachmentsContSel background-color-PMG-selection-elements";
		selectedAttachments.push(selAttach);
	}
	triggerEvent("OX_Selected_Nested", false);
	triggerEvent("SubSelected", selectedAttachments.length);
}

function openNestedMessage() {
	// view mail
	var detailMail = ox.api.mail.view({
        params: {
            id: url.id,
            folder: url.folder,
            sid: detailNestedMessage.sid,
            type: "isNestedMessage"
        },
		data: {
            oNestedMessage: detailNestedMessage
        }
    });
	
	
	/*
	var detailMail=corewindow.newWindow("detailMail.html#type=isNestedMessage&id="
		+ encodeURIComponent(url["id"])
		+ "&folder="+ encodeURIComponent(url["folder"])
		+ "&sid=" + encodeURIComponent(detailNestedMessage.sid), getWindowOptions(), 
		{ "folder": encodeURIComponent(url["folder"]), "id": encodeURIComponent(detailNestedMessage.sid) });
	detailMail.window.oNestedMessage = detailNestedMessage;
	detailMail.oNestedMessage = detailNestedMessage;
	if (detailMail) {
		detailMail.focus();
	}*/
}

function openAttachment(action) {	
	var selAttach = selectedAttachments[0].data;
    if (action != "SAVE" && (isVcard(selAttach.content_type) || isIcal(selAttach.content_type))) {
        if (isIcal(selAttach.content_type) && ox.api.config.get("modules.calendar.module", false) === false) {
            triggerEvent("Feature_Not_Available", "modules/mail/open-ical", window);
            return;
        } else if (isVcard(selAttach.content_type) && ox.api.config.get("modules.contacts.module", false) === false) {
            triggerEvent("Feature_Not_Available", "modules/mail/open-vcard", window);
            return;
        }
        showIcalVcard(selAttach);
        return;
    }
	var tF = $("mail.detail.pop.attachment.save");
	var n_url = AjaxRoot + '/mail'
		 + '?action=' + (action == "SAVE" && 
				 selectedAttachments.length > 1 ? "zip_attachments" : "attachment")
		 + '&session=' + session 
		 + '&folder=' + encodeURIComponent(url["folder"])
		 + '&id=' + encodeURIComponent(url["id"]);
	if (action == "OPEN") {
		var attachWin = corewindow.newWindow(
			n_url + "&attachment=" + selAttach.id + "&save=0&filter=1",
			getWindowOptions(null, null, "scrollbars=yes"),
			{ "folder": encodeURIComponent(url["folder"]), 
			  "id": encodeURIComponent(url["id"]), 
			  "attach_id": encodeURIComponent(selAttach.id) },
			window);
		if (attachWin) {
			attachWin.focus();
		}
		try {
			attachWin.document.title = selAttach.filename;
		} catch (e) { }
	} else if (action == "SAVE" && tF && tF.src) {
		var mattachments = "&attachment="
		for (var i in selectedAttachments) {
			mattachments += selectedAttachments[i].data.id + ",";
		}
		tF.src = n_url + mattachments.substring(0, mattachments.length-1) + "&save=1";
	} else {
		//#. %s will be replaced with an internal error code
	    //#, c-format
		triggerEvent("OX_New_Error", 4, format(_("Internal Error: Unable to open the Attachment (%s)."), "MA01"));
	}
}
	
function mail_printDetailMail() {
	corewindow.mail_printDetailMail(detailmessage);
}

function mail_showMailSource() {
	corewindow.oMailFunctions.showMailSource(getMailDetailObject());
}

function callback_error(arg) {
	newServerError(arg);
}

// init window controller

var ctrl = windowController = new WindowController();

ctrl.set("unload", function () {
    if (detailrequest) { 
        OXCache.unregister(detailrequest.uniqueName);
        detailrequest = null;
    }
});

//alloc memory (for leak test; 250 MB)
//window.leak = new Array( 250 * 0xCCCC ).join( 0xFFFFFFFF );
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Matthias Biggeleben <matthias.biggeleben@open-xchange.com>
 * 
 */

/*jslint bitwise: false, nomen: false, onevar: false, plusplus: false, regexp: false, white: true, browser: true, devel: true, evil: true, forin: true, undef: true, eqeqeq: true, immed: true */

/*global ox, jQuery, window, console */

ox.mail = {};

/**
 * Draw contact image based on email address
 */
ox.mail.drawContactImage = (function ($) {
    
    var current = "";
    
    return function (from) {
        // lower case!
        from = current = (from || "").toLowerCase();
        // getting currentpath
        var path = currentpath[1];
        // have to do some ugly mappings for the popup window
        if (path === "detail") {
            path = "detail\\.pop";
        }
        
        // get div and hide it
        var div = $("#mail-" + path + "-image").hide();
        if (div.length) {
            // searching on OXCache is too buggy, so...
            ox.api.contact.searchByMail({
                data: [from],
                success: function (data) {
                    var map, url = null, i, key, contact;
                    // still of interest?
                    if (from === current) {
                        // iterating through response and check for image
                        map = data.map[from] || [];
                        for (i in map) {
                            key = map[i];
                            contact = data.contacts[key];
                            if (contact && contact.image1_url) {
                                url = contact.image1_url + "&width=90&height=90&scaleType=contain";
                                if (url && contact.folder_id === 6) {
                                    // global address-book always first
                                    break;
                                }
                            }
                        }
                        // found an url?
                        if (url) {
                            url += "&width=90&height=90&scaleType=contain";
                            // same url, no redraw required
                            if ($("img", div).attr("src") != url) {
                                // get proper protocol/hostname
                                url = url.replace(/https?:\/\/[^\/]+\//, location.protocol + "//" + location.host + "/");
                                // update
                                div.css({
                                    width: "100px",
                                    height: "80px",
                                    overflow: "hidden",
                                    margin: "0px 5px 0px 10px"
                                });
                                div.empty();
                                div.append(
                                    $("<img/>", {
                                        src: url,
                                        alt: ""
                                    }).css({
                                        width: "auto",
                                        height: "auto",
                                        "float": "right"
                                    })
                                );
                            }
                            div.show();
                            // adjust height
                            var height = $("#mail\\." + path + "\\.detail\\.attachments").height();
                            resizeSplit("mail." + path.replace("\\", "") + ".detail.attachments", height + "px");
                        }
                    }
                }
            });
        }
    };
    
}(jQuery));

defineDeferredFunction(ox.mail, "addAccount", "com.openexchange.mail.accounts");
/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 *
 */

register("Loaded", function() {
    var menu = globalContextMenus.attachments = new ContextMenu();
    var open = new MenuItem(_("Open"), function() {
        triggerEvent(menunestedmessage ? "OX_Attachment_Open_Nested"
                                       : "OX_Attachment_Open");
    });
    open.setIcon("img/menu/attachment_open.gif",
                 "img/menu/attachment_open_d.gif");
    menu.addItem(open);
    
    var save = new MenuItem(_("Save as"),
        function() { triggerEvent('OX_Attachment_Save'); });
    save.setIcon("img/menu/attachment_save.gif",
                 "img/menu/attachment_save_d.gif");
    menu.addItem(save);

    // save in infostore
    var info = new MenuItem(_("Save in InfoStore"),
        function() { triggerEvent('OX_Attachment_SaveInfoStore'); });
    info.setIcon("img/infostore/infostore_save.gif",
                 "img/infostore/infostore_save_d.gif");
    info.disabled_action = function() {
        if (configGetKey("modules.infostore.module")) return false;
        triggerEvent("Feature_Not_Available", "modules/infostore/mail/save_to_infostore", window);
    };
    menu.addItem(info);
    
    menu.onShow = function() {
        var enabled = !menudisableattachment;
        open.setEnabled(enabled);
        save.setEnabled(!menudisableattachment && 
                (activemodule == "mail" || activemodule == "mail_detail"));
        info.setEnabled(enabled && configGetKey("modules.infostore.module"));
        info.setVisible(corewindow.ox.upsell.isVisible("infostore"));
    };
    
    ox.api.window.core.triggerEvent("OX_Context_Menu_Ready", window);
});

var mail_message, selectedAttachments = [];

function showIcalVcard(selAttach) { 
    var isIcal = true;
    if (isVcard(selAttach.content_type)) {
        var ds = "com.openexchange.mail.vcard";
        var dh = { identifier: "com.openexchange.contact.json", args: [] };
        isIcal = false;
    } else {
        var ds = "com.openexchange.mail.ical";
        var dh = { identifier: "com.openexchange.ical.json", args: [] };
    }
    var myObject = { datasource: { args: [
        { "com.openexchange.mail.conversion.fullname": mail_message.folder_id },
        { "com.openexchange.mail.conversion.mailid": mail_message.id },
        { "com.openexchange.mail.conversion.sequenceid": selAttach.id } 
    ], identifier: ds }, datahandler: dh };

    (new JSONX()).put(AjaxRoot + "/conversion?action=convert&session=" +
        session, myObject, null,
        function (reply) {
            if (!isIcal) {
                var data = reply.data[0];
                if (data.mark_as_distributionlist === true) {
                    // open distribution list
                	ox.api.contact.composeDistributionList({
                		data: data
                	});
                } else {
                 // open contact
                    ox.api.contact.compose({
                        data: data
                    });
                }
            } else {
            	// open appointment
            	var data = {
            		oFromMail: reply.data[0],
                    sFromModule: "calendar"
            	};
            	ox.api.calendar.compose({
        			data: data
        		});
            }      
        }
    );
}

function isIcal(ct) {
    return corewindow.ox.upsell.isVisible("calendar") && ct && ct.match(/text\/(x\-)?(calendar|ical)/i); // || ct.match(/application\/(ics)/i);
}
function isVcard(ct) {
    return corewindow.ox.upsell.isVisible("contacts") && ct && ct.match(/text\/(x\-)?(vcard|directory)/i);
}

function createNewContactfromMail(mailAddressObject,folder) {
	function createContact(module,notneeded,object) {
		// open compose dialog with prefilled fields
		ox.api.contact.compose({
			params: jQuery.extend(object || {}, {
				folder: object.folder_id
			})
		});
//		var addParams = "";
//		for (i in object) {
//			addParams += "&"+i+"="+encodeURIComponent(object[i]);
//		}
//		corewindow.openContactPopup('modul=new&folder='+object.folder_id+addParams,'newContact.html');
	}
    corewindow.rightshandler.checkRights("contacts",(folder || configGetKey("folder.contacts")),mailAddressObject,createContact);
}

/**
 * Parse all <a> links within the node and replace any direct link which maches
 * to the current hostname with a new link to the local infostore.
 * @param ih The document node
 */
var hrefregexp = null;
function parseDirectLinksInMails(ih) {
    if (hrefregexp === null) {
        hrefregexp= new RegExp((window.location.protocol+"//"+window.location.host).replace(/^https?:/, "https?:"));
        if (ox.api.config.get("ui.mail.directlinkregexp") != null) {
            hrefregexp= new RegExp(ox.api.config.get("ui.mail.directlinkregexp").format());
        }
    }
    
    if (IE === 7) {
        // IE7 is a load of sh..
        // @todo: remove as soon as IE7 support has been canceled
        // Have to use the old way because IE7 obviously has a problem using replaceWith
        // in combination with jQuery objects :(
        var ahref = ih.getElementsByTagName("a");
        for (var i=0; i < ahref.length;) {
            var link = ahref[i];        
            if (!link.getAttribute("href")) {
                // no valid href, continue
                i++; 
                continue;
            }
            link.removeAttribute("target");  // clean-up target first
            var module = link.href.match(/[#&]m=([^#&]+)/);
            var folder = link.href.match(/[#&]f=([^#&]+)/);
            var id = link.href.match(/[#&]i=([^#&]+)/);
            if (link.href.match(hrefregexp) && module && folder) {
                // ok, seems like we found a direct link pointing to the right ox 
                link.parentNode.insertBefore(newnode("img", { marginRight: "5px"}, 
                        { src: getFullImgSrc("img/menu/close_linking.gif"), align: "absmiddle"},
                        null, (ih.nodeType == 9 ? ih : null)), link);
                link.parentNode.insertBefore(newnode("img", { marginRight: "5px"}, 
                        { src: getFullImgSrc("icons/16/" + module[1] + ".png"), align: "absmiddle"},
                        null, (ih.nodeType == 9 ? ih : null)), link);
                link.style.color="red";
                link.style.textDecoration="underline";
                link.style.cursor="pointer";
                link.removeAttribute("href");
                jQuery(link).text(_("Follow Link...").toString());
                link.onclick = (function(mo, fo, io) {
                         return function(e) { 
                             parent.corewindow.setTimeout(function() { 
                                parent.corewindow.triggerEvent("OX_Direct_Linking", mo, {"folder": fo, "id": io});
                             }, 0);
                             if (e) {
                                stopEvent(e);
                             }
                             return false;
                         }
                     })(module[1], folder[1], id && id[1] ? id[1] : null);  
                              
            } else if (link.getAttribute("href").match(new RegExp("^(" + window.location.href + ")?#")) != null) {
                // due to an mozilla bug we run into problems with anchors in dynamic written pages 
                // mozilla doesn't recognize that and try to load the whole page instead
                // using this hack to jump to the anchors manually
                for (var ia=0; ia < ih.anchors.length; ia++) {
                    if (link.getAttribute("href").match(new RegExp("^(" + window.location.href + ")?#"+ih.anchors[ia].name))) {
                        link.setAttribute("onclick", "function() { return false; }");
                        link.onclick = (function(myDoc, myAnchor) {
                            return function(e) {
                                 myAnchor.scrollIntoView(true);
                                 return false;
                            };
                        })(ih, ih.anchors[ia]);
                        break;
                    }
                }
            } else {
                // any other links should always open in a new window
                link.target = "_blank";
            }
          i++;
        }
        
    } else {
        // the preferred way working with
        // every other smart browser :-)
        jQuery("a[href]", ih).each(function(index) {
            var link = jQuery(this);
            
            var href = link.attr("href");
            var module = href.match(/[#&]m=([^#&]+)/);
            var folder = href.match(/[#&]f=([^#&]+)/);
            var id = href.match(/[#&]i=([^#&]+)/);
            if (href.match(hrefregexp) && module && folder) {
                var object = { module: module[1], folder: folder[1], id: (id && id.length ? id[1] : null) };
                if (object.module === "task") {
                    object.module = "tasks";
                }
                link.replaceWith(
                        jQuery("<div/>").css({
                            color: "red",
                            textDecoration: "underline",
                            padding: "5px 20px 5px 5px",
                            display: "inline-block",
                            cursor: "pointer",
                            border: "1px solid silver",
                            MozBorderRadius: "5px",
                            WebkitBorderRadius: "5px",
                            borderRadius: "5px 5px 5px 5px"
                        }).append(
                                jQuery("<img/>")
                                .attr({ src: getFullImgSrc("img/menu/close_linking.gif"), align: "absmiddle" })
                                .css({ paddingRight: "10px" })
                        ).append(
                                jQuery("<img/>")
                                .attr({ src: getFullImgSrc("icons/16/" + object.module + ".png"), align: "absmiddle" })
                                .css({ paddingRight: "5px" })
                        ).append(
                                jQuery("<span/>").text(_("Follow Link...").toString())
                        ).click(
                                function () {
                                    parent.corewindow.triggerEvent("OX_Direct_Linking", 
                                            object.module, { "folder": object.folder, "id": object.id });
                                }
                        )
                );
                link.removeAttr("target");
                
            } else if (href.match(new RegExp("^(" + window.location.href + ")?#")) != null) {
                // due to an mozilla bug we run into problems with anchors in dynamic written pages 
                // mozilla doesn't recognize that and try to load the whole page instead
                // using this hack to jump to the anchors manually
                jQuery.each(ih.anchors, function(index, anchor) {
                    if (href.match(new RegExp("^(" + window.location.href + ")?#" + anchor.name))) {
                        link.bind("click", { anchor: anchor }, function(e) {
                            e.data.anchor.scrollIntoView(true);
                            return false;
                        });
                    }
                });
                
            } else if ((href.match(/^mailto:(.+)/) || []).length === 2) {
                var params = href.match(/^mailto:(.+)/)[1];
                var obj = { to: params.split("?")[0] };
                if (params.split("?").length > 1) {
                    obj = jQuery.extend(obj, ox.util.deserialize(params.split("?")[1]));
                    if (obj.body) {
                        obj.mailtext = obj.body.replace("\r\n", "<br>");
                        delete obj.body;
                    }
                }
                link.bind("click", { data: obj }, function(e) {
                    ox.api.mail.compose( { data: e.data.data });
                    return false;
                });
            } else {
                link.attr("target", "_blank");
            };
        });
    }

	corewindow.triggerEvent("ProcessMailContent", ih);
	return ih;
}

function getMailAccountIdByFolder(folder) {	
	var addr = null;
	if (String(folder).match(/^default(\d+)?/) != null) {
		var t = String(folder).match(/^default(\d+)?/)[0];
		addr = t.substring("default".length, t.length);
	}
	return addr;
}

function getMailAccountEmailAddress(id) {
	var addr = null, data;
	if ((data = ox.api.account.get(id))) {
		addr = data.primary_address;
	}
	return addr;
}

ox.mail.itip = {
    options: {
        // shown as
        n_shownAs: [ _("Reserved"), _("Temporary"), _("Absent"), _("Free") ],
        n_shownAsClass: [ "reserved", "temporary", "absent", "free" ],
        n_confirm: ["", "\u2713", "x", "?"],
        n_confirmClass: ["", "accepted", "declined", "tentative"],
        parseRegExp: /;\s*method\s*=\s*(?:([-!#-'*+.0-9A-Z^-~]*)|"([\cA-\b\cK\cL\cN-\x1f!#-[\]-\x7f]*)")/i
    },
    parseMessage: function(options) {
        
        var message = options.message,
            cb = options.callback,
            iMIPAttachments = (message.attachments_html
                    || message.attachments_html_noimage || message.attachments_plain);
        if (iMIPAttachments && corewindow.ox.upsell.isVisible("calendar")) {
            var imipObject = {};
            var join = new Join(function() {
                cb(isEmpty(imipObject) ? undefined : imipObject);
            });
            var last = join.add();
            
            function analyze(iMIPAttachment) {
                (new JSONX()).put(
                    AjaxRoot + "/calendar/itip?action=analyze&dataSource=com.openexchange.mail.ical&descriptionFormat=html&session=" + session,
                    { "com.openexchange.mail.conversion.fullname": message.folder_id ,
                     "com.openexchange.mail.conversion.mailid": message.id,
                     "com.openexchange.mail.conversion.sequenceid": iMIPAttachment.id
                    }, 
                    null,
                    join.add(function(reply) {
                        if (reply && reply.data.length) {
                            if (("annotations" in reply.data[0]) 
                                    && !("appointment" in reply.data[0].annotations)) {
                                // todo: more than one messages are possible!!!
                                options.message.imipWarnings = [ reply.data[0].annotations[0].message ];
                            } else {
                                imipObject.iMIPAttachment = iMIPAttachment;
                                imipObject.data = reply.data;
                                imipObject.message = message;
                            }
                        }
                    }),
                    join.alt(function(reply) {
                        // ignore errors
                        return true;
                    })
                );
            }
            
            // check for imip / itip attachment
            for (var i = 0; i < iMIPAttachments.length; i++) {
                var match = ox.mail.itip.options.parseRegExp.exec(iMIPAttachments[i].content_type);
                if (match) {
                    analyze(iMIPAttachments[i]);
                    break;
                }
            }
            
            last();
        } else {
            cb();
        }
    },
    
    paint: function(options) {
        var node = options.node.empty();
        var data = options.data[0];
        var message = options.message;
        var iMIPAttachment = options.iMIPAttachment;
        
        function getDateInterval(data) {
            var length = (data.end_date - data.start_date) / 864e5 >> 0;
            if (data.full_time && length > 1) {
                // \u2013= &ndash;
                return formatDate(data.start_date, "date") + " \u2013 " + formatDate(data.end_date - 1, "date");
            } else {
                return formatDate(data.start_date, "date");
            }
        }
        
        function getTimeInterval(data) {
            var length;
            if (data.full_time) {
                length = (data.end_date - data.start_date) / 864e5 >> 0;
                return length <= 1 ? "Whole day" : length + " days";
            } else {
                return formatDate(data.start_date, "time") + " \u2013 " + formatDate(data.end_date, "time");
            }
        }
        
        function getRecurrenceString(data) {
            var tmp = new SeriesObject(data, true);
            var recurrenceString = tmp.getSeriesString();
            return getDateInterval(data)  + (recurrenceString != "" ? " \u2013 " + recurrenceString : "");
        }
        
        function getNote(data) {
            return jQuery.trim(data.note || "")
                .replace(/\n{3,}/g, "\n\n")
                .replace(/</g, "&lt;")
                .replace(/(https?\:\/\/\S+)/g, '<a href="$1" target="_blank">$1</a>');
        }
        
        function getConfirmations (data) {
            var hash = {};
            // internal users
            jQuery.each(data.users || [], function (i, obj) {
                hash[String(obj.id)] = {
                    status: obj.confirmation || 0,
                    comment: obj.confirmmessage || ""
                };
            });
            // external users
            jQuery.each(data.confirmations || [], function (i, obj) {
                hash[obj.mail] = {
                    status: obj.status || 0,
                    comment: obj.confirmmessage || ""
                };
            });
            return hash;
        }
        
        function getConfirmationSymbol(status) {
            return ox.mail.itip.options.n_confirm[status || 0];
        }
        function getConfirmationClass(status) {
            return ox.mail.itip.options.n_confirmClass[status || 0];
        }
        
        function getShownAsClass(data) {
            return ox.mail.itip.options.n_shownAsClass[(data.shown_as || 1) - 1];
        }
        
        function getShownAs(data) {
            return ox.mail.itip.options.n_shownAs[(data.shown_as || 1) - 1];
        }
        
        var actions = { };
        for (var i=data.actions.length; i >= 0; i--) {
            var action = data.actions[i];
            switch(action) {
                case "accept":
                    actions["accept"] = _("Accept");
                    break;
                case "decline":
                    actions["decline"] = _("Decline");
                    break;
                case "tentative":
                    actions["tentative"] = _("Tentative");
                    break;
                case "delete":
                    actions["delete"] = _("Delete");
                    break;
                case "create":
                    actions["create"] = _("Create");
                    break;
                case "update":
                    actions["update"] = _("Update");
                    break;
                case "accept_party_crasher":
                    actions["accept_party_crasher"] = _("Accept extra participant");
                    break;
                case "accept_and_replace":
                    actions["accept_and_replace"] = _("Accept and replace exception");
                    break;
                case "accept_and_ignore_conflicts":
                    actions["accept_and_ignore_conflicts"] = _("Accept and ignore conflicts");
                    break;
                case "refresh":
                    actions["refresh"] = _("Ask for new invitation");
                    break;
                case "send_appointment":
                    actions["send_appointment"] = _("Invite again");
                    break;
                case "declinecounter":
                    actions["declinecounter"] = _("Decline counter proposal");
                    break;
            }
        }
        var actual = {};
        if (data.annotations) {
            // it's a 
            actual = data.annotations[0].appointment;
        } else if (data.changes[0].deletedAppointment) {
            // it's a deletion
            actual = data.changes[0].deletedAppointment;
        } else {
            // new or changed
            actual = data.changes[0].newAppointment;
        }
        
        // append introduction
        if ((data.changes || [[]])[0].introduction) {
            node.append(
                jQuery("<div>").addClass("changes")
                .css({ marginTop: 0 })
                .html(data.changes[0].introduction)
            );
        }
        
        node.append(
            jQuery("<div>").addClass("date")
            .append(
                jQuery("<div>").addClass("interval").text(getTimeInterval(actual))
            ).append(
                jQuery("<div>").addClass("day").text(getRecurrenceString(actual))
            )
        ).append(
            jQuery("<div>").addClass("title clear-title").text(actual.title || "")
        ).append(
            jQuery("<div>").addClass("location").text(actual.location || "\u00A0")
        ).append(
            function(index, html) {
                try {
                    var node = jQuery("<div>").addClass("actions");
                    jQuery.each(actions, function(idx, action) {
                        var tmp = jQuery("<a>")
                            .attr({ href: "#" })
                            .addClass("action link")
                            .text(action.toString())
                            .click(function(e) {
                                (new JSONX()).put(AjaxRoot + "/calendar/itip?action=" + idx 
                                        + "&dataSource=com.openexchange.mail.ical&session=" + session,
                                    { "com.openexchange.mail.conversion.fullname": message.folder_id ,
                                      "com.openexchange.mail.conversion.mailid": message.id,
                                      "com.openexchange.mail.conversion.sequenceid": iMIPAttachment.id
                                    }, 
                                    null, 
                                    function(data) {
                                        // remove message if deletion was ok
                                        if (data) {
                                            //deleteMails(message.folder_id, [ message ]);
                                            
                                            //#. Status message will be shown when the confirmation status has been saved
                                            //#. after clicking on any confirmation button in an itip mail
                                            ox.UINotifier.ok(_("Confirmation status has been saved."));
                                        }
                                    }
                                );
                                return false;
                            });
                        node.append(tmp);
                        delete(tmp);
                    });
                    return node;
                } catch (e) {
                    // ignore
                } finally {
                    delete(node);
                }
            }
        ).append(
            function(index, html) {
                try {
                    var node = jQuery();
                    if (data.changes[0].diffDescription) {
                        node = jQuery("<div>").addClass("changes");
                        jQuery.each(data.changes[0].diffDescription, function(index, diff) {
                            node.append(jQuery("<div>").addClass("change").html(diff));
                        });
                    }
                    return node;
                } catch (e) {
                    // ignore
                } finally {
                    delete(node);
                }
            }
        ).append(
            jQuery("<div>").addClass("note").html(getNote(actual))
        ).append(
            function(index, html) {
                
                // iterate through participants
                function drawParticipant(obj, hash) {
                    // initialize vars
                    var key = obj.mail || obj.id,
                        conf = hash[key] || { status: 0, comment: "" },
                        confirm = getConfirmationSymbol(conf.status),
                        statusClass = getConfirmationClass(conf.status),
                        isPerson = hash[key] || obj.folder_id,
                        personClass = isPerson ? "person" : "",
                        display_name, name, node, name_lc,
                        mail_lc = String(obj.mail).toLowerCase();
                    // external participant?
                    if (obj.type === 5) {
                        // beautify
                        name_lc = String(obj.display_name).toLowerCase();
                        if (name_lc === mail_lc) {
                            name = display_name = mail_lc;
                        } else {
                            name = obj.display_name ? obj.display_name + " <" + mail_lc + ">" : mail_lc;
                            display_name = obj.display_name || mail_lc;
                        }
                    } else {
                        name = display_name = obj.display_name || String(obj.mail).toLowerCase();
                    }
                    node = jQuery("<div>").addClass("participant")
                        .append(jQuery("<span>").addClass(personClass).text(name))
                        .append(jQuery("<span>").addClass("status " + statusClass).text(" " + confirm));
                    // has confirmation comment?
                    if (conf.comment !== "") {
                        node.append(jQuery("<span>").addClass("comment").text(conf.comment));
                    }
                    return node;
                }
                
                var list = actual.participants || [], i = list.length,
                    participants = i > 1 ? jQuery("<div>").addClass("participants") : jQuery(),
                    confirmations = {};

                // has more than one participant?
                if (i > 1) {
                    confirmations = getConfirmations(actual);
                    
                    var solvedUsers = (function () {
                        var tmp = { external: [], internal: [] };
                        jQuery.each(list, function(i, obj) {
                            tmp[ obj.type === 5 ? "external" : "internal" ].push(obj);
                        });
                        return tmp;
                    })();
                    
                    function draw(users) {
                        // Evil :( Map cache result to internal object
                        for (var i in users) {
                            var user = users[i];
                            for (var ia=0; ia < (solvedUsers.internal || []).length; ia++) {
                                var comp = user.type + "." + (user.mail || user.id);
                                var user2 = solvedUsers.internal[ia];
                                if (user2.type + "." + (user2.mail || user2.id) === comp) {
                                    if (user.display_name) {
                                        user2.display_name = user.display_name;
                                    }
                                    if (user.email1 && user.type !== 1) {
                                        user2.mail = user.email1;
                                    }
                                }
                            }
                        }
                        
                        participants.append(jQuery("<div>")
                                .addClass("label").text("Participants"));
    
                        var plist = jQuery("<div>").addClass("participant-list").appendTo(participants);
                        
                        // internal users
                        jQuery.each(solvedUsers.internal, function(idx, obj) {
                            if (obj.type === 1) {
                                plist.append(drawParticipant(obj, confirmations));
                            }
                        });
                        
                        // external users
                        jQuery.each(solvedUsers.external, function(idx, obj) {
                            plist.append(drawParticipant(obj, confirmations));
                        });
                        
                        // groups
//                        jQuery.each(solvedUsers.internal, function(idx, obj) {
//                            if (obj.type === 2) {
//                                plist.append(drawParticipant(obj, confirmations));
//                            }
//                        });
                        
                        // internal users
                        jQuery.each(solvedUsers.internal, function(idx, obj) {
                            if (obj.type === 3) {
                                plist.append(drawParticipant(obj, confirmations));
                            }
                        });
                        
                    }
                   
                    internalCache.getObjects(solvedUsers.internal || [], draw);
                    return participants;
                }
            }
        ).append(
            function(index, html) {
                try {
                    var details = jQuery("<div>")
                        .append(
                            jQuery("<div>").addClass("label").text("Details")
                        ).append(
                                jQuery("<span>").addClass("detail-label").text(_("Show as").toString() + ":\u00A0")
                        ).append(
                            jQuery("<span>").addClass("detail shown_as " + getShownAsClass(actual)).text("\u00A0")
                        ).append(
                            jQuery("<span>").addClass("detail shown_as_label " + getShownAsClass(actual)).text(" " + getShownAs(actual))
                        ).append(
                                jQuery("<br>")
                        ).append(
                            function(index, html) {
                                try {
                                    var node = jQuery();
                                    var text = jQuery();
                                    if (actual.creation_date) {
                                        node = jQuery("<div>").append(
                                            jQuery("<span>").addClass("detail-label").text(_("Created").toString() + ":\u00A0")
                                        ).append(
                                            text = jQuery("<span>").addClass("detail").text(formatDate(actual.creation_date, "datetime").toString())
                                        );
                                        if (actual.created_by) {
                                            internalCache.getUsers([ actual.created_by  ], function(data) {
                                                text.text(text.text() + " - "  + data[ actual.created_by ].display_name);
                                            });
                                        }
                                    }
                                    return node;
                                } catch (e) { 
                                    // ignore
                                } finally {
                                    delete(node);
                                    delete(text);
                                }
                            }
                        );
                    return details;
                } catch (e) {
                    // ignore
                } finally{
                    delete(details);
                }
            }
        );
        
        if (options.success) {
            options.success();
        }
        
        // clean-up
        delete(iMIPAttachment);
        delete(message);
        delete(data);
        delete(node);
    }
};


fileloaded();
