var init = 
{"images":{"addressbookNewEmail-h-i":"themes/default/img/x.png","treeDialogNewMail-h-i":"themes/default/img/x.png","alert_window-h-i":"themes/default/img/x.png","create_window-h-i":"themes/default/img/x.png","conflict_window-h-i":"themes/default/img/x.png","window_categories-h-i":"themes/default/img/x.png","window_categories_new-h-i":"themes/default/img/x.png","attachPopupTemplate-h-i":"themes/default/img/x.png","attachInfostorePopupTemplate-h-i":"themes/default/img/x.png"},"hide":{},"movable":["addressbookNewEmail-h","treeDialogNewMail-h","alert_window-h","create_window-h","conflict_window-h","window_categories-h","window_categories_new-h","attachPopupTemplate-h","attachInfostorePopupTemplate-h"],"size":[{"id":"all_of_menu","align":"top","size":"11em","resize":"static","children":[]},{"id":"mainarea","align":"stretch","children":[{"id":"window-header-decorator","align":"top","size":"14px","border":"0px 0px 1px 0px","children":[]},{"id":"d59e13","align":"bottom","size":"2.4em","children":[]},{"id":"d59e22","align":"stretch","children":[{"id":"d59e23","align":"top","margin":"5px 0px 0px 4px","children":[]},{"id":"newMailAttachmentDiv","align":"bottom","size":"0em","resize":"static","children":[]},{"id":"mailsplitbottom","align":"stretch","border":"1px 0px 1px 0px","children":[]}]}]},,],"help":{},"min":{},"max":{},"split":{},"i18n":{"d59e20":"","d59e30":"","d59e34":"","addAddressTo-button":"","addAddressCc-button":"","addAddressBcc-button":"","d59e46":"","d59e55":"","d59e58":"","d59e61":"","addressbookNewEmail-h-i":"alt,title","addressbookNewEmail-h-c":"","d59e73":"","d59e77-button":"","d59e81":"","d59e84":"","but_folder-button":"","d59e94":"","d59e97-button":"","d59e102-button":"","d59e107-button":"","d59e113-button":"","d59e114-button":"","d59e115-button":"","treeDialogNewMail-h-i":"alt,title","treeDialogNewMail-h-c":"","alert_window-h-i":"alt,title","alert_window-h-c":"","d20e8":"","alert_window_cancel-button":"","alert_window_nocomment-button":"","alert_window_no-button":"","alert_window_yes-button":"","alert_window_ok-button":"","alert_window_appointment-button":"","alert_window_series-button":"","alert_window_edit-button":"","alert_window_continue-button":"","alert_window_save-button":"","create_window-h-i":"alt,title","create_window-h-c":"","create_window_cancel-button":"","create_window_nocomment-button":"","create_window_advanced-button":"","create_window_ok-button":"","conflict_window-h-i":"alt,title","conflict_window-h-c":"","d20e28":"","conflict_recurrence_msg":"","d20e42":"","d20e44":"","d20e46":"","d20e48":"","d20e53-button":"","conflict_window_ignore-button":"","window_categories-h-i":"alt,title","window_categories-h-c":"","d20e63":"","categories_sel_but_new-button":"","categories_sel_but_rename-button":"","categories_sel_but_delete-button":"","d20e69":"","d20e72-button":"","d20e73-button":"","window_categories_new-h-i":"alt,title","window_categories_new-h-c":"","d20e79":"","d20e82":"","categories_new_but_cancel-button":"","categories_new_but_ok-button":"","attachPopupTemplate-h-i":"alt,title","attachPopupTemplate-h-c":"","d53e6":"","d53e8":"","d53e14-button":"","d53e16-button":"","d53e17-button":"","attachInfostorePopupTemplate-h-i":"alt,title","attachInfostorePopupTemplate-h-c":"","d53e30-button":"","d53e31-button":""}};
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * 
 */

function AutoComplete(oText, oDiv, nMaxSize, minChars, timeout) {    
    this.oText = oText;
    this.oDiv = oDiv;
    // minium characters a user has to enter before search will be executed
    this.minChars = minChars && minChars >= 2 ? minChars : 2;
    // maximum numbers of results which will be displayed
    this.nMaxSize = nMaxSize || 20;
    // timeout after the search results will be displayed
    this.timeout = timeout || 500;
    this.searchPattern = new Object();
    this.cancelRequest = false;
    
    /* to work with teamview (i.e. other use cases than new mail) */
    this.autoAdjustHeight = true;
    this.showDisplayNamesOnly = false;
    this.showSystemUsersOnly = false;
    this.includeResources = false;
    this.nameIndex = {};
    
    /*-- private variables --*/
    this.tt;
    this.cache = new AutoCompleteCache();
    this.currSelected = 0;
    this.currEntries = 0;
    var Self = this;
            
    // attach handlers to the text-box
    oText.AutoComplete = this;
    oText.onkeydown = AutoComplete.prototype.onTextChange;
    jQuery(oText).change(function(evt) {
        Self.onTextBlur(evt);
    });
    oDiv.onmousedown = function() { return false; };
}

AutoComplete.prototype.onTextBlur = function () {
	this.cancelRequest=true;
    this.clear();
    // remove last ending , if exists
    var value = trimStr(this.oText.value);
    if (value.charAt(value.length-1) == ",") {
       this.oText.value = value.substring(0, value.length-1);
    }
};

AutoComplete.prototype.onTextChange = function(evt) {
    var parent = this;
    if (!evt) evt = event;
    a = evt.keyCode;    
   this.AutoComplete.cancelRequest = false;
    switch (a) {
        case 27: //ESC
            parent.AutoComplete.clear();
            stopEvent(evt); 
            return false;
        case 38:    // UP
            parent.AutoComplete.keyUpDown(false);
            break;
        case 40:    // DOWN
            parent.AutoComplete.keyUpDown(true);
            break;
        case 16: case 17: case 18: case 35: case 36: case 37: case 39: 
           // ignore: SHIFT / CTRL / ALT / POS1 / END / LEFT / RIGHT;
            return true;
        case 13: case 9: // ENTER
            return parent.AutoComplete.keyEnter(a);
        default:
            setTimeout(function() {
                    var st = getCurrStr(parent.AutoComplete.oText.value, parent.AutoComplete.oText);
                    if (getSearchPatternLength(st) >= parent.AutoComplete.minChars) {
                        parent.AutoComplete.search(trimStr(st));
                    } else {
                        parent.AutoComplete.clear();
                    }
                },50);
            return;
    }
    if (this.AutoComplete.visible) stopEvent(evt);
};

AutoComplete.prototype.onDivMouseDown = function() {
    var st = this.AutoComplete.oText.scrollTop;
    this.AutoComplete.onSelect(this, st);
    this.AutoComplete.clear();
    return true;
};

AutoComplete.prototype.onDivMouseOver = function() {
    this.className = "PopupEntryDivActive border-color-PMG-selection-elements";
    this.AutoComplete.oText.currSelected = this.getAttribute("ono");
};

AutoComplete.prototype.onDivMouseOut = function() {
    this.className = "PopupEntryDiv";
};

AutoComplete.prototype.keyUpDown = function (up) {
    // top or bottom has been reached, so nothing to do    
    if ((up && this.currSelected >= this.currEntries) || (!up && this.currSelected == 0)) {
        return;
    }

    // disable old selection
    document.getElementById("ac_" + this.currSelected).className = "PopupEntryDiv";
    if (up)
        this.currSelected++;
    else
        this.currSelected--;
    
    // select new row
    var elem = document.getElementById("ac_" + this.currSelected);
    if (elem) {
        elem.className = "PopupEntryDivActive border-color-PMG-selection-elements";
        if (this.oDiv.scrollTop + this.oDiv.clientHeight
            < elem.offsetTop + elem.offsetHeight)
        {
            this.oDiv.scrollTop = elem.offsetTop + elem.offsetHeight
                - this.oDiv.clientHeight;
        }
        if (this.oDiv.scrollTop > elem.offsetTop)
            this.oDiv.scrollTop = elem.offsetTop;
    }
};

AutoComplete.prototype.keyEnter = function () {
    var _rb = true;
    var elem = document.getElementById("ac_" + this.currSelected);
    if (elem) {
        var st = this.oText.scrollTop;
        this.onSelect(elem, st);
        _rb = false;
    }
    this.clear();
    return _rb;
};

AutoComplete.prototype.onSelect = function (elem, st) {
    this.oText.value=replaceCurrStr(this.oText.value, this.oText, elem.getAttribute("oval"));
    setSelRange(this.oText, this.oText.value.length, this.oText.value.length, st);
};

AutoComplete.prototype.clear = function () {
    removeChildNodes(this.oDiv);
    if (this.autoAdjustHeight) {
        this.oDiv.style.height = "";
    }
    this.oDiv.style.visibility = "hidden";    
    this.currSelected = 0;
    this.currEntries = 0;
    this.visible = false;
};

AutoComplete.prototype.enableDiv = function() {
    // positioning the div and enable it
    var oTop = getAbsolutePositionTop(this.oText) + this.oText.offsetHeight;
    var oLeft = getAbsolutePositionLeft(this.oText);
    this.oDiv.style.top = oTop + "px";
    this.oDiv.style.left =  oLeft + "px";
    this.oDiv.scrollTop = "0";
    this.oDiv.style.visibility = "visible";
    this.visible = true;
};

AutoComplete.prototype.onchange = function(txt) {    
    // get all the matching strings from the AutoCompleteCache
    var aStr = new Array();
    this.cache.getResults(txt, aStr);
    this.currSelected = 0;

    // count the number of strings that match the text-box value
    var nCount = aStr.length > this.nMaxSize ? this.nMaxSize : aStr.length;
    this.currEntries = nCount-1;
            
    // if a suitable number then show the popup-div
    if (!this.cancelRequest && this.nMaxSize != -1 && nCount > 0) {
        //!(nCount == 1 && trimStr(txt) == aStr[0])
        
        // clear the popup-div.
        while ( this.oDiv.hasChildNodes() )
            this.oDiv.removeChild(this.oDiv.firstChild);
        
        for (var i = 0; i < nCount; i++ ) {
            var nobj = aStr[i];
            for (var ab in nobj) {                
                var myObj = nobj[ab];
                
                // add each string to the popup-div
                var nDiv = newnode("div", 
                    { overflow: "hidden", whiteSpace: "nowrap" }, null);
                getParsedNode(txt, ab, nDiv);
                nDiv.id = "ac_" + i;
                nDiv.setAttribute("oval", myObj.join(","));
                nDiv.setAttribute("ono", ab);
                nDiv.onmousedown = AutoComplete.prototype.onDivMouseDown;
                nDiv.onmouseover = AutoComplete.prototype.onDivMouseOver;
                nDiv.onmouseout = AutoComplete.prototype.onDivMouseOut;
                if (this.currSelected == i)
                    nDiv.className = "PopupEntryDivActive border-color-PMG-selection-elements";
                else 
                    nDiv.className = "PopupEntryDiv";
                nDiv.AutoComplete = this;
                this.oDiv.appendChild(nDiv);    
            }
        }
        //this.oDiv.style.height = "20em";
        if (this.autoAdjustHeight && this.oDiv.offsetHeight > 160) {
            this.oDiv.style.height = "160px";
        }
        this.enableDiv();
    } else {
        this.clear();
    }
};

AutoComplete.prototype.search = function(str) {
    var parent = this;
    
    // already in cache?
    if (this.cache.contains(trimStr(str)))
       return;
    
    for (var e in this.searchPattern) {
        var sp = new RegExp("^" + escapeRegExp(e));
        if (sp && str.match(sp)) {
            this.onchange(str);
            return;
        }
    }    
        
    // clear timer if already set
    if (this.tt) 
        window.clearTimeout(this.tt);
        
    if (this.oDiv.firstChild) 
        this.oDiv.removeChild(this.oDiv.firstChild);

    this.oDiv.appendChild(
        newnode("div", { textAlign: "center", width: "100%" }, null, [ 
            newnode("img",null,{src: getFullImgSrc("img/ox_animated_withoutbg.gif")},[])
        ])
    );        
        
    // set new timer with given timout
    this.tt = window.setTimeout(function() {
        
        if (parent.cancelRequest) return; // request aborted, so leave    
        parent.enableDiv();
        
        // fire-up search
        var pattern = str;
        if (pattern.charAt(pattern.length - 1) != "*") pattern += "*";
        
        ox.api.folder.exists({
            folder: "6",
            success: function (GAL) {
            
                // in which folder should be searched for autocomplete
                var allFolder = GAL ? [6] : [];
                allFolder.push(configGetKey("folder.contacts"));
                if (configGetKey("modules.mail.contactCollectFolder")) {
                    allFolder.push(configGetKey("modules.mail.contactCollectFolder"));
                }
                
                // default folder
                var defaultSearchFolder = configGetKey("folder.contacts") || 6;
                
                // create multiple request
                var multiple = [{
                    // search contacts
                    "action": "search",
                    "module": "contacts",
                    "columns": "1,500,555,556,557,524,602,592,20,524",
                    "sort": "609",
                    "data": {
                        display_name: pattern, email1: pattern,
                        email2: pattern, email3: pattern, last_name: pattern,
                        first_name: pattern, folder: allFolder, orSearch: true,
                        emailAutoComplete: true
                    }
                }];
                
                if (configGetKey("language") == "ja_JP") {
                    multiple[0].data.yomiFirstName = pattern;
                    multiple[0].data.yomiLastName = pattern;
                }
                
                if (configGetKey("modules.contacts.allFoldersForAutoComplete") == true) {
                    delete(multiple[0].data.folder);
                }
                
                // search for resource?
                if (parent.includeResources) {
                    multiple.push({
                        "action": "search",
                        "module": "resource",
                        "data": {
                            "pattern": pattern,
                            "folder": defaultSearchFolder
                        }
                    });
                }
    
                (new JSONX()).put(AjaxRoot + "/multiple?session=" + session, multiple, null, function(cb) {
                    // no response?
                    if (!cb || !cb.length) {
                        parent.clear();
                        return;
                    }
    
                    // process contacts
                    if (cb[0].error) {
                        newServerError(4, cb[0]);
                    } else {
                        var response = cb[0];
                        for (var i = 0; i < response.data.length; i++) {
                            var data = response.data[i];
                            // system users only? (folder_id=6)
                            if (parent.showSystemUsersOnly && data[8] != 6) continue;
                            // address prefix
                            var pn = data[1] || "";
                            // fill name cache (format: folder.id)
                            var name = quotePersonalAddr(pn);
                            var objectData = {
                                    type: 1, // user
                                    id: data[9], // internal user id
                                    folder: data[8],
                                    display_name: name
                            };
                            // names only?
                            if (parent.showDisplayNamesOnly) {
                                // add
                                var mailAddresses = [];
                                if (data[2]) mailAddresses.push("<"+data[2]+">");
                                if (data[3]) mailAddresses.push("<"+data[3]+">");
                                if (data[4]) mailAddresses.push("<"+data[4]+">");
                                var key = name + " " + mailAddresses.join(", ");
                                parent.cache.add(key, [key]);
                                parent.nameIndex[key] = objectData;
                            }
                            // distribution list?
                            else if (data[6] && data[7]) {
                                var addresses = [];
                                for (var ib in data[7]) {
                                    addresses.push(quotePersonalAddr(
                                        data[7][ib].display_name) +
                                        " <" + data[7][ib].mail + ">");
                                }
                                parent.cache.add(pn, addresses);
                            }
                            // normal users
                            else {
                                var em1 = data[2]; // email1
                                if (em1) {
                                    var key = quotePersonalAddr(pn) + " <" + em1 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                                var em2 = data[3]; // email2
                                if (em2) {
                                    var key = quotePersonalAddr(pn) + " <" + em2 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                                var em3 = data[4]; // email3
                                if (em3) {
                                    var key = quotePersonalAddr(pn) + " <" + em3 + ">";
                                    parent.cache.add(key, [key]);
                                    parent.nameIndex[key] = objectData;
                                }
                            }
                        }
                    }
    
                    // process resources
                    if (cb.length > 1 && !cb[1].error) {
                        var response = cb[1];
                        for (var i = 0; i < response.data.length; i++) {
                            var data = response.data[i];
                            var objectData = {
                                    type: 3, // resource
                                    id: data.id,
                                    folder: 0,
                                    display_name: data.display_name
                            };
                            var key = data.display_name + " <" + data.mailaddress + ">";
                            parent.cache.add(key, [key]);
                            parent.nameIndex[key] = objectData;
                        }
                    } else {
                        newServerError(4, cb[1]);
                    }
                    
                    // add search pattern
                    if (!parent.searchPattern[str]) {
                        parent.searchPattern[str] = str;
                    }
                    parent.onchange(str);
                });
            }
        });
    }, this.timeout);
};

function AutoCompleteCache() {
    this.aStr = new Object();
}

AutoCompleteCache.prototype.add = function(key, addresses) {
    if ( !this.aStr[key] ) 
        this.aStr[key] = new AutoCompleteCache();
    this.aStr[key] = addresses;
};

AutoCompleteCache.prototype.getResults = function(str, outStr) {
    for (var i in this.aStr) {
        // quote string for regex but fix wilcards
        // this reflects what the server does: the search pattern must start
        // at the begin or after whitespaces or "<" (email addresses)
        // additionally, display names might be quoted
        var resultRegex = "(^\"?|.*(\\s|<))"+escapeRegExp(str).replace(/\\\*/g, '.*').replace(/\\\?/g, '.');
        var re = new RegExp(resultRegex, "i");
        var obj = {};
        obj[i] = this.aStr[i];
        if (i.match(re)) outStr.push(obj);
    }
};

AutoCompleteCache.prototype.contains = function(str) {
    var tA = new Array();
    this.getResults(str, tA);
    return (tA && tA.length == 1 && tA[0] == str);
};

/******************* UTILS **********************/

/**
 * Constructs a single row with and mark matching text colored
 * @param str  The search String
 * @param oStr The original String (the address in this case)
 * @param oDiv The original div where the row will be appended
 */
var tmp_span = newnode("span", { margin:0 }, { className:"font-style-headline" }, [document.createTextNode("\xa0")]);
function getParsedNode (str, oStr, oDiv) {
    var regexp = new RegExp(escapeRegExp(str), "gi");
    var mpos, lIndex = 0;
    while (str != "" && (mpos = regexp.exec(oStr))) {        
        // everything before
       oDiv.appendChild(document.createTextNode(oStr.substring(lIndex,mpos.index)));
       lIndex = mpos.index + str.length;
       // match
       var mn = tmp_span.cloneNode(true);
       
       mn.firstChild.nodeValue = oStr.substring(mpos.index, lIndex)
       oDiv.appendChild(mn);
    }
    // everything else
    oDiv.appendChild(document.createTextNode(oStr.substring(lIndex, oStr.length)));
}

/**
 * Gets the current String within the carret position
 * @param str  The search String
 * @param obj The div
 */
function getCurrStr(str, obj) {
    var caretStart = getCaretStart(obj);
    var iLength = 0;
    var io=splitMails(str);
    for (var a = 0; a < io.length; a++) {
        iLength += io[a].length + 1;
        if (iLength > caretStart) {
            return io[a];
        }
    }
    return null;
}

function getSearchPatternLength(str) {
    // remove wildcards and whitespaces and return the number of characters
    return (str || "").replace(/[*?\s]/g, '').length;
}

function replaceCurrStr(oldstr,obj,newstr) {    
    var caretStart = getCaretStart(obj);
    var io = splitMails(oldstr);
    var iLength = 0;
    var stringnotfound=true;
    for (var a = 0; a < io.length; a++) {
        iLength += io[a].length + 1;
        if (iLength > caretStart && stringnotfound) {
            io[a]=newstr;
            stringnotfound=false;
        }
    }
    // rebuild string
    var nStr = "";
    for (var a = 0; a < io.length; a++) {
        if (trimStr(io[a]).length != 0) nStr += trimStr(io[a]) + ", ";
    }
     return nStr;
}

function getCaretStart(obj){
    if (typeof obj.selectionStart != "undefined") {
        return obj.selectionStart;
    } else if (document.selection && document.selection.createRange){
        var O = document.selection.createRange();
        try {
            var am = O.duplicate();
            am.moveToElementText(obj);
        } catch(e) {
            var am = obj.createTextRange();
        }
        am.setEndPoint("EndToStart", O);
        var rb=am.text.length;
        if (rb > obj.value.length) {
            return -1;
        }
        return rb;
    }
}

function setSelRange(obj, selStart, selEnd, sc) {
   if (obj.setSelectionRange) {
      obj.focus(); 
      obj.setSelectionRange(selStart, selEnd);
   } else if (obj.createTextRange) { 
      var range = obj.createTextRange(); 
      range.collapse(true); 
      range.moveEnd('character', selEnd); 
      range.moveStart('character', selStart); 
      range.select(); 
   }   
   setTimeout(function() { 
            obj.focus(); 
            obj.scrollTop = sc + 2 + pxPerEm;           
       }, 0);
}

function splitMails(str) {
    var quoted=str.split("\"");
    var noquotes=new Array();
    var holes=new Array();
    var removequotes="";
    var count=0;
    if(quoted.length) {
        for(var i=0;i<quoted.length;i++) {
            if(i%2==0) {
                noquotes.push(quoted[i]);
                count=count+quoted[i].length;
            } else {
                holes.push({count : count , size : quoted[i].length+1 , content : quoted[i] })
            }    
        }
        removequotes=noquotes.join("");
    } else {
        removequotes=str;
    }
    var mysplit=removequotes.split(new RegExp(";|,","g"));
    var newquote=new Array();
    var tmpcount=-1;
    for (var i=0; i<mysplit.length;i++) {
        tmpcount++;
        var tmpInt=mysplit[i].length+tmpcount;
        var tmpText=mysplit[i];
        for(var i2=0;i2<holes.length; i2++) {
            if(holes[i2].count>tmpInt)  { break;}
            if(holes[i2].count<tmpcount) { continue;}
            else {
                tmpText=tmpText.substring(0,holes[i2].count-tmpcount)+"\""+holes[i2].content+"\""+tmpText.substring(holes[i2].count-tmpcount,tmpText.length);
            }
        }
        tmpcount=tmpcount+mysplit[i].length;
        mysplit[i]=tmpText;
    }
    return mysplit;
}
/**
 *
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com
 *
 * @author Jan Finsel <jan.finsel@open-xchange.com>
 *
 */

// get reference to core window
var corewindow = window;
if (window.opener) {
    corewindow = window.opener.corewindow;
} else if (window.parent) {
    corewindow = window.parent.corewindow;
}

oxThemeStyle = corewindow.oxThemeStyle;

corewindow.register("LanguageChanged", function () {
    setLanguage(corewindow.configGetKey("language"));
    if (setWindowTitle) {
        setWindowTitle();
    }
});

register("Loaded",function() {
    var newPath = corewindow.oxThemeStyle.path || "default";
    for (var i in init.images) {
        init.images[i] = init.images[i].replace(/\/default\//g, "/"+newPath+"/");
    }
	appendNode("everything");
});
function addHideTreeNode(node,parent,index) { }
function appendNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display=="none" || node.style.display=="NONE")) {
		if(node.tagName == "DIV") { node.style.display = "block"; }
		else { node.style.display = ""; }
	}
}
function removeNode(id,cd) {
	var node=document.getElementById(id);
	if(node && !cd && (node.style.display!="none" || node.style.display!="NONE")) {
		node.style.display = "none";
	}	
}
function refillImages(id) {
    if($ALL(id)) {
        var elements=$ALL(id).getElementsByTagName("img");
        for(var i=0;i<elements.length;i++) {
            var src = init.images[elements[i].id];
            if(src && src != elements[i].src) elements[i].src = src;
        }
    }
}
function showNode(id,changedisplay) {
	appendNode(id,changedisplay);
	refillImages(id);
}

function hideNode(id,changedisplay) {
	removeNode(id,changedisplay);
}
function autorefill() {
	refillImages("body");
}
register("Loaded",autorefill);

var fileloaded=function() {};
/**
 *
 * All content on this website (including text, images, source code and any
 * other original works), unless otherwise noted, is licensed under a Creative
 * Commons License.
 *
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Copyright (C) Open-Xchange Inc., 2006-2012 Mail: info@open-xchange.com
 *
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * @author Matthias Biggeleben <matthias.biggeleben@open-xchange.com>
 *
 */

/*global jQuery, corewindow, AlertPopup, AutoComplete, addDOMEvent, ox, urlify,
tinyMCE, tinymce, $ALL, newConfirm, _, $, url : true, getFullImgSrc, removeCSSFilesForNewWindow,
activemodule : true, initContents, initAll, loadingComplete, triggerEvent, resizeEvents,
Join, attachmentDialog, infostoreDialog, resizeSplit, pxPerEm, SearchListAddressBook,
registerView, unregister, quotePersonalAddr, ComboBox3, noI18n, register, JSONX, AjaxRoot,
newAlert, formatError, trimStr, IE, isEmpty, newInput, removeChildNodes, cancelDefault,
newnode, format, bytesToString, newServerError, centerPopupWindow, addOnClose,
addressbookFolderPath, addTranslated, windowController : true, WindowController */

/*jslint devel: true, browser: true, forin: true, continue: true, unparam: true, maxerr: 50, indent: 4 */

// local vars
var selAttachment,
    priority,
    senderAddress,
    signature,
    tmp_attachmentDialog,
    tmp_attachmentInfostoreDialog,
    defaultSignature = -1,
    action = "new",
    myListAddressBook = null,
    distruGrid = null,
    msgref = null,
    autosave = null,
    undoActive = false,
    internalCache,
    defaultSignature = -1,
    activeMailAccount,
    oMailFunctionsNew,
    // references
    refToMain = corewindow,
    configContainsKey = corewindow.configContainsKey,
    configGetKey = corewindow.configGetKey,
    configSetKey = corewindow.configSetKey,
    options = configGetKey("gui.mail.newmail_options") || { "from": true,
		"replyto": ox.api.config.get("ui.mail.replyTo.configurable", false),
		"cc": true, "bcc": false, "options": false },
    messageFormat = configGetKey("gui.mail.formatmessage"),
    editorEnabled = (!messageFormat.match(/text\/plain/i)),
    // get font settings
    default_font_tynmce = configGetKey("gui.mail.defaul_mail_font"),
    default_font_size_tynmce = configGetKey("gui.mail.defaul_mail_font_size"),
    // required for joining initializing processes
    cb_initMessageContent = null,
    cb_initAddressBook = null,
    // passed via window
    aInfoMailAttachmentFile,
    aInfoMailAttachmentLink,
    multiForward,
    intervals = [],
    // trigger
    triggerReady = jQuery.noop,
    // window controller
    ctrl;

if (options.toolbar === undefined) options.toolbar = true;

// cache TinyMCE's popup CSS
var prefetch = jQuery.get(urlify(
    "3rdparty/tinymce/jscripts/tiny_mce/themes/advanced/skins/default/dialog.css"));

// not valid for all circumstances but sufficient here

function isSafari() {
    return navigator.userAgent.indexOf("AppleWebKit") >= 0;
}

function isFirefox() {
    return navigator.userAgent.indexOf('Gecko') > -1 && navigator.userAgent.indexOf('KHTML') === -1;
}

function isIE() {
    var test = navigator.appVersion.match(/MSIE (\d+\.\d+)/, '');
    return (test !== null && Number(test[1]) >= 5.5);
}

var ums = false;
function setBeforeUnload(on) {
    ums = on;
}

function onChange() {
    setBeforeUnload(true);
}

/**
 * TinyMCE Helper
 */

var splitContent,
    splitContent_IE,
    splitContent_W3C,
    initMessageHeader,
    initMessageContent,
    cb_mailComboChanged,
    setMailFields,
    setRecipients,
    setSubject,
    setMessageText,
    setInitialFocus,
    firefox_setInitialFocus,
    setDefaultFont,
    applyDefaultFontOnNode,
    getStyleTextOfDefaultFont,
    stripReservedAttributes,
    trimLastBlockquote,
    callback_new,
    searchEmailAddress,
    newmailContact,
    closeAddressbookNewEmail,
    getURL,
    addImg2Poll;

function isInsideBlockquote(range) {
    // get ancestor/parent container
    var container = range.commonAncestorContainer || range.parentElement();
    // loop for blockquote
    var bq = jQuery(container).parents('blockquote').last();
    return bq.length > 0;
}

//this one takes care of splitting the preset content
splitContent = function (ed, e) {
    // get current range
    var range = ed.selection.getRng();
    // in preset content?
    if (isInsideBlockquote(range)) {
        // W3C or IE?
        if (range.startContainer) {
            // strategy #1 (W3C compliant)
            splitContent_W3C(ed);
        } else {
            // strategy #2 (IE-specific / IE7 & IE8)
            splitContent_IE(ed);
        }
        tinymce.dom.Event.cancel(e);
    }
};

//this only works for IE
splitContent_IE = function (ed) {
    // get current range
    var range = ed.selection.getRng();
    // get body
    var body = ed.getBody();
    // get two text ranges
    var before = body.createTextRange();
    var after = body.createTextRange();
    // initialize first range & get its content
    before.setEndPoint("EndToStart", range);
    before = before.htmlText;
    // initialize second range & get its content
    after.setEndPoint("StartToEnd", range);
    // BR fix (remove unwanted newline)
    // leading white space in regexp is necessary (don't ask)
    after = after.htmlText.replace(/^(\s*<[^>]+>\s*)<BR\s*\/?>(.*)$/im, '$1$2');
    // create an unique mark
    var mark = "#cursor~mark^";
    // check uniqueness
    while (before.indexOf(mark) >= 0 || after.indexOf(mark) >= 0) {
        // add random characters until its unique
        mark += String.fromCharCode(64 + Math.random() * 63);
    }
    // replace editor content
    var markHTML = '<div>' + mark + '</div>';
    body.innerHTML = before + markHTML + after;
    // select mark
    range.findText(mark);
    range.select();
    // delete mark (this way!)
    range.pasteHTML("");
    range.collapse(true);
};

// works for FF and Safari
splitContent_W3C = function (ed) {
    // get current range
    var range = ed.selection.getRng();
    // range collapsed?
    if (!range.collapsed) {
        // delete selected content now
        ed.execCommand("Delete", false, null);
        // reselect new range
        range = ed.selection.getRng();
    }
    // do magic
    var container = range.commonAncestorContainer;
    var lastBR = null,
        traverse;
    // helper
    traverse = function (node) {
        var i;
        if (node) {
            if (node.hasChildNodes()) {
                // skip text nodes
                for (i = 0; i < node.childNodes.length; i++) {
                    if (node.childNodes[i].nodeType === 1) {
                        // follow this node
                        traverse(node.childNodes[i]);
                        return;
                    } else if (node.childNodes[i].nodeType === 3) {
                        // remove zero width space (good for safari)
                        node.childNodes[i].nodeValue = node.childNodes[i].nodeValue.replace('\u200B', '');
                    }
                }
            } else if (node.nodeName === "BR") {
                // remember node
                lastBR = node;
            }
        }
    };
    while (container && container.nodeName !== "BODY") {
        // set range to end of container
        range.setEndAfter(container);
        // get parent node
        var p = container.parentNode;
        // add range content before next sibling (or at the end of the parent
        // node)
        var contents = range.extractContents();
        // BR fix (remove unwanted newline)
        traverse(contents.firstChild);
        // now insert contents
        if (jQuery(contents).text().length > 0) {
            // insert this content only if it includes something visible
            // Actually this allows to split a quote after the very last
            // character
            // without getting empty gray blocks below the split
            p.insertBefore(contents, container.nextSibling);
        }
        // climb up
        container = p;
    }
    // last BR?
    if (lastBR) {
        try {
            lastBR.parentNode.removeChild(lastBR);
        } catch (e) {
        }
    }
    // create new elements
    var dummySpan = ed.getDoc().createElement("span");
    dummySpan.innerHTML = "&nbsp;";
    var para = ed.getDoc().createElement("p");
    // and both elements to editor
    para.appendChild(dummySpan);
    range.insertNode(para);
    // select the span
    ed.selection.select(dummySpan);
    // and delete it
    ed.execCommand("Delete", false, null);
};

// -----------------------------------------------------------------------------
// modal dialog
function setModalBusy(state) {
    if (state === true) {
        ox.api.setModal(true);
        jQuery("#modal-dialog-decorator").addClass("busy");
    } else {
        ox.api.setModal(false);
        jQuery("#modal-dialog-decorator").removeClass("busy");
    }
}

// -----------------------------------------------------------------------------

var askToClose = function () {
    function cbyes() {
        oMailFunctionsNew.cleanUp();
        ctrl.close(true);
    }
    if (ums) {
        newConfirm(_("Close Window"),
            _("Do you really want to discard your changes and close the window?"),
            AlertPopup.YESNO, null, null, cbyes, null, null, null, function () {});
    } else {
        cbyes();
    }
};

/**
 * handles resizing of the tinyMCE editor and will be called each time the
 * resized event got triggered
 */
function cb_resize_tinyMCE() {
    /*
     * getting the iframe element of the editor
     */
    if (tinyMCE && tinyMCE.activeEditor) { // double check that!
        var editor = $ALL(tinyMCE.activeEditor.id + "_ifr");
        if (!editor) {
            return; // ups, no editor!?
        }
    } else {
        return;
    }

    /*
     * calculates the plain editor height without toolbar and setting the new
     * height (if it really changed)
     */
    var editorHeight = $('mailsplitbottom').clientHeight - $ALL("editor_content_tbl").getElementsByTagName("td")[0].offsetHeight;
    if (editorHeight > 0 && editorHeight !== editor.offsetHeight) {
        editor.style.height = editorHeight - 1 + "px";
    }
}

// local functions
var finalizeGUI,
    newMailWindowOnload,
    newMailOnload,
    initAddressBook,
    cb_attachmentDialog,
    setSignatureText,
    isNewline,
    createNewLine;

/**
 * will be executed if the body onload event gots triggered
 */
newMailWindowOnload = function () {

    // get passed data
    var wd = ox.api.window.getData(url.guid);
    aInfoMailAttachmentFile = wd.aInfoMailAttachmentFile;
    aInfoMailAttachmentLink = wd.aInfoMailAttachmentLink;
    multiForward = wd.multiForward;

    // add default theme (should be in browser cache)
    var themeStyle = corewindow.oxThemeStyle || { name: "Default", path: "default" };
    ox.gui.themePath = getFullImgSrc("");
    removeCSSFilesForNewWindow(themeStyle.path);
    $("attachments_note").style.display="";

    activemodule = 'mail_new';
    initContents('mail_new');
    initAll();
};



/**
 * handles the initialization of all necessary events, parameter and load
 * contents for the new mail window
 */
newMailOnload = function () {

    loadingComplete();

    // extend url object
    url = jQuery.extend((url || {}), ox.api.window.getData(url.guid));

    // map url given addresses to valid objects
    var tAddr = [ "to", "cc", "bcc" ],
        i = 0;
    for (; i < tAddr.length; i++) {
        if (jQuery.isArray(url[tAddr[i]]) === false) {
            url[tAddr[i]] = [[ null, url[tAddr[i]]]];
        }
    }

    // prepare url object and take care
    // everything set correctly
    if (!url.attachments) {
        url.attachments = [{}];
    }
    // wrap any mailtext parameter into valid object
    if (url.mailtext) {
        var attach = url.attachments[0];
        attach.content_type = "text/plain";
        attach.content = url.mailtext;
        url.action = "new";
    }

    triggerEvent("OX_Switch_View", "mail_new");

    internalCache = corewindow.internalCache;
    action = url.action || "new";

    // get active mail account
    // default is
    var acc =  "0";
    // account via url?
    if (url.account) {
        acc = url.account;
    } else {
        // account via folder/id in url?
        if (url.folder && url.folder.length !== 0) {
            acc = ox.api.account.derive(url.folder); // use folder (e.g. default0/INBOX)
        } else if (url.id && url.id.length !== 0) {
            acc = ox.api.account.derive(url.id); // use id (e.g. default0/INBOX/23893)
        }
    }

    // get account data (relies on account being already cached);
    activeMailAccount = ox.api.account.get(acc);

    /*
     * attach autocomplete to recipient dialogs if enabled in the user options
     */
    if (configGetKey("gui.mail.autocomplete")) {
        var dummy; // for jslint
        dummy = new AutoComplete($('to'), $('AutoCompleteContent'), 25, configGetKey("minimumSearchCharacters"));
        dummy = new AutoComplete($('cc'), $('AutoCompleteContent'), 25, configGetKey("minimumSearchCharacters"));
        dummy = new AutoComplete($('bcc'), $('AutoCompleteContent'), 25, configGetKey("minimumSearchCharacters"));
        dummy = null;
    }

    // add simple context menu for attachments
    var menu = globalContextMenus.simpleAttachments = new ContextMenu(),
        open, save, menuContext, menuSelection;

    open = new MenuItem(_("Open"), function () { corewindow.openAttachment("OPEN", menuContext, menuSelection); });
    open.setIcon("img/menu/attachment_open.gif", "img/menu/attachment_open_d.gif");
    menu.addItem(open);

    save = new MenuItem(_("Save as"), function () { corewindow.openAttachment("SAVE", menuContext, menuSelection); });
    save.setIcon("img/menu/attachment_save.gif", "img/menu/attachment_save_d.gif");
    menu.addItem(save);

    menu.onShow = function (obj) {
        if (obj && obj.disp === 'attachment') {
            menuContext = { folder: url.folder, id: url.id };
            menuSelection = [{ data: obj }];
            open.setEnabled(true);
            save.setEnabled(true);
        } else {
            open.setEnabled(false);
            save.setEnabled(false);
        }
    };

    /*
     * register to resizing event for setting the new height of the tinyMCE
     * editor when the user resizes the window
     */
    resizeEvents.register("Resized", cb_resize_tinyMCE);
    
    // adding new menu
    ox.gui.initToolBarNewWindowMail();
    
    // wait for tinyMCE
    jQuery.when(setMessageFormat(messageFormat), prefetch).done(function() {
        // join handlers
        var joint = new Join(finalizeGUI),
            lock = joint.add();
        // initialize header (sync)
        initMessageHeader();
        // initialize header (async)
        cb_initMessageContent = joint.add();
        // initialize address book (async)
        cb_initAddressBook = joint.add();
        // go!
        initMessageContent(action);

        // disable attachments first
        triggerEvent("SubSelected", []);

        // init cb for attachment dialog
        tmp_attachmentDialog = new attachmentDialog(0, cb_attachmentDialog);
        tmp_attachmentInfostoreDialog = new infostoreDialog(0, cb_attachmentDialog);

        addDOMEvent($('addAddressTo'), "mousedown", function () { searchEmailAddress('to'); });
        addDOMEvent($('addAddressCc'), "mousedown", function () { searchEmailAddress('cc'); });
        addDOMEvent($('addAddressBcc'), "mousedown", function () { searchEmailAddress('bcc'); });

        /*
         * if enabled in the user options initialize auto save and register
         * timer which saves the message each n minutes to the drafts folder
         */
        if (!isNaN(configGetKey("gui.mail.auto_save_drafts")) && configGetKey("gui.mail.auto_save_drafts") !== 0) {
            var iv = window.setInterval(
                "oMailFunctionsNew.autosaveMessage()",
                (configGetKey("gui.mail.auto_save_drafts") * 60000)
            );
            intervals.push(iv);
        }

        // init address book
        setTimeout(function () {
            initAddressBook();
            lock();
        }, 100);
    });
};

finalizeGUI = function () {

    // set focus
    setInitialFocus();

    triggerReady = function (object) {
        // if available set the reply-to address, otherwise it will be the primary address
        if (action !== "draft"
                && ox.api.config.get("ui.mail.replyTo.configurable", false) === true) {
            var address = activeMailAccount.reply_to || "";
            if (address.length) {
                $("replyTo").value = activeMailAccount.reply_to;
            }
            if (options.replyto !== (address.length !== 0)) {
                options.replyto = !options.replyto;
            }
        }

        // adjust view states
        for (i in options) {
            oMailFunctionsNew.showAdditionalHeaderField(i, options[i]);
        }

        resizeEvents.register("Resized", function () {
            // ugly hack to fix bug #18051.
            // check to get rif of the toolbar resize race condition,
            if (oMailFunctionsNew.attachObj.length &&
                    jQuery("#mailsplitbottom").css("bottom") === "0px") {
                // force a redraw of the attachment panel if it seems that the
                // bottom
                // height does not match with the attachment counter
                resizeSplit("newMailAttachmentDiv", Math.round(pxPerEm * 3.2) + "px");
            }
        });

        // THIS MUST be called before Window READY !!!
        triggerEvent("OX_menu_Change_Height");

        var metaData = {
            module: "mail",
            activemodule: activemodule,
            handle: url.guid,
            id: url.id ? url.id : null,
            folder_id: url.folder ? url.folder : null,
            title: (url.id && url.id !== "" ? $("subject").value : corewindow._("New E-Mail")),
            action: action
        };;

        ox.api.window.core.triggerEvent("OX_Window_Ready", metaData, window);

        // this is the final resize! however, this potentially is risky because
        // we assume that any possible registered plugin already finished its work
        setTimeout(function() {
            oMailFunctionsNew.drawAttachmentPanel(true);
            // disable loading screen
            $("loading_data_bg").style.display = "none";
        }, 50);
        
        object = metaData = null;
    };

    triggerReady();
};

/**
 * The attachment dialog callback. We take the given objects and convert them
 * into unique attachment objects.
 *
 * @param {attachments}
 *            the attachment object
 */
cb_attachmentDialog = function (attachments) {
    // nothing to do
    if (!attachments && !attachments.length) {
        return;
    }
    // fetch objects and add to global attach obj
    for (var i = 0; i < attachments.length; i++) {
        if (!oMailFunctionsNew.attachmentExists(attachments[i].id)) {
            var attach = {
                id: attachments[i].id,
                filename: attachments[i].filename,
                size: null,
                content_type: attachments[i].content_type || null,
                msgref: attachments[i].msgref || null,
                selected: false,
                infostore: attachments[i].infostore || false
            };
            if (attachments[i].cid) {
                attach.cid = attachements[i].cid;
            }
            oMailFunctionsNew.addAttachment(attach);
            setBeforeUnload(true);
            delete(attach);
        }
    }
};

registerView(
    "mail_new",
    null,
    function () {
        // set focus
        setInitialFocus();
    },
    null,
    function () {
        unregister("cb_mailComboChanged", cb_mailComboChanged);
    },
    function () {
        // set focus
        setInitialFocus();
    }
);



// -----------------------------------------------------------------------------
var currentSignature = null;
setSignatureText = function (sig, initial) {
    
    if (editorEnabled) {
        // shortcut to active editor / body
        var ae = tinyMCE.activeEditor;
        // find old signature
        var signature = jQuery('#ox-signature', ae.getDoc());

        // quick path to remove the signature
        if (!sig) {
            currentSignature = sig;
            signature.remove();
            return;
        }
        
        var newSignature = jQuery('<div id="ox-signature">' +
                sig.signature_text.replace(/\n/g, '<br>') + '</div>');
        
        // Signatures with the same position are replaced in-place
        if (signature.length && currentSignature && sig &&
            sig.position === currentSignature.position)
        {
            signature.replaceWith(newSignature);
        } else {
            signature.remove();
            if (sig.position === "above") {
                newSignature.prependTo(ae.getBody());
            } else {
                newSignature.appendTo(ae.getBody());
            }
        }
        
        currentSignature = sig;
        
        // special case for initialization: add an empty line for top-posting
        // instead of scrolling to the new signature
        if (initial) return jQuery('<div><br></div>').prependTo(ae.getBody());
        
        jQuery('#ox-signature', ae.getDoc())[0].scrollIntoView(false);
    } else {
        var text = jQuery("#editor_content");
        var content = text.val();
        var signature = '', above = true, i = -1, before = '', after = '';
        
        // find current signature
        if (currentSignature) {
            var indexFn = currentSignature.position === "above" ? "indexOf"
                                                                : "lastIndexOf";
            i = content[indexFn](currentSignature.signature_text);
            if (i >= 0) {
                before = content.slice(0, i);
                after = content.slice(i +
                    currentSignature.signature_text.length);
                // don't replace signatures with different positions
                if (sig && sig.position !== currentSignature.position) {
                    content = joinLines([before, after]);
                    i = -1;
                }
            }
            above = currentSignature.position == "above";
        }
        
        currentSignature = sig;
        if (sig) {
            signature = sig.signature_text;
            above = sig.position === "above";
        }
        
        // if not replacing, compute the new position
        if (i < 0) {
            before = above ? '' : content;
            after = above ? content : '';
        }
        
        var padding = initial && action !== "new" ? '\n' : '';
        text.val(joinLines([padding, before, signature, after]));
        if (initial) return
        text.scrollTop(above ? 0 : text.prop('scrollHeight') - text.height());
    }
};

/**
 * Joins an array of strings by adding newlines only when necessary to prevent
 * merging of lines from different strings.
 * @param {Array of String} lines An array of strings to join
 * @type String
 * @returns The joined strings.
 */
function joinLines(lines) {
    var out = [], prev = '';
    for (var i = 0; i < lines.length; i++) {
        var line = lines[i];
        if (line) {
            if (prev && prev.slice(-1) !== '\n' && line.charAt(0) !== '\n') {
                out.push('\n');
            }
            out.push(line);
        }
        prev = line;
    }
    return out.join('');
}

// -----------------------------------------------------------------------------
var accountAliases = {}; // aliases mapping
initMessageHeader = function () {

    var defaultName = quotePersonalAddr(corewindow.getPersonalFullName()) + " ",
        reply_to = null, primaryAddress = configGetKey("mail.sendaddress");

    // adding e-mail addresses from external accounts to sender addresses list
    if (configGetKey("modules.mailaccount.module")) {
        // get all accounts
        ox.api.account.all(function (list) {
            var i = 0, $i = list.length, data, personal;
            for (; i < $i; i++) {
                data = list[i];
                // need some setting from the main account
                if (data.id == 0) {
                    reply_to = data.reply_to;
                }
                var personal = defaultName;
                // personal name used for internal aliases later
                if (data.personal) {
                    personal = quotePersonalAddr(data.personal) + " ";
                    if (data.id == 0) {
                        defaultName = personal;
                    }
                }
                accountAliases[data.id] = {
                        address: data.primary_address,
                        personal: personal,
                        value: data.primary_address + " (" + data.name + ")",
                        id: data.id,
                        reply_to: data.reply_to
                };
                if (data.primary_address == primaryAddress) {
                    // address matched to the default sender address
                    primaryAddress = data.id;
                }
            }
        });
    }

    // adding regular aliases from the gui config
    var aliases = {}, i;
    if (configContainsKey("mail.addresses")) {
        var addrs = configGetKey("mail.addresses");
        for (i = 0; i < addrs.length; i++) {
            var address = addrs[i], found = false;
            // iterating through existing mailacounts
            // search for a matching address
            for (var a in accountAliases) {
                if (accountAliases[a].address == address) {
                    found = true;
                    break;
                }
            }
            // not found, adding to tmp list
            if (found == false) {
                aliases[address] = {
                        address: address,
                        personal: defaultName,
                        value: address,
                        reply_to: reply_to
                };
            }
        }
    }

    // merge internal aliases with mail account addresses
    jQuery.extend(accountAliases, aliases);

    var scrollBar = ObjectToArray(accountAliases).length > 5 ? 6 : null;
    senderAddress = window.heinz = new ComboBox3(window, "mail.fromCombo", "25em", 0,
            true, "cb_mailComboChanged", scrollBar, { type: "sender" });
    // add to combo-box
    for (var i in accountAliases) {
        senderAddress.addElement(noI18n(accountAliases[i].value), i);
    }
    senderAddress.sort();
    senderAddress.getDomNode();

    if (activeMailAccount && activeMailAccount.primary_address &&
            (activeMailAccount.id && activeMailAccount.id > 0)) {
        primaryAddress = activeMailAccount.id;
    }

    // set the default selected address
    senderAddress.setKey(primaryAddress, true);

    priority = new ComboBox3(window, "mail.priorityCombo", "13em", 1, true, "cb_mailComboChanged", 3, { type: "priority" });
    priority.addElement(_("Low"), "4");
    priority.addElement(_("Normal"), "3");
    priority.addElement(_("High"), "2");
    priority.getDomNode();
    register("cb_mailComboChanged", cb_mailComboChanged);

    // get number of signatures (+1 = "None")
    var signature_count = configGetKey("gui.mail.signatures").length + 1;
    // add combobox (height depends on number of signatures (max 4 rows)
    signature = new ComboBox3(window, "mail.signatureCombo", "15em", 0, true, "setSignature", Math.min(signature_count, 5));
    // fill combobox
    if (configContainsKey("gui.mail.signatures")) {
        signature.addElement(_("None"), "");
        var a = 0;
        for (; a < configGetKey("gui.mail.signatures").length; a++) {
            var signatures = configGetKey("gui.mail.signatures")[a];
            var sig_name = signatures.signature_name.length === 0 ?
                _("Unnamed signature") :
                noI18n(signatures.signature_name);
            signature.addElement(sig_name, signatures);
            if (configGetKey("gui.mail.signatures")[a].signature_default && url.default_signature !== false) {
                defaultSignature = a;
                signature.selected = a + 1;
            }
        }
    } else {
        signature.addElement("No signature", "");
    }
    signature.getDomNode();

    if (!configGetKey("gui.mail.signatures") || ((configGetKey("gui.mail.signatures") && configGetKey("gui.mail.signatures").length === 0))) {
        setTimeout(function () { signature.disable(); }, 0);
    }

    if (configGetKey("mail.vcard")) {
        document.getElementsByName("mail.attachVCard")[0].checked = true;
    }
};

cb_mailComboChanged = function (key, args) {
    // set reply-to address
    if (ox.api.config.get("ui.mail.replyTo.configurable") === true
    		&& accountAliases.length != 0 && args.type === "sender") {
        var address = "";
        if (accountAliases[key] && accountAliases[key].reply_to) {
            address = accountAliases[key].reply_to;
        }
        $("replyTo").value = address;
        oMailFunctionsNew.showAdditionalHeaderField("replyto", (address.length !== 0));
    }
    setBeforeUnload(true);
};

initMessageContent = function (m_action) {

    var addParam = messageFormat.toUpperCase() === "TEXT/PLAIN" ? "&view=text" : "&view=html";

    if (m_action && m_action === "draft") {
        m_action = "get";
        addParam += "&edit=1";
    }

    // attached objects?
    var i;
    var wd = ox.api.window.getData(url.guid);
    if (wd.attachedObjects !== undefined) {
        // loop objects
        for (i = 0; i < wd.attachedObjects.length; i++) {
            var obj = wd.attachedObjects[i];
            // attach:
            oMailFunctionsNew.addObject(obj);
        }
    }

    // headers
    if (wd.headers) {
        for (i in wd.headers) {
            oMailFunctionsNew.headers[i] = wd.headers[i];
        }
    }

    if (m_action && m_action !== "" && m_action !== "new") {
        var sObj = [{ "folder": url.folder, "id": url.id }];
        // multi forward?
        if (jQuery.isArray(multiForward) && multiForward.length) {
            sObj = multiForward;
        }
        (new JSONX()).put(
            AjaxRoot + "/mail?action=" + m_action + "&session=" + corewindow.session + addParam,
            sObj,
            null,
            function (cb) {
                if (cb && cb.data) {
                    if (action !== "draft") {
                        delete cb.data.disp_notification_to;
                    }
                    if (action === "forward") {
                        cb.data.to = url.to ? url.to : [];
                    }
                    setMailFields(cb.data);
                }
                // callback
                cb_initMessageContent();
            },
            function (cb) {
                // mail no longer exists so show alert and then close window
                if (cb && cb.code === "MSG-0032") {
                    newAlert(
                        _("Error"),
                        formatError(cb),
                        function () {
                            oMailFunctionsNew.cleanUp();
                            corewindow.triggerEvent("OX_Mail_Delete");
                            ctrl.close();
                        }
                    );
                    finalizeGUI();
                    return true;
                } else {
                    finalizeGUI();
                    return false;
                }
            }
        );

    } else {

        setMailFields(url);
        if (aInfoMailAttachmentFile !== undefined) {
            setMessageText(aInfoMailAttachmentFile);
        } else if (aInfoMailAttachmentLink !== undefined) {
            setMessageText(aInfoMailAttachmentLink);
        }
        // callback
        cb_initMessageContent();
    }
};

setMailFields = function (mailobject) {
    setRecipients(mailobject.to, "to");
    setRecipients(mailobject.cc, "cc");
    setRecipients(mailobject.bcc, "bcc");
    setSubject(mailobject.subject);
    msgref = mailobject.msgref;
    if (mailobject.nested_msgs && mailobject.nested_msgs.length > 0) {
        var i, nobj, textAttachment;
        for (i = 0; i < mailobject.nested_msgs.length; i++) {
            nobj = mailobject.nested_msgs[i];
            textAttachment = nobj.subject || _("attachment");
            oMailFunctionsNew.addAttachment({
                id: nobj.id || "message/rfc822",
                filename: textAttachment,
                size: null,
                content_type: "message/rfc822",
                msgref: nobj.msgref || null,
                selected: false,
                disk: nobj.disk || null
            });
        }
    }
    setMessageText(mailobject.attachments);

    var prio = "3";
    switch (String(mailobject.priority)) {
        case "1":
        case "2":
            prio = "2";
            break;
        case "4":
        case "5":
            prio = "4";
            break;
    }
    priority.setKey(prio, true);

    if (mailobject.disp_notification_to && $("acknowledge")) {
        $("acknowledge").checked = true;
    }
};

setRecipients = function (to, field) {
    if (to && to.length && $(field)) {
        $(field).value = corewindow.getAdressString(to, false);
        if (field !== "to" && trimStr($(field).value).length !== 0) {
            // don't use trigger event because we won't store the settings!
            oMailFunctionsNew.showAdditionalHeaderField(field, true);
        }
    }
};

var setWindowTitle = function () {
    var title = _("New E-Mail");
    if (url.id && url.id !== "") {
    	title += ": " + $("subject").value;
    }
    if (document) {
    	document.title = title;
    }
};

setSubject = function (subject) {
    if (subject) {
        // set text fields
        $("subject").value = subject;
    }
    // set document title as well
    setWindowTitle();
};

function processAttachments(attachments) {
    var cnn = "", conArr, ct, con, idfield;
    for (idfield in attachments) {
        conArr = attachments[idfield];
        ct = conArr.content_type ? conArr.content_type.toLowerCase() : "application/unknown";
        con = conArr.content;
        if (ct.search(/text\//) !== -1 && con && con !== undefined) {
            if (editorEnabled) {
                cnn += con;
            } else {
                cnn += unescapeHTML(con.replace(/<br\s*\/?>/g, '\n'));
            }
        } else {
            if (conArr.filename && !oMailFunctionsNew.attachmentExists(conArr.id)) {
                oMailFunctionsNew.addAttachment({
                    id: conArr.id || null,
                    filename: conArr.filename || null,
                    size: conArr.size || null,
                    content_type: conArr ? conArr.content_type : null,
                    disp: conArr.disp || null,
                    content: conArr.content || null,
                    disk: conArr.disk || null,
                    selected: false,
                    infostore: conArr.infostore || null,
                    cid: conArr.cid || null
                });
            }
        }
    }
    return cnn;
}

setMessageText = function (attachments) {

    var cnn = processAttachments(attachments);
    if (editorEnabled) {
        // shortcut to active editor
        var ae = tinyMCE.activeEditor;
        
        // separate styles from the body using an iframe
        var iframe = jQuery("<iframe/>").attr("src", "javascript:false");
        // append to body, otherwise contentWindow is empty!
        iframe.appendTo("body");
        // append original html to iframe
        iframe[0].contentWindow.document.open();
        iframe[0].contentWindow.document.write(cnn);
        iframe[0].contentWindow.document.close();
        // filter required style and body elements
        var styles = iframe.contents().find("style");
        var cnn = iframe.contents().find("body").html();
        iframe.remove();
       
        // add styles and body to the editor
        styles.appendTo(ae.dom.select("head"));
        if (!cnn && action === "draft") cnn = '<div></div>';
        ae.setContent(cnn);
        
        // set default font
        jQuery(ae.dom.getRoot()).attr("style", getStyleTextOfDefaultFont());
        // remove quoted signature ids
        if (action !== "draft") {
            jQuery('#ox-signature', ae.getDoc()).removeAttr("id");
        }
    } else {
        if (!cnn && action === "draft") cnn = '\n';
        jQuery('#editor_content').val(cnn);
    }
    // add default signature
    if (action !== "draft") {
        setSignatureText(configGetKey("gui.mail.signatures")[defaultSignature],
                         true);
    }
};

setInitialFocus = function () {
    window.focus();
    // first, focus the editor and move the cursor to the top
    if (editorEnabled) {
        var ae = tinyMCE.activeEditor;
        if (!ae) return;
        ae.focus();
        var sel = ae.selection;
        sel.select(ae.getBody().firstChild, true);
        sel.collapse(true);
    } else {
        var textarea = jQuery('#editor_content').focus().get(0);
        if ("selectionStart" in textarea) {
            textarea.selectionStart = 0;
            textarea.selectionEnd = 0;
        } else {
            var tr = textarea.createTextRange();
            tr.setEndPoint('EndToStart', tr);
            tr.select();
        }
    }
    // now, eventually focus the recipient field
    if (url.action !== "reply" && url.action !== "replyall") {
        // set focus on "To" field
        // ok for FF and IE (take care if input not visible, possible
        // problem e.g. when using the fax plugin together with IE)
        jQuery("#to:visible").focus();
    }
};

getStyleTextOfDefaultFont = function () {
    var styleText = "";
    // set font family
    if (default_font_tynmce && default_font_tynmce !== 'default') {
        styleText += "font-family: " + default_font_tynmce + "; ";
    }
    // convert index to PT and set font size
    if (default_font_size_tynmce && default_font_size_tynmce !== 'default') {
        var PT = [8, 10, 12, 14, 18, 24, 36];
        styleText += "font-size: " + PT[default_font_size_tynmce - 1] + "pt; ";
    }
    return styleText;
};

function MailFunctions() {
    this.oo = {};
    this.headers = {};
    this.ooA = {};
    this.attachContainer = [];
    this.attachObj = [];
    this.savePending = false;
}

MailFunctions.prototype = {

    sendMessage: function (param, silent) {
        var Self = this;
        if (this.savePending) {
            return;
        }
        if (!param) {
            Self.getMailValues();
        }
        function cb_ok() {
            Self.savePending = true;
            if (action === "forward") {
                Self.oo.sendtype = 2;
            } else if (action === "reply" || action === "replyall") {
                Self.oo.sendtype = 1;
            } else if (action === "draft") {
                Self.oo.sendtype = 4;
            }
            Self.sAction = AjaxRoot + "/mail?action=new&session=" + corewindow.session;
            var sTargetParam = 'mailSendCB';
            if (!isEmpty(Self.headers)) {
                Self.oo.headers = Self.headers;
            }
            setModalBusy(true);
            tmp_attachmentDialog.do_post(Self.oo, callback_new, Self.sAction, sTargetParam, setModalBusy);
        }
        if (!silent && trimStr(Self.oo.subject).length === 0) {
            newInput(
                _("Send"),
                _("You did not enter a subject. Would you like to enter a subject now?"),
                null,
                "",
                AlertPopup.OKCANCEL,
                function () {
                    $("subject").value = $("create_window_text_field").value;
                    Self.oo.subject = $("create_window_text_field").value;
                    cb_ok();
                },
                null,
                null,
                null,
                "input",
                null
            );
        } else {
            cb_ok();
        }
    },

    saveMessageAsDraft: function (callback, silent) {

        var self = this;

        this.getMailValues();
        this.oo.flags = 4;

        if (msgref) {
            this.oo.msgref = msgref;
        }

        // magic global callback
        callback_new_cb = function (data) {
            callback_new_cb = null;
            self.savePending = false;
            // remember msgref
            msgref = data;
            action = 'draft';
            setBeforeUnload(false);
            corewindow.updateDraftsFolderCache(url.id, data, activeMailAccount.id);
            if (!silent && (self.attachObj.length ||
                editorEnabled && tinyMCE.activeEditor.dom.select("img").length))
            {
                cb_initMessageContent = callback || jQuery.noop;
                url.folder = data.replace(/\/[^\/]+$/, "");
                url.id = data.replace(/.*\//, "");
                var ids = [];
                for (var i = 0; i < self.attachObj.length; i++) {
                    ids.push(self.attachObj[i].id);
                }
                tmp_attachmentDialog.removeFiles(ids);
                self.attachObj.length = 0;
                initMessageContent(action);
            } else if (callback) callback();
        };

        // save draft
        this.sendMessage("fromDraft", silent);
    },

    autosaveMessage: function () {
        var self = this;
        if (!ums) {
            return; // nothing changed, so no need to save anything
        }
        this.getMailValues();
        delete this.oo.attachments;
        delete this.oo.infostore_ids;
        if (autosave) {
            this.oo.msgref = autosave;
        } else {
            delete this.oo.msgref;
        }
        this.oo.flags = 4;
        // refill message text
        this.oo.attachments = [{
            content_type: messageFormat,
            content: editorEnabled ? tinyMCE.activeEditor.getContent()
                                   : jQuery('#editor_content').val()
        }];
        // send to server
        (new JSONX()).put(
            AjaxRoot + "/mail?action=autosave&session=" + corewindow.session,
            this.oo,
            null,
            function (reply) {
                if (!reply.error && reply.data) {
                    corewindow.updateDraftsFolderCache(autosave, reply.data, activeMailAccount.id);
                    autosave = reply.data;
                    if (autosave.indexOf("/") !== -1) {
                        // have to update mail id for all inline images
                        self.updateInlineImages(
                            autosave.substr(autosave.lastIndexOf("/")+1, autosave.length)
                        );
                    }
                    self = null;
                }
            }
        );
    },
    
    /**
     * 
     * @param id - the new mail id
     */
    updateInlineImages: function(id) {
        if (editorEnabled) {
            // getting all images in editor
            jQuery("img", tinyMCE.activeEditor.dom.select("body")).filter(function() {
                // filter just only for inline-images
                return this.src.match(/picture?/);
            }).each(function (i, node) {
                var url = this.src.split("?");
                if (url.length === 2) {
                    var hash  = ox.util.deserialize(url[1]);
                    if ("id" in hash && "uid" in hash) {
                        hash.id = id;
                        var url = url[0] + "?" + ox.util.serialize(hash);
                        jQuery(this).attr({ src: url, "data-mce-src": url});
                        url = null;
                    }
                }
            });
        }
    },

    cleanUp: function () {
        // reset intervals, specially IE does not reset
        // them when closing the iframe
        for (var i=0; i < intervals.length; i++) {
            window.clearInterval(intervals[i]);
        }
        // delete autosave message if necessary
        if (autosave) {
            corewindow.deleteAutosaveMessage(
                configGetKey("mail.folder.drafts"),
                String(autosave.match(/[0-9]+$/g)),
                true
            );
        }
    },

    getEditorContent: function () {
        if (editorEnabled) {
            var ae = tinyMCE.activeEditor;
            var style = jQuery(ae.dom.select('style')).text();
            if (style) {
                style = '<head><style type="text/css">' + style +
                        '</style></head>';
            }
            return '<html>' + style + '<body style="' +
                getStyleTextOfDefaultFont() + '">' +
                tinyMCE.activeEditor.getContent() + '</body></html>';
        } else {
            return replaceSpaces(escapeHTML(jQuery('#editor_content').val()),
                                 true);
        }
    },

    getMailValues : function () {

        var i;

        this.clearObjectContent();
        var sender = accountAliases[senderAddress.getKey()];
        this.oo.from = sender.personal + "<" + sender.address + ">";
        // set reply_to address if configureable
        if (ox.api.config.get("ui.mail.replyTo.configurable") === true
                && $("replyTo")) {
            var reply_to = trimStr($("replyTo").value || "");
            if (reply_to.length !== 0) {
                this.oo.reply_to = reply_to;
            }
        }
        this.oo.to = $("to").value;
        this.oo.cc = $("cc").value;
        this.oo.bcc = $("bcc").value;
        this.oo.subject = $("subject").value;
        this.oo.priority = priority.getKey();

        if (msgref !== null && msgref !== undefined) {
            this.oo.msgref = msgref;
        }

        if (document.getElementsByName("acknowledge")[0].checked) {
            this.oo.disp_notification_to = document.getElementsByName("acknowledge")[0].checked;
        }

        if (document.getElementsByName("mail.attachVCard")[0].checked) {
            this.oo.vcard = 1;
        }

        // get content type
        this.ooA.content_type = messageFormat;
        // get content
        this.ooA.content = this.getEditorContent();

        // build the final attachment object
        var tmp_attachObj = [],
            infoAttaches = [],
            attachObj;
        tmp_attachObj.push(this.ooA); // always message text first
        for (i = 0; i < this.attachObj.length; i++) {
            attachObj = this.attachObj[i];
            if (attachObj.infostore) {
                infoAttaches.push(attachObj.id);
            } else if (attachObj.type === "file" && attachObj.content_type !== null) {
                tmp_attachObj.push(attachObj);
            }
        }
        this.oo.attachments = tmp_attachObj;

        // attach infostore references
        if (infoAttaches.length !== 0) {
            this.oo.infostore_ids = infoAttaches;
        }

        // build the final data source object
        tmp_attachObj = [];
        for (i = 0; i < this.attachObj.length; i++) {
            attachObj = this.attachObj[i];
            if (attachObj.type === "datasource") {
                tmp_attachObj.push(attachObj.data);
            }
        }
        this.oo.datasources = tmp_attachObj;
    },

    clearObjectContent: function () {
        this.oo = {};
        this.ooA = {};
    },

    addAttachment: function (attachObj) {
        if (!attachObj || !attachObj.id) {
            return;
        }
        // set type
        attachObj.type = "file";
        // add
        this.attachObj.push(attachObj);
        this.drawAttachmentPanel();
    },

    getObjectID: function (obj) {
        // create id
        var keys = [], key;
        for (key in obj.compositeID) {
            keys.push(key);
        }
        keys.sort();
        var values = [], i;
        for (i in keys) {
            values.push(obj.compositeID[keys[i]]);
        }
        return values.join(".");
    },

    addObject: function (obj) {
        if (!obj || !obj.compositeID) {
            return;
        }
        // get id
        obj.id = this.getObjectID(obj);
        // set type
        obj.type = "datasource";
        obj.selected = false;
        // add
        this.attachObj.push(obj);
        this.drawAttachmentPanel();
    },

    getAttachment: function (id) {
        var i;
        for (i = 0; i < this.attachObj.length; i++) {
            if (this.attachObj[i].id === id) {
                return this.attachObj[i];
            }
        }
        return null;
    },

    removeAttachment: function (id) {
        var i;
        for (i = this.attachObj.length - 1; i >= 0; --i) {
            if (this.attachObj[i].id === id) {
                var obj = this.attachObj[i];
                this.attachObj.splice(i, 1);
                tmp_attachmentDialog.removeFiles([id]);
                // remove inline image when cid is available
                if ("cid" in obj && obj.cid !== null) {
                    // prepare id
                    var cid = obj.cid.replace(/^<|>$/g, "");
                    if (editorEnabled) {
                        var dom = tinyMCE.activeEditor.dom.select("body");
                        // find any reference and remove them
                        jQuery(dom[0]).find("img").each(function () {
                            if (this.id === cid) {
                                jQuery(this).remove();
                            };
                        });
                    }
                }
                obj = null;
            }
        }
        this.drawAttachmentPanel();
    },

    attachmentExists: function (id) {
        return (this.getAttachment(id) !== null ? true : false);
    },

    drawAttachmentPanel: function (forceResize) {

        var mda = $("newMailAttachmentDiv");
        removeChildNodes(mda);

        var fnSelect = function (id, oMailFunctionsNew) {
            return function (e) {
                cancelDefault(e);
                oMailFunctionsNew.selectAttachment(id);
            };
        };

        var i, attach, label, imgSrc;
        for (i = 0; i < this.attachObj.length; i++) {
            attach = this.attachObj[i];
            label = "";
            imgSrc = "";
            // get label of attachment
            switch (attach.type) {
            case "file":
                label = attach.filename;
                imgSrc = getFullImgSrc("img/mail/" + (this.attachObj[i].content_type && this.attachObj[i].content_type.match(/^message\/rfc822/gi) ? "unread.gif" : "attachment.gif"));
                break;
            case "datasource":
                switch (attach.objectType) {
                case "vCard":
                    label = attach.name + " (vCard)";
                    imgSrc = getFullImgSrc("img/infostore/mimetypes/vcard.gif");
                    break;
                case "default":
                    label = attach.name;
                    imgSrc = getFullImgSrc("/img/mail/attachment.gif");
                    break;
                }
                break;
            }
            var oDOMDiv = newnode("div", 0, { id: this.attachObj[i].id, className: "mailDetailAttachmentsCont" + (this.attachObj[i].selected ? "Sel background-color-PMG-selection-elements" : "") },
                [ newnode("img", 0,
                    { src: imgSrc, align: "absmiddle", padding: "3px"}),
                      newnode("span", 0, {className: "_nothing"},
                          [ document.createTextNode(this.attachObj[i].size ?
                            //#. Displayed label for attachments
                            //#. %1$s is the file name.
                            //#. %2$s is the file size.
                            //#, c-format
                            format(_(" %1$s (%2$s); "), label,
                                     bytesToString(this.attachObj[i].size)) :
                            //#. Displayed label for attachments without file size
                            //#. %1$s is the file name.
                            //#, c-format
                            format(_(" %1$s; "), label))]
                          )
                    ]
                );

            addDOMEvent(oDOMDiv, "mousedown", fnSelect(this.attachObj[i].id, oMailFunctionsNew));

            addDOMEvent(oDOMDiv, "dblclick", (function (obj) {
                return function(e) {
                    stopEvent(e);
                    if (obj) {
                        if (obj.disp === 'attachment') {
                            corewindow.openAttachment("OPEN", { folder: url.folder, id: url.id }, [{ data: obj }] );
                        } else {
                            globalalert.header = _("Note");
                            globalalert.buttons = 514;
                            globalalert.text = _("To view attachment you must first save your e-mail as a draft.");
                            globalalert.cbsave = function() {
                                triggerEvent("OX_Save_Template_Object");
                            };
                            AlertPopup.open();
                        }
                    }
                };
            }(this.attachObj[i])));

            addDOMEvent(oDOMDiv, "contextmenu", (function (obj) {
                return function(e) {
                    stopEvent(e);
                    globalContextMenus.simpleAttachments.display(e.clientX, e.clientY, obj);
                };
            }(this.attachObj[i])));

            mda.appendChild(oDOMDiv);
        }

        var os = 0;
        if (this.attachObj.length > 0) {
            os = Math.round(pxPerEm * 3.2);
        }

        // only resize if really changed
        if (forceResize === true || jQuery(mda).height() !== os) {
            resizeSplit(mda.id, os + "px");
        }
    },

    /*
     * @private
     *
     */
    selectAttachment: function (id) {
        var i;
        for (i = 0; i < this.attachObj.length; i++) {
            this.attachObj[i].selected = false;
            if (this.attachObj[i].id === id) {
                this.attachObj[i].selected = true;
                triggerEvent("SubSelected", [this.attachObj[i]]);
            }
            document.getElementById(this.attachObj[i].id).className =
                "mailDetailAttachmentsCont" + (this.attachObj[i].selected ? "Sel background-color-PMG-selection-elements" : "");
        }
    },

    showAdditionalHeaderField: function (field, selected) {
    	if (field === "replyto" && ox.api.config.get("ui.mail.replyTo.configurable", false) === false) {
    		// looks like replyto is disabled, so we have to take care about it :)
    		selected = false;
    		// do we have to set it in options as well?
    		if (options[field]) {
    			options[field] = false;
    		}
    	}

    	// take care that checkbox of the toolbar item is in sync
    	if (ox.widgets) {
        	var node = ox.widgets.toolBar.menuItems["mail_new-" + field];
            if (node && node.stateChecked !== selected) {
                node.setChecked(selected);
                node.validate();
            }
            delete(node);
    	}

        // to, cc, bcc, options
        if (!$ALL(field + "_row") || $ALL(field + "_row").style.display === (selected ? "" : "none")) {
            return;
        }
        $ALL(field + "_row").style.display = selected ? "" : "none";
        this.drawAttachmentPanel(true);
    }
};

oMailFunctionsNew = new MailFunctions();

callback_new_cb = null;

callback_new = function (cb) {

    oMailFunctionsNew.savePending = false;

    if (cb) {
        if (cb.data && !cb.error) {
            // use custom callback?
            if (callback_new_cb) {
                setModalBusy(false);
                callback_new_cb(cb.data);
            } else {
                // default callback
                switch (action) {
                case "reply":
                case "replyall":
                    corewindow.updateMailFlagsInternal(url.folder, url.id, { flag: 1, bool: true });
                    break;
                case "forward":
                    corewindow.updateMailFlagsInternal(url.folder, url.id, { flag: 256, bool: true });
                    break;
                case "draft":
                    corewindow.updateDraftsFolderCache(url.id, cb.data, activeMailAccount.id);
                    break;
                }
                oMailFunctionsNew.cleanUp();
                window.setTimeout(function () {
                    // vars
                    var core = corewindow,
                        inbox = ox.api.config.get("mail.folder.inbox"),
                        sent = ox.api.config.get("mail.folder.sent");
                    // update sent folder
                    core.ox.api.folder.getMultiple({
                        list: [inbox, sent],
                        cache: false,
                        success: function () {
                            // update tree
                            try {
                                ox.api.folder.dispatcher.trigger("modify");
                            } catch (e) {
                                // psst - strange IE...
                            }
                            core.triggerEvent("OX_New_Unread_Mail");
                            // trigger update - refrehes mail views (see bug #18104)
                            core.OXCache.update();
                             // close window
                            ctrl.close(true);
                        }
                    });
                }, 500); // wait a bit so that mails can arrive in INBOX/Sent
                            // items
            }
        } else {
            // check for special errors
            if (cb.code === "MSG-0084") {
                // attachment has been published, let the user knows about it :)
                newAlert(
                    _("Info"),
                    _(cb.error),
                    function () {
                        // sending was fine, so remove the error
                        // and let the callback re-do the rest
                        setModalBusy(true);
                        delete cb.error;
                        callback_new(cb);
                    }
                );
            } else {
                newServerError(cb);
                setModalBusy();
            }
        }
    } else {
        triggerEvent("OX_New_Error", 4, _("The server didn't respond!"));
    }
};

initAddressBook = function () {
    // initialized?
    if (!myListAddressBook) {
        var myFields = ["to", "cc", "bcc"];
        // initialize
        myListAddressBook = new SearchListAddressBook(
            null,
            "addressbookNewEmail",
            "newmailSearchResult",
            null,
            "newmail_add_list",
            "newmail_search",
            closeAddressbookNewEmail
        );
        myListAddressBook.setAllFolders(
            $("newmail-search-all-folders"),
            $("but_folder")
        );
    }
    
    myListAddressBook.makeGrid();
    
    myListAddressBook.clearList = function() {
        jQuery("select[id^=newmail_add_list_]").empty();
    };
    
    // join
    cb_initAddressBook();
};

/* search EmailAddresses */
searchEmailAddress = function (recipientField) {
    myListAddressBook.recipientType = recipientField;
    myListAddressBook.openDiv();
    myListAddressBook.getResult();
};

newmailContact = function () {
    var searchString = $('newmail_search').value;
    myListAddressBook.searchstring = searchString;
    myListAddressBook.getResult();
};

closeAddressbookNewEmail = function (ok) {
    if (ok) {
        // fill address fields
        for (var suffix in { to: 1, cc: 1, bcc: 1}) {
            var addresses = jQuery("#" + myListAddressBook.divAddContact + "_" + suffix)
            .children()
            .map(function() {
                return this.value;
            }).get().join(", ");
            if (addresses.length !== 0) {
                var value = jQuery("#" + suffix).attr("value");
                if (value.length !== 0) {
                    addresses = value + (value.match(/;|,[\s]?$/) ? "" : ", ") + addresses;
                }
                jQuery("#" + suffix).attr("value", addresses + ", ");
                value = null;
            }
            addresses = null;
        }
    }
    // clear lists
    myListAddressBook.clearList();
    
    // set focus
    var _ftj = myListAddressBook.tmpIdsForSave &&
        myListAddressBook.tmpIdsForSave.length !== 0 ? "subject" : myListAddressBook.recipientType;
    setTimeout(function () {
        if (document.getElementById(_ftj) && document.getElementById(_ftj).focus()) {
            document.getElementById(_ftj).focus();
        }
        _ftj = null;
    }, 0);
};

function addnewmailToList(field) {
    if (myListAddressBook) {
        myListAddressBook.addToList(field);
    }
}

getURL = function () {
    var URL = window.location.pathname;
    URL = URL.substring(0, URL.lastIndexOf("/") + 1);
    return URL;
};

/**
 * File browser for adding images as Inline Content. Will be added to the Image
 * selection dialog.
 *
 * @param field_name
 * @param url
 * @param type
 * @param win
 */
function cb_mailFileBrowser(field_name, url, type, win) {
    if (!win || !win.document) {
        return false;
    }

    var URL = getURL();

    var doc = win.document;
    if (doc.getElementById("oxmainBG")) {
        doc.getElementById("oxmainBG").parentNode.removeChild(doc.getElementById("oxmainBG"));
    }
    if (doc.getElementById("oxmain")) {
        doc.getElementById("oxmain").parentNode.removeChild(doc.getElementById("oxmain"));
    }

    // build div for file browser
    var nd1, nd2, nd3, nd4, nd5, pURL;
    nd1 = newnode("div", { zIndex: 2, width: "100%", height: "100%", top: 0, left: 0, position: "fixed", background: "#FFFFFF none repeat scroll 0 0", opacity: 0.6 }, { id: "oxmainBG" }, null, doc);
    pURL = AjaxRoot + "/file?action=new&module=mail&type=image&session=" + corewindow.session;
    nd2 = newnode("div", { position: "absolute", zIndex: 3, top: 0, left: 0, width: "100%", height: "100%" }, { id: "oxmain" }, null, doc);

    // uploading an image when adding a link doesn't make sense.
    // Unfortunately there's no way to prevent the upload button so
    // have to show a feature not available dialog.
    if (field_name === "href") {
        nd3 = newnode("div", { width: "90%", position: "absolute", zIndex: "99", top: "85px", left: "12px", padding: "5px", textAlign: "center", border: "1px solid gray", backgroundColor: "white", id: "oxmainContent" }, null, null, doc);
        nd4 = newnode("input", { marginTop: "5px" }, { type: "button", name: _("OK"), value: _("OK") }, null, doc);
        addDOMEvent(nd4, "click", function () {
            jQuery(nd1).remove();
            jQuery(nd2).remove();
        }, win);
        nd3.appendChild(addTranslated(_("Feature not available!")));
        nd3.appendChild(newnode("br"));
        nd3.appendChild(nd4);
        nd2.appendChild(nd3);
    } else {
        // processing with the OX specific upload dialog
        var nd_form;
        if (IE < 9) {
            nd_form = doc.createElement('<form action="' + pURL + '" method="POST" enctype="multipart/form-data" target="hiddenNMFrame" name="mailUploadImage" id="mailUploadImage">');
        } else {
            nd_form = newnode("form", null, { enctype: "multipart/form-data", method: "post", action: pURL, acceptCharset: "UTF-8", target: "hiddenNMFrame", id: "mailUploadImage", name: "mailUploadImage" }, null, doc);
        }

        nd3 = newnode("div", { width: "90%", position: "absolute", zIndex: "99", top: "85px", left: "12px", padding: "5px", textAlign: "right", border: "1px solid gray", backgroundColor: "white", id: "oxmainContent" }, null, null, doc);
        nd3.appendChild(newnode("div", { width: "90%", textAlign: "left" }, null, [doc.createTextNode(_("Select a File:"))], doc));
        nd3.appendChild(newnode("input", { border: "solid 1px gray", width: "100%" }, { type: "file", size: "30", name: "file", id: "file" }, null, doc));

        nd4 = newnode("input", { marginTop: "5px" }, { type: "button", name: _("OK"), value: _("OK") }, null, doc);
        addDOMEvent(nd4, "click", function () { win.sendOXFile(); }, win);
        nd3.appendChild(nd4);

        nd5 = newnode("input", { margin: "5px 0px 0px 5px" }, { type: "button", name: _("Cancel"), value: _("Cancel") }, null, doc);
        addDOMEvent(nd5, "click", function () { win.disableOXBG(); }, win);
        nd3.appendChild(nd5);

        nd_form.appendChild(nd3);
        nd2.appendChild(nd_form);
    }
    doc.body.appendChild(nd1);
    doc.body.appendChild(nd2);

    doc.body.appendChild(newnode("script", null, { language: "javascript", type: "text/javascript", src: URL + "mailFileBrowser.js" }, null, doc));
    doc.body.appendChild(newnode("iframe", { display: "none" }, { scrolling: "no", frameBorder: "0", src: URL + "newInfoItemHidden.html", name: "hiddenNMFrame", id: "hiddenNMFrame"}, null, doc));

    /* *** Ugly workaround for IE Only *** */
    if (win.frames.hiddenNMFrame.name !== "hiddenNMFrame") {
        win.frames.hiddenNMFrame.name = "hiddenNMFrame";
    }

    var ielem = win.document.getElementById("insert");
    if (ielem) {
        ielem.onmousedown = function () {
            if (win.oxFile) {
                addImg2Poll(win.oxFile);
            }
        };
    }

    return false;
}

addImg2Poll = function (id) {
    var timeout = configGetKey("maxUploadIdleTimeout") ? configGetKey("maxUploadIdleTimeout") : 200000;
    timeout = Math.round(timeout * 0.9);
    var iv = window.setInterval(function () {
        (new JSONX()).get(AjaxRoot + "/file?action=keepalive&session=" + corewindow.session + "&id=" + id,
            null, function (cb) { }, function (cb) { return true; });
    }, timeout);
    intervals.push(iv);
    timeout = iv = null;
};

/*
 * Initialize TinyMCE
 */

/**
 * callback when tinyMCE get initialized
 */
function cb_initTiny() {
    /*
     * setting tabindex on the editor iframe content
     */
    if ($ALL(tinyMCE.activeEditor.id + "_ifr")) {
        $ALL(tinyMCE.activeEditor.id + "_ifr").setAttribute("tabIndex", "5");
    }
    /*
     * hide the editor toolbar if it has been disabled
     */
    if (!options.toolbar) {
        var tdContent = $ALL("editor_content_tbl").getElementsByTagName("td");
        tdContent[0].style.display = "none";
        tdContent[1].className = "tiny_mceFirst";
    }
    
    loadTinyMCE.def.resolve();
}

/*
 * initialize tinyMCE editor
 */

var tinyMCELanguage = "en"; // fallback
var tinyMCEInit = function () {

    // default tiny settings
    var tinySettings = {
        mode: "none",
        theme: "advanced",
        language: tinyMCELanguage,
        plugins: "inlinepopups,table,paste,lists"
            + (Boolean(ox.api.config.get("modules.mail.spellcheck")) ? ",spellchecker" : ""),
        content_css: getURL() + "newmail.css",
        theme_advanced_toolbar_location: "top",
        theme_advanced_toolbar_align: "left",
        theme_advanced_statusbar_location: "none",
        theme_advanced_resize_horizontal: false,
        extended_valid_elements:
            "a[name|href|target|title|onclick]," +
            "img[id|class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name]," +
            "hr[class|width|size|noshade]," +
            "span[class|align|style]," +
            "blockquote[type|style],style[type]",
        forced_root_block: 'div',
        formats: {
            blockquote: {
                block: "blockquote",
                wrapper: 1,
                remove: "all",
                attributes: { type: "cite" },
                styles: {
                    "margin-left": "0px",
                    "padding-left": "10px",
                    // The border style is split because each style must match
                    // exactly with the style extracted from DOM nodes and
                    // browsers may change the order in a shorthand style.
                    "border-left-style": "solid",
                    "border-left-width": "1px",
                    "border-left-color": "blue"
                }
            }
        },
        gecko_spellcheck: true,
        button_tile_map: true,
        entity_encoding: "numeric", // lately changed from "raw" to "numeric"
        relative_urls: false,
        convert_urls: false,
        init_instance_callback : "cb_initTiny",
        file_browser_callback : "cb_mailFileBrowser",
        font_size_style_values : "8pt,10pt,12pt,14pt,18pt,24pt,36pt",
        width: "100%",
        height: "100%",
        setup: function (ed) {
            // key: enter
            ed.onKeyDown.add(function (ed, e) {
                // wrote something
                setBeforeUnload(true);
                // pressed enter?
                if ((e.keyCode || e.which) === 13) splitContent(ed, e);
            });
            // click into editor to take care about context menus
            ed.onClick.add(function(ed, e) {
                if (globalContextMenus && globalContextMenus.simpleAttachments) {
                    globalContextMenus.simpleAttachments.hide();
                }
            });
        }
    };
    // start with empty controls
    tinySettings.theme_advanced_buttons3 = "";
    tinySettings.theme_advanced_buttons2 = "";
    tinySettings.theme_advanced_buttons1 = "";
    // set controls depending on the choosen feature set
    switch (String(configGetKey("gui.mail.editor_featureset"))) {
        case "2":
            // default
            tinySettings.theme_advanced_buttons3 = "tablecontrols,|,sub,sup,|,print|,ltr,rtl";
            tinySettings.plugins += ",directionality";
        case "1":
            // enhanced
            tinySettings.theme_advanced_buttons2 =
                (ox.browser.WebKit || ox.browser.Gecko ? '' : 'cut,copy,paste,pastetext,') +
                "pasteword,|,bullist,numlist,|,outdent,indent,|,undo,redo,|,image,link,unlink,|,hr,|,charmap,|,blockquote" +
                (Boolean(ox.api.config.get("modules.mail.spellcheck")) ? ",|,spellchecker" : "");
        case "3":
            // minimized
            tinySettings.theme_advanced_buttons1 = "newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,formatselect,fontselect,fontsizeselect,|,forecolor,backcolor";
            break;
    }
    // init tiny
    tinyMCE.init(tinySettings);
    tinyMCE.execCommand("mceAddControl", true, "editor_content");
};

function loadTinyMCE() {
    if (loadTinyMCE.def) {
        tinyMCE.execCommand("mceAddControl", true, "editor_content");
        return loadTinyMCE.def.promise();
    }
    loadTinyMCE.def = jQuery.Deferred();
    if (corewindow && configGetKey("language")) {
        var tmp = configGetKey("language").toLowerCase().split("_");
        // using two letter iso lang code only is evil :(
        if (configGetKey("language") == "zh_CN") {
            tinyMCELanguage = tmp[0] + "-" + tmp[1];
        } else {
            tinyMCELanguage = tmp[0];
        }
    }
    
    if (/^(de|en|fr)$/.test(tinyMCELanguage) === false) {
        // check that language pack exists
        jQuery.ajax({
            url: urlify("3rdparty/tinymce/jscripts/tiny_mce/langs/" +
                        tinyMCELanguage + ".js"),
            success: function () {
                tinyMCEInit();
            },
            error: function () {
                tinyMCELanguage = "en";
                tinyMCEInit();
            }
        });
    } else {
        tinyMCEInit();
    }
    return loadTinyMCE.def.promise();
}
/*
 * Register events
 */

register("Loaded", newMailOnload);
register("OX_Cancel_Object", askToClose);
register("setSignature", setSignatureText);

// The attachment remove callback
register("OX_Object_Attachment_Delete", function () {
    // loop over selection
    var i = 0, list = oMailFunctionsNew.attachObj, removed = false;
    while (i < list.length) {
        if (list[i].selected) {
            oMailFunctionsNew.removeAttachment(list[i].id);
            removed = true;
        } else {
            i++;
        }
    }
    if (removed) {
        triggerEvent("SubSelected", []);
    }
});

register("OX_SAVE_OBJECT", function () {
    oMailFunctionsNew.sendMessage();
});

register("OX_Save_Template_Object", function (callback, silent) {
    action = "draft";
    oMailFunctionsNew.saveMessageAsDraft(callback, silent);
});

register("OX_New_Mail_Toggle_Additional_Header", function (id) {
    // toggle state
    options[id] = !options[id];
    // update config
    configSetKey("gui.mail.newmail_options", options);
    // apply
    oMailFunctionsNew.showAdditionalHeaderField(id, options[id]);
});

function showEditorToolbar(state) {
    // apply flag
    jQuery("#editor_content_tbl").find("td").eq(0)
        .css("display", state ? "" : "none");
    // resize
    var id = "newMailAttachmentDiv";
    resizeSplit(id, jQuery("#" + id).height() + "px");
}

register("OX_New_Mail_Toggle_Toolbar", function () {
    // toggle state
    options.toolbar = !options.toolbar;
    ox.api.config.set("gui.mail.newmail_options.toolbar", options.toolbar);
    showEditorToolbar(options.toolbar);
});

register("OX_New_Mail_Set_Format", setMessageFormat);

function setMessageFormat(format) {
    messageFormat = format;
    var content, toHTML = format.toUpperCase() !== "TEXT/PLAIN";
    if (toHTML != editorEnabled) content = oMailFunctionsNew.getEditorContent();
    if (toHTML) {
        jQuery('#editor_content').off('change', onChange);
        return loadTinyMCE().pipe(function() {
            if (!editorEnabled) return convertContent(content);
        }).done(function() {
            showEditorToolbar(options.toolbar);
            ox.widgets.toolBar.menuItems["mail_new-editorToolbar"].show();
        });
    } else {
        return jQuery.when().pipe(function() {
            if (editorEnabled) {
                tinyMCE.execCommand('mceRemoveControl', true,
                                    'editor_content');
                return convertContent(content);
            }
        }).done(function() {
            ox.widgets.toolBar.menuItems["mail_new-editorToolbar"].hide();
            jQuery('#editor_content').on('change', onChange);
        });
    }
}

function convertContent(content) {
    setModalBusy(true);
    editorEnabled = !editorEnabled;
    var boundary = uuid();
    return jQuery.ajax({
        type: "POST",
        url: AjaxRoot + "/mail?action=new&session=" + session,
        contentType: "multipart/form-data; boundary=" + boundary,
        data: '--' + boundary +
              '\r\nContent-Disposition: form-data; name="json_0"\r\n\r\n' +
              JSONX.serialize({
                  sendtype: 4,
                  flags: 4,
                  from: configGetKey("modules.mail.defaultaddress"),
                  attachments: [{
                      content_type: editorEnabled ? "text/plain" : "text/html",
                      content: content
                  }]
              }) + '\r\n--' + boundary + '--'
    }).pipe(function(response) {
        var data = Function("return " + response.match(/\((\{.*\})\)/)[1])();
        if (data.error) {
            triggerEvent("OX_New_Error", 4, formatError(data));
            return jQuery.Deferred().reject(data).promise();
        }
        var index = data.data.lastIndexOf('/');
        var def = jQuery.Deferred();
        ox.api.http.GET({
            module: "mail",
            params: {
                action: "get",
                folder: data.data.slice(0, index),
                id: data.data.slice(index + 1),
                edit: 1,
                view: editorEnabled ? "html" : "text"
            },
            success: function(data) { def.resolve(data); }
        });
        return def.promise();
    }).done(function(mail) {
        ox.api.http.PUT({
            module: "mail",
            params: { action: "delete", harddelete: 1 },
            data: [{ folder: mail.folder_id, id: mail.id }]
        });
        var a = action;
        action="draft";
        setMessageText(mail.attachments);
        action = a;
        setModalBusy(false);
    });
}

/*
 * init window controller
 */
ctrl = windowController = new WindowController();

ctrl.set("beforeunload", function () {
    if (ums && !isIE()) {
        // ask
        return String(_("Do you really want to discard your changes and close the window?"));
    }
});

ctrl.set("confirm", askToClose);
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Matthias Biggeleben <matthias.biggeleben@open-xchange.com>
 * 
 */

/*jslint bitwise: false, nomen: false, onevar: false, plusplus: false, regexp: false, white: true, browser: true, devel: true, evil: true, forin: true, undef: true, eqeqeq: true, immed: true */

/*global ox, jQuery, window, console */

ox.mail = {};

/**
 * Draw contact image based on email address
 */
ox.mail.drawContactImage = (function ($) {
    
    var current = "";
    
    return function (from) {
        // lower case!
        from = current = (from || "").toLowerCase();
        // getting currentpath
        var path = currentpath[1];
        // have to do some ugly mappings for the popup window
        if (path === "detail") {
            path = "detail\\.pop";
        }
        
        // get div and hide it
        var div = $("#mail-" + path + "-image").hide();
        if (div.length) {
            // searching on OXCache is too buggy, so...
            ox.api.contact.searchByMail({
                data: [from],
                success: function (data) {
                    var map, url = null, i, key, contact;
                    // still of interest?
                    if (from === current) {
                        // iterating through response and check for image
                        map = data.map[from] || [];
                        for (i in map) {
                            key = map[i];
                            contact = data.contacts[key];
                            if (contact && contact.image1_url) {
                                url = contact.image1_url + "&width=90&height=90&scaleType=contain";
                                if (url && contact.folder_id === 6) {
                                    // global address-book always first
                                    break;
                                }
                            }
                        }
                        // found an url?
                        if (url) {
                            url += "&width=90&height=90&scaleType=contain";
                            // same url, no redraw required
                            if ($("img", div).attr("src") != url) {
                                // get proper protocol/hostname
                                url = url.replace(/https?:\/\/[^\/]+\//, location.protocol + "//" + location.host + "/");
                                // update
                                div.css({
                                    width: "100px",
                                    height: "80px",
                                    overflow: "hidden",
                                    margin: "0px 5px 0px 10px"
                                });
                                div.empty();
                                div.append(
                                    $("<img/>", {
                                        src: url,
                                        alt: ""
                                    }).css({
                                        width: "auto",
                                        height: "auto",
                                        "float": "right"
                                    })
                                );
                            }
                            div.show();
                            // adjust height
                            var height = $("#mail\\." + path + "\\.detail\\.attachments").height();
                            resizeSplit("mail." + path.replace("\\", "") + ".detail.attachments", height + "px");
                        }
                    }
                }
            });
        }
    };
    
}(jQuery));

defineDeferredFunction(ox.mail, "addAccount", "com.openexchange.mail.accounts");
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Andreas Mayer <andreas.mayer@open-xchange.com>
 * 
 */

var ExecAfterUpload =  function (){};
var ExecErrorAfterUpload = null;

function attachmentDialog(sDialogNum, fkt_On_OK) {
    this.template_id = 'attachPopupTemplate';
    this.popup = $('attachPopupTemplate');
    this.popup.id = this.template_id + '_' + this.dialog_num;
    this.dialog_num = sDialogNum;
    this.att_server_rem = [];    
    this.callOnOK = fkt_On_OK;
    this.form_name = 'attFile_' + this.dialog_num;
    this.form =  document.attFile;
    this.form.name = this.form_name;
    
    //this.sel_files_area = $("selectedFilesArea");
    this.files_area_id = "selectedFilesArea" + '_' + this.dialog_num;
    //this.sel_files_area.id = this.files_area_id;
    this.live_grid_container = $("sel_files_area");
    this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];});
    this.file_input_count = 0; 
    this.attachmentsChanged = false;
    
    var Self = this;
    register("OX_Attachment_Dialog_Cancel", function(){Self.closePopup();});
    addOnClose (this.popup,function(){
          triggerEvent("OX_Attachment_Dialog_Cancel");
        });
    register("OX_Object_Add_Attachment", function(){Self.openPopup();});
    register("OX_Attachments_Add_File", function(){Self.addFile();});
    register("OX_Attachments_Remove_File", function(){Self.removeFile();});
    register("OX_Attachment_Dialog_OK", function(){Self.commitPopup();});
    
    this.all_input_fields = [];
    this.file_name_list = [];
    this.temp_list = [];
    
    this.last_input = null;
    
    this.curr_file_input_id;
    
    this.open = false;    
}

attachmentDialog.prototype = {
    attach_changed: function () {
        return (this.att_server_rem.length > 0 || this.file_input_count > 0 || this.attachmentsChanged);
    },
    do_post: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload) {
        if(this.att_server_rem.length > 0) {
            var aAttIds = [];

            for (var indx2=0;indx2<this.att_server_rem.length;indx2++) {
                aAttIds.push(this.att_server_rem[indx2].attid);
            }

            var sAction = AjaxRoot + "/attachment?action=detach" + "&session="+session + "&attached=" 
                        + this.att_server_rem[0].item_id + "&module=" 
                                + this.att_server_rem[0].module + "&folder=" + (this.att_server_rem[0].folder || this.att_server_rem[0].folder_id);                                                 
            this.att_server_rem = [];    
            var attJson = new JSONX();
            var Self = this;
            function cb_deleted(arg) {
                if (arg && arg.error) {
                    alert(arg.error);
                } else {
                    Self.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
                }                
            }
            attJson.put(sAction,aAttIds,null,cb_deleted);
        } else {
            this.post_new(obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload);
        }
        return;
    },
    post_new: function (obj,fn_exec_afterupload,sActionParam,sTargetParam,fn_error_exec_afterupload) {
        ExecAfterUpload = fn_exec_afterupload;
        ExecErrorAfterUpload = fn_error_exec_afterupload;
        if(sActionParam) {
            this.form.action = sActionParam;
        } else {
            this.form.action = AjaxRoot + "/attachment?action=attach&session=" + session;
        }
        if (sTargetParam) {
            this.form.target = sTargetParam;
        }
        var  sObj = JSONX.serialize(obj);
        if (this.file_input_count === 0) {
            var oNodeJson;
            if (this.form["json_0"] === undefined) {
                var oNodeJson;
                if (this.form["json_0"] === undefined) {
                    var id = this.createFileInput();
                    this.file_input_count++;
                    jQuery("#" + id).parent().remove();
                }
            }
            if (sObj) {
                this.form["json_0"].value = sObj;
            }
        }        
        else {
            for (var nCount=0;nCount<this.file_input_count;nCount++) {
                if(this.form['json_'+nCount]) {
                    this.form['json_'+nCount].value = sObj;
                }
            }
        }
        this.attachmentsChanged = true;
        this.form.submit();
    },
    createFileInput: function () {
        var sId = 'file_' + (this.file_input_count);
        var oNode = newnode('input',0,{
                                        type:"file",
                                        size:"40",
                                        name:sId,
                                        id:sId,
                                        className:"inputElementAttachment"
                                        });
        var oNodeJson = newnode('input',0,{
                                        type:"hidden",
                                        name:'json_'+(this.file_input_count),
                                        id:'json_'+(this.file_input_count)
                                        });
        if (IE) {
            // prevent entering file path manually
            jQuery(oNode).keypress(function(event){
                event.preventDefault();
            });
        }
        // auto-add file on change
        var self = this;
        jQuery(oNode).bind("change", function (e) {
            self.addFile();
        });
        this.last_input = oNode;
        var outerDiv1 = newnode("div");
        var outerDiv2 = newnode("div");        
        outerDiv1.appendChild(oNode);
        outerDiv2.appendChild(oNodeJson);
        this.form.appendChild(outerDiv1);
        this.form.appendChild(outerDiv2);
        this.all_input_fields.push(oNode);
        this.all_input_fields.push(oNodeJson);        
        return sId;
    },
    openPopup: function () {
        if(!this.open) {
            this.curr_file_input_id = this.createFileInput();
        }
        this.open = true;
        this.temp_list = [];
        if ($("modal-dialog")) {
            ox.api.setModal(true);
//            showNode("modal-dialog");
//            $("modal-dialog").style.display = "block";
        }
        centerPopupWindow(this.popup);
        this.popup.style.display = 'block';        
        //create
        if(this.live_grid === null || this.live_grid === undefined) {
            this.live_grid = new LiveGrid([ 
                {
                    text:" ",                
                    index: 1,    
                    style: {overflowX:"auto"},
                    set: function(div, text) {
                        text = text || "\u00a0";
                        if (div.firstChild) {
                            div.firstChild.data = text;
                        } else {
                            div.appendChild(document.createTextNode(text));
                        }
                    },                    
                    clear: LiveGrid.makeClear("")
                }
            ],new Selection());            
    
            this.live_grid.emptylivegridtext ="";
            this.live_grid.getHeader();        
            this.live_grid.getTable(this.live_grid_container);
            this.live_grid_container.style.overflowX = "auto";
            //this.live_grid_container.firstChild.style.width = "";            
            //this.live_grid_container.firstChild.style.overflowX = "auto";            
        } else {
            this.live_grid.enable(this.file_storage = new Storage(0, [], "", 0, 0,  null, function(x){ return x[0];}));
        }

    },
    closePopup: function () {
        //this.form.reset();
        //var oNode;
        //empty lg
        //removeChildren(this.sel_files_area);        
        /*
        while(oNode = this.all_input_fields.pop())
        {
            if(oNode)
            {
                this.form.removeChild(oNode);
            }
        }*/
        this.popup.style.display = 'none';
        if ($("modal-dialog")) {
            ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
        /*
        this.file_input_count = 0;    
        */
        this.open = false;
        var aToDel = [];
        for (var indxTd in this.temp_list) {
            aToDel.push(this.temp_list[indxTd].id);
        }
        this.removeFiles(aToDel);
        this.temp_list = [];        
        this.live_grid.disable();
        if (this.last_input !== null) {
            this.form.removeChild(this.last_input.parentNode);
        }
        this.last_input = null;
        this.file_input_count++;
    },    
    commitPopup: function () {
        this.popup.style.display = 'none';
        if ($("modal-dialog")) {
            ox.api.setModal(false);
//            hideNode("modal-dialog");
//            $("modal-dialog").style.display = "none";
        }
        this.file_name_list = this.file_name_list.concat(this.temp_list);
        this.callOnOK(this.file_name_list);    
        this.live_grid.disable();
    },
    showAttachedFiles: function () {
        return this.file_name_list;
    },
    addFile: function () {    
        //ie7 bugfix
        //var currFileInput = this.form.elements[this.curr_file_input_id];
        
        var currFileInput = document.getElementById(this.curr_file_input_id);
        
        if(currFileInput.value.length === 0) {
            return;
        }
        var fileName = separateFilenameFromPath(currFileInput.value);        
        var file = {id:fileName+'_'+this.file_input_count,filename:fileName};
        this.temp_list.push(file);
        
        //add file to lg
        var aFileObjects =  [[file.id,fileName]];
        this.file_storage.append(aFileObjects);
        this.live_grid.enable(this.file_storage);
        
        //update styles here (IE BUG FIX horizontal scroll bar)
        this.live_grid.rowTemplate.style.tableLayout = "auto";
        
        //this.sel_files_area.appendChild(newnode("option", 0,
        //    {value: file.id}, [document.createTextNode(fileName)]));

        currFileInput.style.display = "none";
        
        this.file_input_count++;
        this.curr_file_input_id = this.createFileInput();            
    },
    removeFile: function() {    
        //var files = this.sel_files_area.childNodes;
//        var len = files.length;
//        var selected = [];
//        for (var i = 0; i < len; i++)
//            if (files[i].selected) selected.push(files[i].value);
        var aSelItems = this.live_grid.selection.getSelected();
        if(aSelItems.length > 0) {
            this.removeFiles(aSelItems);
        }
//        removSelected;
    },
    getLocalPath:function (sId) {
            sFileName = sId.split('_')[0]; 
            for(var nField=0;nField<this.all_input_fields.length;nField++) {
                if((this.all_input_fields[nField].name == 'file_' + sId.split('_')[1])) {
                    return this.all_input_fields[nField];
                }
            }
    },
    removeFiles:function (aFiles) {
        function removeFileNameFromString(sStr,sFileName) {
            sFileName += '; ';
            var sReturnStr = sStr.replace(sFileName,'');
            return sReturnStr;
        }
        var Self = this;
        function removeFileNameFromList(sId) {
            for (var indx in Self.file_name_list) {
                if (Self.file_name_list[indx].id == sId) {
                    Self.file_name_list.splice(indx,1);
                    break;
                }
            }
            for (var indx in Self.temp_list) {
                if (Self.temp_list[indx].id == sId) {
                    Self.temp_list.splice(indx,1);
                    break;
                }
            }
        }
        //aFiles
        //get files from lg
        //var options = this.sel_files_area.childNodes;
        if( this.live_grid && this.live_grid.storage !== undefined) {
            this.live_grid.deleteIDs(aFiles);
        }
        for (var nIndex=0;nIndex<aFiles.length;nIndex++) {
            var filename = aFiles[nIndex];
            removeFileNameFromList(filename);
            for(var nField = this.all_input_fields.length - 1; nField >= 0; --nField) {
                if(((this.all_input_fields[nField].name == 'file_' + expandIDS(filename))
                            || (this.all_input_fields[nField].name == 'json_' + expandIDS(filename))) 
                                            && this.all_input_fields[nField].name != 'json_0')
                {
                    this.form.removeChild(this.all_input_fields[nField].parentNode);
                    this.all_input_fields.splice(nField, 1);
                }
            }
        }
    }
};

function expandIDS(sFileWithId) {
    var aTempArray = sFileWithId.split('_');
    return aTempArray[(aTempArray.length-1)];
}

/*
 * remove is possible in new/edit window only
 * */
function attachmentGrid(sContainerId,nId,nFolder,sModule,oDialog) {
    this.container = $(sContainerId);
    this.containerHeader = $(sContainerId + "Header");
    this.module  = sModule;
    this.nItemId = nId;
    this.folder = nFolder;    
    this.liveGrid = null;
    this.viewGrid();
    this.attachmentStorage;// = new Storage(0, []);
    this.bDetailAttachmentsLoaded = false;
    
    this.selection_dialog = (oDialog)?oDialog:false;
    
    this.timestamp = 0;
    
    this.addData = [];
    this.selectedRtfFlag = false;
    this.selectedId = null;
    this.selectedFilename = null;    
    
    this.numberOfAttachments = 0;
    
    Self = this;
    this.openAttachedFile = function () {
                if(Self.selectedRtfFlag) {
                    return;
                }
                var sURL = 
                AjaxRoot + "/attachment/" + encodeURIComponent(Self.selectedFilename) 
                    + "?action=document&session="
                    + session + "&attached=" + Self.nItemId  + "&module=" + Self.module + "&folder="
                    + activefolder + "&id=" + Self.selectedId;
                newWindow(sURL, getWindowOptions(null, null, "scrollbars=yes"));
    };
    this.saveAttachedFile = function () {

                if(Self.selectedRtfFlag) {
                    return;
                }
                var sContentType = 'application%2Foctet-stream';    
                var sURL = 
                AjaxRoot + "/attachment/" + encodeURIComponent(Self.selectedFilename) 
                    + "?action=document&session="
                    + session + "&attached=" + Self.nItemId  + "&module=" + Self.module + "&folder="
                    + activefolder + "&id=" + Self.selectedId + '&content_type=' +sContentType;
                if (IE6) {
                    newWindow(sURL, getWindowOptions());
                } else {
                    var frame = $ALL("dlIframe") ? getFrameElement('dlIframe') : parent.frames['dlIframe'];
                    frame.location.href = sURL;
                }
    };
    this.saveAttachInInfoStore = function () {
        if (Self.selectedRtfFlag) {
            return;
        }
        if (activemodule === "mail") {
            return;
        }
        var nNumModule = -1;
        switch (activemodule) {
            case "calendar":     nNumModule = 1;
                                break;
            case "tasks":     nNumModule = 4;
                                break;
            case "contacts":     nNumModule = 7;
                                break;
        }
        
        // use new api
        ox.api.infostore.compose({
            params: {
                attachmodule: nNumModule,
                filename: Self.selectedFilename,
                attid: Self.selectedId,
                attobjid: Self.nItemId,
                attobjfolder: Self.folder || Self.folder_id,
                folder: configGetKey("folder.infostore")
            },
            id: [ Self.selectedId, Self.nItemId, (Self.folder || Self.folder_id)]
        });
    };
    
    var Self = this;
    this.remAttachedFile  = function () {
        if(Self.selectedRtfFlag) return;        
        function cbyes() {
            Self.remove(Self.liveGrid.selection.getSelected(), function() {
                Self.updateGrid(Self.selection_dialog.file_name_list);
            });                                        
        }
        newConfirm(_("Delete Attachment"),_('Are you sure you want to delete the selected attachment?'),AlertPopup.YESNO,null,null,cbyes,null);
                                        
    };
                                        
    register("OX_Attachment_Open", this.openAttachedFile);        
    register("OX_Attachment_Save", this.saveAttachedFile);        
    register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);    
    
    if(this.selection_dialog) {
        register("OX_Object_Attachment_Delete", this.remAttachedFile);
    }
}

attachmentGrid.prototype = {
updateGrid: function (data) {    
    var aNewData = [];
    for(var indx in data) {
        var bFound = false;
        for(var indx2=0;indx2<this.addData.length;indx2++) {    
            if (data[indx].id == this.addData[indx2].id) {
                bFound = true;
                break;
            }
        }
        if(!bFound) {
            aNewData.push(data[indx]);
        }
    }    
    for(var indx2=0;indx2<this.addData.length;indx2++) {
        var bFound = false;
        for (var indx in data) {
            if (data[indx].id == this.addData[indx2].id) {
                bFound = true;
                break;                
            }
        }
        if(!bFound) {
            //IE7 bugfix
            //this.attachmentStorage.remove(this.attachmentStorage.ids.indexOf(this.addData[indx2].id));
            var indexToDelete = -1;
            var aIds = this.attachmentStorage.ids;
            for (var i = 0; i < aIds.length; i++) {
                if (aIds[i] == this.addData[indx2].id) {
                    this.liveGrid.deleteIDs([this.addData[indx2].id]);
                    indexToDelete = i; 
                }
            }
//            if(indexToDelete != -1)
//                this.attachmentStorage.remove(indexToDelete);
            this.addData.splice(indx2,1);
        }
    }
    this.addData = this.addData.concat(aNewData);
    var aNewObj =  [];
    for (var i in aNewData) {
        sFileName = aNewData[i].filename;
        aNewObj.push(new Array(aNewData[i].id,sFileName,'','',''));
        this.numberOfAttachments++;
        triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    }
    if(aNewObj.length == 0) {
        triggerEvent("SubSelected", 0);
    } else {
        this.attachmentStorage.append(aNewObj);
    }
    this.enableGrid();

},
remove: function (ids, callback) {
    var local = [], remote = [];
    for (var i = 0; i < ids.length; i++) {
        var id = ids[i];
        if (typeof id === "string" && id.indexOf("_") >= 0) {
            local.push(id);
        } else {
            remote.push(id);
            this.selection_dialog.att_server_rem.push({
                attid: id, item_id: this.nItemId, module: this.module,
                folder: this.folder || this.folder_id
            });
        }    
    }
    if (local.length) {
        this.selection_dialog.removeFiles(local);
    }
    if (remote.length) {
        this.attachmentStorage.removeIDs(remote);
    }
    this.numberOfAttachments -= ids.length;        
    triggerEvent("OX_Attachments_Changed_InGrid",this.numberOfAttachments);
    if (callback) {
        callback();
    }
},
enableGrid: function () {
    this.liveGrid.enable(this.attachmentStorage);        
    register("OX_Attachment_Open", this.openAttachedFile);        
    register("OX_Attachment_Save", this.saveAttachedFile);    
    register("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);        
},
disableGrid: function () {
        this.liveGrid.disable();
        unregister("OX_Attachment_Open", this.openAttachedFile);        
        unregister("OX_Attachment_Save", this.saveAttachedFile);
        unregister("OX_Attachment_SaveInfoStore", this.saveAttachInInfoStore);
},
getAttachments: function (nId,nFolder,fn_update_opt) {
    var  Self = this;    
    this.attachmentStorage = new Storage(0, []);
    if (this.nItemId === false) {
        return;
    }
    function cb_attachments(arg) {
        var aData = [];
        Self.numberOfAttachments = 0;
        //check rtf_flags here
        for (var indx in arg.data) {
            aData.push(arg.data[indx]);
            Self.numberOfAttachments++;        
        }
        
        triggerEvent("OX_Attachments_Changed_InGrid",Self.numberOfAttachments);
        Self.attachmentStorage.append(aData);
        Self.attachmentStorage.timestamp = arg.timestamp;
        Self.liveGrid.enable(Self.attachmentStorage);
        Self.bDetailAttachmentsLoaded = true; 
        if(fn_update_opt)
            fn_update_opt();            
    }
    if(nId != 0 && nId !== undefined &&  nFolder != 0 && nFolder !== undefined) {
        this.nItemId = nId;
        this.folder = nFolder;        
    }        
    this.doAjaxFetchAllAttachments(cb_attachments);
},
viewGrid: function () {
        var Self = this;
        var clear = LiveGrid.makeClear("...");
        function setAttachmentsTest1 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode(text[1]));        
        }
        function setAttachmentsTest2 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode(text[2]));        
        }    
        function setAttachmentsTest3 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            div.appendChild(document.createTextNode( text[3] && text[3].length != 0 ? bytesToString(text[3]) : "") );        
        }            
        function setAttachmentsTest4 (div, text){
            removeChildNodes(div);
            if (text[5]) {
                div.style.fontStyle = "italic";
            } else {
                div.style.fontStyle = "";
            }
            if (text[4].length==0) {
                div.appendChild(document.createTextNode(""));
            } else {
                div.appendChild(document.createTextNode(formatDate(text[4], "date")));
            }
        }                                
        this.liveGrid = new LiveGrid([ 
            {
                text: "File name", /*i18n*/
                i18n: true,
                sortable: true,
                set: setAttachmentsTest1,
                clear: clear
            }, {
                text: "Mime type", /*i18n*/
                i18n: true,                
                sortable: true,
                width: "20%",
                set: setAttachmentsTest2,
                clear: clear
            }, {
                text: "Size", /*i18n*/
                i18n: true,                
                sortable: true,
                width: "15%",
                set: setAttachmentsTest3,
                clear: clear
            }, {
                text: "Last modified", /*i18n*/
                i18n: true,                    
                sortable: true,
                width: "15%",
                set: setAttachmentsTest4,
                clear: clear
            }
        ], new Selection());
        this.liveGrid.emptylivegridtext="No Attachments available";/*i18n*/
        this.containerHeader.appendChild(this.liveGrid.getHeader());
        this.liveGrid.getTable(this.container);
                
        this.liveGrid.events.register("Activated", function(ids){
            if (!ids || ids == 0) {
                return;
            }
            (menucheckRight("WRITE")) ? triggerEvent("OX_Object_Delete_Attachment") :
                triggerEvent("OX_New_Error", 4, _("You're not allowed to delete this attachment!"));
        });
    
        var aIds = Self.liveGrid.selection.getSelected();
        var Self = this;        
        function fn_triggerSubSel(ids){
            triggerEvent("SelectedAttachment",ids);
            ox.ToolBarController.processSelection("attachments", false,
                Self.liveGrid.selection.getSelected(), true);
            if (ids == 1) {                
                var aIDS = Self.liveGrid.getSelectedIDs();
                Self.selectedId = aIDS[0];
                Self.selectedFilename = Self.liveGrid.storage.data.get(Self.selectedId)[1];        
                Self.selectedRtfFlag = !(Self.liveGrid.storage.data.get(Self.selectedId)[5] == false);
                if(Self.liveGrid.storage.data.get(Self.selectedId)[5] === undefined) {
                    Self.selectedRtfFlag = false;
                }
                triggerEvent("SubSelected", ids,Self.selectedRtfFlag);                
            }          

        }
        this.liveGrid.events.register("Selected", fn_triggerSubSel);
},
doAjaxFetchAllAttachments:function (cb)
{
    json.get(AjaxRoot + "/attachment?action=all&session=" + session + "&folder=" +
            (this.folder || this.folder_id) + "&attached=" + this.nItemId + "&module="+this.module+"&" + 
            "columns=1%2C803%2C805%2C804%2C4%2C806&sort=803&order=asc", null,cb);        
}
}

function callback_attach(cb) {
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if (!cb.error) {
        ExecAfterUpload();    
    }
    else {
        //triggerEvent("OX_New_Error", 4, cb.toString());
    }
}

function callback_document(cb) {
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if (cb.error) {
        newServerError(cb);
    }
}
function callback_error(arg)
{
    if(typeof savePending != "undefined" && savePending) {
        savePending = false;
    }
    if(ExecErrorAfterUpload && typeof ExecErrorAfterUpload != "undefined") {
        ExecErrorAfterUpload(arg);
    } else {
        newServerError(arg);
    }
}
fileloaded();


/* 
 * +++++++++++++++++
 * Infostore Attachment Load 
 * +++++++++++++++++
 */

function infostoreDialog(number, callback) {
	var Self = this;
    this.popup = $('attachInfostorePopupTemplate');
    this.open = false;
    this.attachLiveGrid;
    this.gridSelectedElements = new Selection2();
    this.gridSelectedElements.oldToggle = this.gridSelectedElements.toggle;
    // overwrite toggle to prevent selection of non files
    this.gridSelectedElements.toggle = function(index) {
        var data = Self.attachLiveGrid.collection.objects;
        if (data && data[index] && !data[index].filename) {
            return false;
        } else {
            this.oldToggle(index);
        }
    }
    
    this.gridAddedElements = $("selectedFilesInfostore");
    this.miniGrid;
    this.file_storage;
    this.callback = callback || jQuery.noop;
    
    register("OX_AttachInfostore_Dialog_Cancel", function(){Self.closePopup();});
    addOnClose (this.popup,function(){
          triggerEvent("OX_AttachInfostore_Dialog_Cancel");
        });
    register("OX_Object_Add_Attachment_Infostore", function(){Self.openPopup();});
    register("OX_AttachInfostore_OK", function(){ Self.commitPopup(); });
}

infostoreDialog.prototype = {
	commitPopup: function () {
		var Self = this, attachments = [];
    	// get selected files from the top grid 
    	if (this.gridSelectedElements.count > 0){
    		jQuery(this.gridSelectedElements.getSelected()).each(function(index) {
    			var file = jQuery(this)[0];
    			// pre-fill object for callback
    			attachments.push({ id: file.id, filename: file.title, size: null, 
    			        content_type: file.file_mimetype || null, msgref: null, 
    			        selected: false, infostore: true });
    		});
    	}
        // trigger callback with infostore objects
        Self.callback(attachments);
    	Self.closePopup();
	},
    openPopup: function () {
    	this.loadFolderTree();
    	
    	// get the grid header and body div from the template
    	var gridHeader = $("attachInfostorGridHeader");
    	var gridContent = $("attachInfostorGridContent");
    	
    	// clear a old grid if available
    	if (this.attachLiveGrid) {
    		removeChildNodes(gridContent);
    		removeChildNodes(gridHeader);
    		this.attachLiveGrid = null;
    	}
    	
    	//fix some css
    	jQuery("#folder_tree_attachment #select-folder-popup-infostore").removeClass("oxStretch");
    	jQuery("#folder_tree_attachment #select-folder-popup-infostore").css("overflow", "visible");
    	
    	// create the grid
    	this.attachLiveGrid = new LiveGrid2([
            {
  				name : ["title"],
                i18n: "description", /*i18n context*/
  				text: "Title", /*i18n*/
  				sortable: true,
  				sort : "title",
  				set: LiveGrid.defaultSet,
  				clear: LiveGrid.makeClear("")
  			}, {
  				name : ["file_size", "file_mimetype", "filename"],
  				text: "Size", /*i18n*/
  				i18n: true,
  				sortable: true,
  				width: "20%",
  				sort : "file_size",
  				set: function (div, object) {
                    // mark non-files as greyed-out
                    jQuery(div).parent().css("color", object.filename ? "" : "silver");
                    // calculate size
  					var sDisplayString = object.file_size ? bytesToString(object.file_size) : "-";
  					if (div.firstChild) {
  						div.firstChild.data = sDisplayString;
  					} else {
  						div.appendChild(document.createTextNode(sDisplayString));
  					}
  				},
  				clear: LiveGrid.makeClear("")
  			}, {
  				name : ["created_by"],
  				text: "Created by", /*i18n*/
  				i18n: true,
  				sortable: true,
  				sort : "created_by",
  				width: "25%",			
  				set: function  (div, text) {
  					var nId = parseInt(text);											
  					function cb_fetchUserFromCache(){
  						return function (arg) {
  							if (div.firstChild) {
  								div.firstChild.data = arg[nId].display_name;
  							} else {
  								div.appendChild(document.createTextNode(arg[nId].display_name));
  							}
  						}
  					}
  					internalCache.getUsers([nId],cb_fetchUserFromCache());		
  				},
  				clear: LiveGrid.makeClear("")
  			}
  		], this.gridSelectedElements);
    	this.attachLiveGrid.module="infostore";

    	// add grid to header and body divs
    	gridHeader.appendChild(this.attachLiveGrid.getHeader());
    	this.attachLiveGrid.getTable(gridContent);
    	    	
    	// start the popup
	    if ($("modal-dialog")) {
	        ox.api.setModal(true);
	    }
		this.open = true;
		
		// center popup
    	centerPopupWindow(this.popup);
    	this.popup.style.display = 'block';
    	
    },
    closePopup: function () {
    	// disable the big grid
    	this.attachLiveGrid.disable();
        
    	// clode popup
    	this.open = false;
    	this.popup.style.display = 'none'; 
        if ($("modal-dialog")) {
            ox.api.setModal(false);
        }
    },
    loadFolderTree: function() {
    	var Self = this;
    	
    	// load the folder and draw the grid
    	function loadFolderContent(data) {
        	var criteria= { "folder_id" : data.id };
        	Self.attachLiveGrid.disablehover=true;
        	Self.attachLiveGrid.enable(criteria,false);
        }
    	
    	// the left side folder tree
    	ox.api.ui.selectFolder({
        	type: "infostore",
        	destroy: false,
        	id: "select-folder-popup-infostore",
        	root: "9",
        	open: ["9", "10", ox.api.config.get("folder.infostore")],
        	callback: loadFolderContent,
        	node: $('folder_tree_attachment'),
        	minPerms: 1 << 7 // read own objects
        });
    }
}
/**
 * 
 * All content on this website (including text, images, source
 * code and any other original works), unless otherwise noted,
 * is licensed under a Creative Commons License.
 * 
 * http://creativecommons.org/licenses/by-nc-sa/2.5/
 * 
 * Copyright (C) Open-Xchange Inc., 2006-2012
 * Mail: info@open-xchange.com 
 * 
 * @author Stefan Preuss <stefan.preuss@open-xchange.com>
 * @author Suphi Basdemir <suphi.basdemir@open-xchange.com>
 * 
 */

/**
 * Search for Contacts in different Addressbooks
 * makes a liveGrid for Searchresult, an append the selected to a LiveGrid or
 * in a Input field
 * @param {String} searchstring for pattern in the database
 * @param {String} Id of the main search dialog div
 * @param {String} Id of the div for the Livegrid, in the search dialog
 * @param {String} optional: for appending the Contacts in a LiveGrid of the page (deprecated: no longer in use!)
 * @param {String} Id from div, for the selected Contacts in the search dialog
 * @param {String} Id from div, for clearing the search string in the search dialog
 * @param {Array} optional: if suffix of each Inputfield (example: 'to' and 'cc' for newmail_btn_add_to, newmail_btn_add_cc)
 * 
 * the DOM Event as parameter.
 */

function SearchListAddressBook(searchstring, floatingpopupdiv, liveGridDivSearch, liveGridDivResult, divAddContact, searchField, onClose) {
	var Self = this;
	this.emptySearchText = _("Please enter your search");
	this.searchField = searchField;
	this.blurTimer;
	addressbookFolderPath();
	this.divAddContact = divAddContact;
	this.liveGridDivSearch = liveGridDivSearch;
	this.floatingpopupdiv = floatingpopupdiv;
	this.searchstring = searchstring;
	this.internalStorage = new Storage(0, []);
	this.recipientType = "to";	
	$(this.searchField).value = this.emptySearchText;
	this.onClose = onClose;
	addOnClose($(this.floatingpopupdiv), this.closeDiv);
	
    Self.clickOnCombobox = function (e) {
    	if (Self.blurTimer != undefined) {
            clearTimeout(Self.blurTimer);
            delete(Self.blurTimer);
        }
        if ($(searchField).value == Self.emptySearchText) {
            $(searchField).value="";
            $(Self.searchField).style.color="";
        } else if (e.keyCode == 13) {
            Self.searchstring = $(searchField).value;
            Self.getResult();
        }
    };
    
    Self.enterInput = function(e) {
    	Self.blurTimer = setTimeout(function() {
	        if (trimStr($(searchField).value).length == 0) {
	            $(searchField).value=Self.emptySearchText;
	            $(Self.searchField).style.color="silver";
	        }
        }, 100);
    }; 
    
    addDOMEvent($(this.searchField), "keypress", Self.clickOnCombobox);
    addDOMEvent($(this.searchField), "click", Self.clickOnCombobox);
    addDOMEvent($(this.searchField), "blur", Self.enterInput); 
	
    this.searchContacts = function() {
        Self.getResult();
    };
	register("searchContacts", this.searchContacts);
}

SearchListAddressBook.prototype = {

    setAllFolders: function(checkbox, folder_button) {
        if (configGetKey("modules.contacts.singleFolderSearch")) return;
        var setDisabled = classNameSetter("font-color-disabled");
        checkbox.parentNode.parentNode.parentNode.style.display = "";
        checkbox.checked = true;
        setDisabled(folder_button, true);
        checkbox.onclick = function() {
            setDisabled(folder_button, checkbox.checked);
        };
        this.allFoldersCheckbox = checkbox;
    },

	displayError: function(msg) {
        $(this.floatingpopupdiv+"SearchError").style.display = "";
        $(this.floatingpopupdiv+"SearchError").getElementsByTagName("DIV")[0].firstChild.data = msg;
    },
    
	getResult: function() {
		var Self = this;
        this.searchstring = "";
        var inVal = $(this.searchField).value;
        if (trimStr(inVal).length == 0 ||
            inVal == this.emptySearchText) {
            $(this.searchField).value=this.emptySearchText;
            setTimeout(function() {
                $(Self.searchField).style.color="silver";
            },0);
            if (configContainsKey("modules.contacts.mailAddressAutoSearch") &&
                configGetKey("modules.contacts.mailAddressAutoSearch") == false) {
            	this.searchstring = "";
                return;	
            } else if (configContainsKey("minimumSearchCharacters") &&
                configGetKey("minimumSearchCharacters") != 0) {
                this.displayError(
                   //#. %s is the number of characters.
                   //#, c-format
                   format(_("The search pattern requires at least %s characters."), 
                       configGetKey("minimumSearchCharacters")));
                return;
            } else {
            	this.searchstring="";
            }
        } else if (configContainsKey("minimumSearchCharacters") &&
            trimStr(inVal).length < configGetKey("minimumSearchCharacters")) {
            this.displayError(
                //#. %s is the number of characters.
                //#, c-format
                format(_("The search pattern requires at least %s characters."), 
                    configGetKey("minimumSearchCharacters")));
            return;
        } else {
    	   $(Self.searchField).style.color="";
    	   this.searchstring=inVal;
        }
		var pattern = trimStr(this.searchstring) ? this.searchstring : "*";
        var searchObject = {
            display_name: pattern, first_name: pattern, last_name: pattern,
            email1: pattern, email2: pattern, email3: pattern, operator: "or"
        };
        if (configGetKey("language") == "ja_JP") {
            searchObject.yomiFirstName = pattern;
            searchObject.yomiLastName = pattern;
        }
        var criteria = { };
        var lang = ox.api.config.get("language").substring(0, 3);
        if (lang === "zh_") {
            criteria.collation = "gbk";
        }
        
        if (!this.allFoldersCheckbox || !this.allFoldersCheckbox.checked) { 
            criteria.folder_id = clickedItem;
        }
        
        var collection = {
            criteria: criteria,
            search: searchObject,
            columns: [ "id", "folder_id", "display_name", "first_name", "last_name",
                       "email1", "email2", "email3", "distribution_list" ]
        };
        
        var sort = lang == "zh_" || lang == "ja_" ? "last_name" : "sort";
        collection.order = [{ sort: sort, order: "asc" }];
        
        function callback(data) {
            Self.internalStorage = new Storage(0, [], 0, 0, 0, 0, 
                    function(addr) { return addr.folder_id + "." + addr.id + "." + addr.pos; });
            
            if (data && data.objects.length) {
                for (var i = 0; i < data.objects.length; i++) {
                    var obj = data.objects[i];
                    // temp object 
                    var store = { id: obj.id, folder_id: obj.folder_id, pos: 0 };
                    
                    // display name
                    store.display_name = null;
                    if (obj.display_name !== null) {
                        // set the valid display name
                        store.display_name = obj.display_name;
                        
                    } else if (obj.last_name !== null || obj.first_name !== null) {
                        // try to build something based on last and first name
                        store.display_name = (obj.last_name || "") 
                            + ", " + (obj.first_name || "");
                    }
                    
                    if (obj.distribution_list !== null) {
                        // ignore empty lists
                        if (obj.distribution_list.length === 0) {
                            continue;
                        }
                        // store distribution list
                        store.distribution_list = obj.distribution_list;
                        store.mail = null;
                        if (store.display_name === null) {
                            store.display_name = "";
                        }
                        Self.internalStorage.append([ store ]);
                    } else {
                        for (var a in { email1: 1, email2: 1, email3: 1 }) {
                            if (obj[a] !== null && trimStr(obj[a]).length !== 0) {
                                var tmpStore = clone(store);
                                tmpStore.pos = a;
                                tmpStore.mail = obj[a];
                                if (tmpStore.display_name === null) {
                                    tmpStore.display_name = obj[a];
                                }
                                Self.internalStorage.append([ tmpStore ]);
                                tmpStore = null;
                            }
                        }
                    }
                    obj = store = null;
                }
            }
            // enable grid
            distruGrid.selection = new Selection();
            distruGrid.enable(Self.internalStorage);
            gridData = null;
        }
        
        OXCache.newRequest(null, "contacts", collection, jQuery.noop, callback, false);
        
        // clean-up
        collection = sort = criteria = searchObject = lang = pattern = inVal = null;
	},
	
	addToList: function(fieldSuffix) {
	    var Self = this, selCont = distruGrid.selection.getSelected();
	    distruGrid.storage.newIterate(selCont, emptyFunction, function(id, obj) {
	        var tmpObj = clone(obj);
	        if (!tmpObj.distribution_list) {
	            tmpObj = { distribution_list: [ tmpObj ] };
	        }
	        for (var i = 0; i < tmpObj.distribution_list.length; i++) {
	            var tmp = tmpObj.distribution_list[i];
    	        var address = "";
    	        if (!tmp.display_name) {
    	            address = tmp.mail;
    	        } else {
    	            address = quotePersonalAddr(tmp.display_name || "") + " <" + tmp.mail + ">";
    	        }
    	        jQuery("#" + Self.divAddContact + '_' + fieldSuffix).prepend(
                    jQuery("<option>", { value: address }).text(address)
    	        );
    	        address = tmp = null;
	        }
	        tmpObj = null;
	    }, function() {
	        Self = selCont = null;
	    });
	},
	
	resetView: function() {
		if (distruGrid && distruGrid.storage) {
		    distruGrid.selection = new Selection();
			distruGrid.storage.remove(0, distruGrid.storage.ids.length);
		}
	},
	
	resetGrid: function() {
        if (distruGrid && distruGrid.storage) {
        	distruGrid.disable();
        	distruGrid.selection = new Selection();
            this.internalStorage = new Storage(0, []);
            this.makeGrid();
        }
	},
	
	makeGrid: function() {
		var list = $(this.liveGridDivSearch);
		var listHeader = $(this.liveGridDivSearch + "Header");
		if (distruGrid) {
			removeChildNodes(listHeader);
			list.innerHTML = "";
			distruGrid = null;
		}
		
		distruGrid = new LiveGrid([
			{   
				text: "&#xa0;",
				sortable: false,
				width: "26px",
				set: function(div, object) {
				    var src = getFullImgSrc("img/folder/contacts.gif");
				    if (object.distribution_list) {
				        src = getFullImgSrc("img/menu/distributionlist.gif");
				    }
                    if (!div.firstChild) {
                        div.appendChild(newnode("img", {
                            height : "16px",
                            width: "16px"
                        }, {
                            src: getFullImgSrc("img/mail/noattachment.gif"),
                            align: "absmiddle"
                        }));
                    }
                    div.firstChild.src = src;
				},
				clear: function(div) {
				    if (!div.firstChild) {
                        div.appendChild(newnode("img", {
                            height : "16px",
                            width : "16px"
                        }, {
                            src: getFullImgSrc("img/mail/noattachment.gif"),
                            align: "absmiddle"
                        }));
                    } else {
                        div.firstChild.src = getFullImgSrc("img/mail/noattachment.gif");
                    }
				}
			} , {
				text: _("Name"),
				width: "42%",
				set: function(div, object) {
				    if (!div.firstChild) {
                        div.appendChild(div.ownerDocument.createTextNode(object.display_name));
                    } else {
                        div.firstChild.data = object.display_name;
                    }
				},
				clear: function(div) {
				    if (div.firstChild) {
				        div.firstChild.data = "";
				    }
				}
			} , {
    			text: _("E-Mail"),
    			set: function(div, object) {
    			    if (!div.firstChild) {
                        div.appendChild(div.ownerDocument.createTextNode(object.mail || ""));
                    } else {
                        div.firstChild.data = object.mail || "";
                    }
    			},
    			clear: function(div) {
                    if (div.firstChild) {
                        div.firstChild.data = "";
                    }
                }
			}
		], new Selection());
		listHeader.appendChild(distruGrid.getHeader());
		distruGrid.getTable(list);
		
		var Self = this;
		distruGrid.events.register("Activated", 
			function(ids){
		        Self.addToList(Self.recipientType);
			}
		);
	},
	
	openDiv: function() {
	    addressbookFolderPath();
	    centerPopupWindow($(this.floatingpopupdiv));
	    $(this.floatingpopupdiv).style.display = 'block';
	    if (this.onClose) {
	        this.onClose();
	    }
	    this.resetView();
	},
	
	closeDiv: function() {
		this.disableActiveGrids();
		$(this.floatingpopupdiv).style.display = 'none';
	},
	
	disableActiveGrids : function() {
	    if (this.internalStorage) {
	        this.internalStorage.remove(0, this.internalStorage.ids.length);
	    }
	    if (distruGrid) {
	        if (distruGrid.storage) {
	            distruGrid.storage.remove(0, distruGrid.storage.ids.length);
	        }
	        distruGrid.disable();
        }

	},
	
	destroy: function() {
	    this.disableActiveGrids();
	    removeDOMEvent($(this.searchField), "keypress", this.clickOnCombobox);
	    addDOMEvent($(this.searchField), "click", this.clickOnCombobox);
	    addDOMEvent($(this.searchField), "blur", this.enterInput);
	    unregister("searchContacts", this.searchContacts);
	    
	    this.emptySearchText = this.searchField = searchField = this.blurTimer =
	    this.divAddContact = this.liveGridDivSearch = this.floatingpopupdiv = floatingpopupdiv =
	    this.searchstring = searchstring = this.internalStorage = this.recipientType =
	    this.emptySearchText = this.clickOnCombobox = this.enterInput = 
        distruGrid = this.allFoldersCheckbox = Self = contactAddressbookTreeLoaded = 
        treeAddressbookVisible = clickedItem = currentDivIdForAddressbook = 
        addressbookFolderPath = cb_AddressbookGetpath = folderAction = hideAddressbookTree = 
        toggleAddressbookTree = null;
	}
};

var contactAddressbookTreeLoaded = false;
var treeAddressbookVisible = false;
var clickedItem = "";
var currentDivIdForAddressbook = "";

function addressbookFolderPath() {
    ox.api.folder.exists({
        folder: "6",
        success: function (GAL) {
            clickedItem = GAL ? 6 : corewindow.configGetKey("folder.contacts");
            session = corewindow.session;
            var folderViewSettingsNewContact = new Object();
            var folderViewSettingsNewContactById = new Object();
            //Disable Email... 
            folderViewSettingsNewContactById["default"] = 4;
            folderViewSettingsNewContact["contacts"] = 8;
            folderViewSettingsNewContact["calendar"] = 4;
            folderViewSettingsNewContact["tasks"] = 4;
            folderViewSettingsNewContact["infostore"] = 4;
            if (!contactAddressbookTreeLoaded) {
                ox.api.ui.selectFolder({
                    type: "contacts",
                    id: "select-folder-popup-contacts",
                    callback: folderAction,
                    node: $('folderAddressbook_tree_info'),
                    minPerms: 1 << 7, // read own objects
                    destroy: false
                });
                contactAddressbookTreeLoaded = true;
            }
            ox.api.folder.get({ folder: clickedItem, success: cb_AddressbookGetpath});
        }
    });
}

function cb_AddressbookGetpath(data) {
    var vb = document.getElementsByName('newcontact_folder')[0].value = data.title;
}

function folderAction(data) {
    hideAddressbookTree(currentDivIdForAddressbook);
    clickedItem = data.id;
    ox.api.folder.get({ folder: clickedItem, success: cb_AddressbookGetpath });
    triggerEvent("searchContacts");
}

function hideAddressbookTree(divId) {
    $(divId).style.display = "none";
    treeAddressbookVisible = false;
}

function toggleAddressbookTree(divId) {
    currentDivIdForAddressbook = divId;
    if (!treeAddressbookVisible) {
        $(divId).style.display = "block";
        treeAddressbookVisible = true;
    } else {
        $(divId).style.display = "none";
        treeAddressbookVisible = false;
    }
}
